#!/bin/sh
set -x
PATH=$PATH:$FK_TOOLS_ROOT'GSPN2'
export PATH


if [ "$1" = "-extended" ] ; then 
    # Le chemin vers GSPN, version ESRG
    # i686blabla = archi 
    #GSPN=/home/baarir/ESRG/i686_R2.4.21-0.13mdk/WNESRG
    GSPN=$FK_TOOLS_ROOT'GSPN2'/WNESRG
    export GSPN
    # le generateur qui fabrique du cami (formalisme RG)
    # a partir de la sortie de gspn
    GSPN2GMS=$FK_TOOLS_ROOT'GSPN2'/gspn2gms
    export GSPN2GMS
    DO_EXPORT="0"
elif [ "$1" = "" ] ; then
    # Le chemin vers GSPN, version symbolique
    # i686blabla = archi 
    #GSPN=/data/thierry/gspn/greatspn/i686_R2.4.21-0.13mdk/WNSRG
    GSPN=$FK_TOOLS_ROOT'GSPN2'/WNSRG
    export GSPN
    # le generateur qui fabrique du cami (formalisme RG)
    # a partir de la sortie de gspn
    GSPN2GMS=$FK_TOOLS_ROOT'GSPN2'/gspn2gms
    export GSPN2GMS
    DO_EXPORT="1"
fi

# L'exe qui extrait les sous-classes et genere model.def model.net
# c'est gere avec un generic/specific make pour l'archi
# partition = snow_FK !
CAMI2GSPN=$FK_TOOLS_ROOT/COLOR_PARTITION/snow_FK
export CAMI2GSPN
if [ ! -d FK_MNGR/nets ] ; then
    mkdir -p FK_MNGR/nets
    fk_send_state_message 'Generating description for GreatSPN 2.0'
    $CAMI2GSPN -s -d ./FK_MNGR/nets/
fi
cd FK_MNGR/nets
fk_send_state_message 'Generating reachability Graph'
echo 'WN('`fk_make_macao_string 'This tool relies on GreatSPN 2.0 by G.Chiola (Univ. Genova)'`')'
$GSPN model -o > gspn_outt 2> gspn_err
set `wc -l gspn_outt`
if [ $1 -ne 0 ] ; then
	cat gspn_outt | sed -e 's/\*/\#/g' > gspn_out
	fk_send_file_content gspn_out
else
	echo "WARNING --- WARNING --- WARNING --- WARNING --- WARNING --- WARNING" > gspn_out
	echo "gspn_outt apparently crashed without providing any information" >> gspn_out
	fk_set_end_status Error
	fk_send_file_content gspn_out
	exit
fi
shift $#
set `wc -c gspn_err`
if [ $1 -ne 0 ] ; then
         fk_send_msg -error "problem with GreatSPN!!!"
         fk_set_end_status Error
         fk_send_file_content gspn_err
fi
# rm gspn_err gspn_out xxx
fk_send_state_message 'Converting into Macao format'
x=`ls model.srg*`

if [ $DO_EXPORT = "1" ] ; then
    sed 's/ORDINARY INSTANCES.*$//g' $x >$x.tmp
    $GSPN2GMS -s $x.tmp > tmp
fi
# rm $x tmp
