#!/bin/sh
set -x

####################################################################
# Initialisations diverses
####################################################################
cd FK_MNGR/nets
cdir=`pwd`
DO_PRETTY="NON"
####################################################################
# traitement des parametres (pour definir le type de graphe et
# pour savoir si on calcule un placement)
####################################################################
if [ "$1" = "-symbolic" ] ; then
	shift
	FILE="model.gms"
	TEXT="Symbolic Reachability Graph"
else
	FILE="model.gma"
	TEXT="Reachability Graph"
fi
if [ "$1" = "-pretty" ] ; then
	DO_PRETTY="OUI"
fi
####################################################################
# le traitement de l'envoi en lui-meme
####################################################################
if [ -f $FILE ] ; then
	echo 'DB()' > tmp_res
	grep -v 'DB()' $FILE | grep -v 'FB()' >> tmp_res
	if [ "$DO_PRETTY" = "OUI" ] ; then
		# placement demande!
	    if [ ! -f poso_$FILE ] ; then
			# on doit effectuer le calcul...
			fk_send_state_message "Computing layouts $TEXT"
			# preparation des donnees pour arrange_objets
			mkdir TMP_DIR
			cp $FILE TMP_DIR/.model
			echo ReachabilityGraph > TMP_DIR/.formalism
			cp ../../fk_basic_info .
			# l'invocation d'arrange_object en elle-meme
			shift $#
			set `grep 'CA(' $FILE | wc -l`
			PATH=$PATH:$FK_TOOLS_ROOT/GRAPHIC_DISPLAY
			export PATH
			fk_send_state_message "reachability graph contains $1 arcs"
			if [ $1 -gt 150 ]; then
				fk_send_msg "Warning: no routing of the $1 arcs will be provided (might be too long)"
				"$FK_TOOLS_ROOT/GRAPHIC_DISPLAY/arrange_objects" -s -dg -no_arc -modl_in_dir TMP_DIR 2> ar_stderr > tmp
				mv TMP_DIR/cami_pos_cmd poso_$FILE
			else
				"$FK_TOOLS_ROOT/GRAPHIC_DISPLAY/arrange_objects" -s -dg -modl_in_dir TMP_DIR 2> ar_stderr > tmp
				mv cami_pos_cmd poso_$FILE
				mv cami_ifp_cmd arcrr_$FILE
			fi
			#rm -rf TMP
			fk_send_file_content tmp
		else
			fk_send_state_message "Layouts already computed for $TEXT"
		fi
		# Ici, les fichiers de placement des objets doivent TOUJOURS exister
		cat poso_$FILE >> tmp_res
		if [ -f arcrr_$FILE ] ; then
			cat arcrr_$FILE >> tmp_res
		fi
	fi
	echo 'FB()' >> tmp_res
	fk_send_state_message "Downloading $TEXT"
	echo "SEND_CAMI_FILE("`fk_make_macao_string $cdir/tmp_res`",1)"
else
	fk_send_msg -error "Somethink wrong MUST have happened with GreatSPn files:-("
	fk_send_msg -error "I cannot find file $FILE"
fi
#if [ "$DO_PRETTY" = "OUI" ] ; then
