#!/usr/bin/perl


use Getopt::Std;

getopt ('mfo');

my $usage="This script filters transiitons from a cami file. \n (c) 2006 Yann Thierry-Mieg, Laboratoire d'Informatique de Paris 6 \n Usage:\n filterCamiTobs.pl -m [input_model = xxx.cami] -f [filter = comma separated AP list. No filter arg => filter all PROP_] -o [output file]\n";
my $model = $opt_m or  die $usage;
my $filter = $opt_f or "";
my $outff = $opt_o or die $usage;
use strict 'vars';


# check existence of everybody
if (! -f $model) {
  die "ERROR : model file $model not found, please check existence and permissions. \n $usage";
}


open(OUT,"> $outff") or die "Couldn't create output file $outff";
open(IN,"< $model");

my @aplist = split(/,/,$filter);
my %apdict;
for (@aplist) { $apdict{$_} = 1 ;}
#print %apdict;

my %tokillnodes;

#one pass to fill tokillnodes
while (my $line = <IN>) {
  if ( $line =~ /^CT\(/ ) {
    if ( $line =~ /PROP\_(.*)\)/) {
      if (! exists $apdict{$1} ) {	
	# a transition to kill
	$line =~ /^CT\(4:name,(\d+),/;
	my $nodenum = $1;
	$tokillnodes{$1} = 1;
      }
    }
  } elsif ($line =~ /^CA\(.*,(\d+),(\d+),(\d+)\)$/) {
    if (exists $tokillnodes{$2} or exists $tokillnodes{$3}) {
      $tokillnodes{$1} = 1;
    }
  }
}

# print %tokillnodes;

close IN;
open(IN,"< $model");
while (my $line = <IN>) {
  if ($line =~ /^..\(.*,(\d+)[,\)]/) {
    if (! exists $tokillnodes{$1}) {
      print OUT $line;
    } else {
#      print "we should kill this line ! $line ";
    }
  } elsif ($line =~ /^CA\(.*,(\d+),/) {
    if (! exists $tokillnodes{$1}) {
      print OUT $line;
    } else {
#      print "we should kill this line ! $line ";
    }
  } else  {
    print OUT $line;
  } 
}

close IN;
close OUT;

exit(0);

#system("\\mv $model.tmp $model");
