#include "spot/ltlparse/public.hh"
#include "spot/ltlvisit/apcollect.hh"
#include <iostream>

using namespace std;


int main (int argc, char ** argv) {
  if (argc != 2) {
    cerr << "this program returns the list of AP in an LTL formula, based on Spot's parser"<<endl;
    cerr << "Please give formula as argument to this program"<<endl;
    exit(2);
  }
  

  spot::ltl::parse_error_list pel;
  spot::ltl::formula* f = spot::ltl::parse(argv[1],pel);
  
  if (spot::ltl::format_parse_errors(std::cerr,argv[1], pel))
    exit(2);

  spot::ltl::atomic_prop_set* sap = spot::ltl::atomic_prop_collect(f);

  if (sap) {
    spot::ltl::atomic_prop_set::iterator it;
    for(it=sap->begin(); it!=sap->end(); /* ++it */) {
      cout << (*it)->name()  ;
      if (++it != sap->end())
	cout << ",";
    }
  }
  cout << endl;
  return 0;
}
