'''
Created on 21 sept. 2009

@author: hong
'''

import sys
import os
from Util import *
from DialogBox import *


class APICami(object):
    
    # Initialization on FIFO
    def __init__(self,fifo_in=None,fifo_out=None):
        self.tube_out = sys.stdout
        self.tube_in = sys.stdin
        self.standalone = True
        if fifo_out != None:
            self.tube_out = open(fifo_out,'w')
            self.standalone = False
        if fifo_in != None:
            self.tube_in = open(fifo_in,'r')
            self.standalone = False
        #tube_out = open(sys.argv[4],'w')
        #tube_in = open(sys.argv[3],'r')
    
    # Redefinition of the Write STDOUT function
    # Automatic redirection to a communication PIPE if CPN-AMI is linked
    def write(self,str):
        if self.tube_out == sys.stdout:
           print str
        else:
            self.send_Trace(str)
        
        
    def start_tool(self,tool_name,tool_version,tool_copyright):
        if self.standalone == False:
            command = 'START_TOOL(1:C,2,1,2,6,2,3,'+text2cami(tool_name)+','+text2cami(tool_version)+','+text2cami(tool_copyright)+')'
            self.tube_out.write(makeCami(command))
            command = 'TR('+ text2cami('The application start with the PYTHON API Communication Module (S. HONG)') + ')'
            self.tube_out.write(makeCami(command))
            self.tube_out.flush()
        else:
            print 'Tools starting into Stand Alone Mode'
    
    def cami_send(self,commands):
        if self.standalone == False:
            self.tube_out.write(makeCami(commands))
            self.tube_out.flush()
        else:
            print commands
    
    def send_Trace(self,commands):
        if self.standalone == False:
            self.tube_out.write(makeCami('DE()'))
            self.tube_out.write(makeCami('RT('+text2cami(commands)+')'))
            self.tube_out.write(makeCami('FE()'))
            self.tube_out.flush()
        else:
            print commands
            
    def send_Trace_Bloc(self,commands):
        if self.standalone == False:
            self.tube_out.write(makeCami('DE()'))
            for line in commands.splitlines():
                line = line.replace('\n','')
                self.tube_out.write(makeCami('RT('+text2cami(line)+')'))
            self.tube_out.write(makeCami('FE()'))
            self.tube_out.flush()
        else:
            print commands

    def send_cami_file(self,lines):
        if self.standalone == False:
            filew = open("out_cami.txt","w")
            filew.write('DE()\n')
            for line in lines.split("\n") :
                line = line.replace('\n','')
                filew.write('RT('+text2cami(line)+')\n')
            filew.write('FE()\n')
            filew.close()
            self.tube_out.write(makeCami('SEND_CAMI_FILE(' +text2cami(os.getcwd() + '/out_cami.txt')+',0)'))
            self.tube_out.flush()
        else:
            filew = open("out_cami.txt","w")
            for line in lines.split("\n") :
                line = line.replace('\n','')
                filew.write('TR('+text2cami(line)+')\n')
            filew.close()
            print lines
    
    def send_State(self,commands):
        if self.standalone == False:
            self.tube_out.write(makeCami('STT_MSG('+text2cami(commands)+')'))
            self.tube_out.flush()
        else:
            print commands
    
    def send_DB(self,db):
        self.cami_send(db.toCami())
        self.tube_out.flush()
        
    def wait_ADB(self):
        self.tube_out.flush()
        # Wait answer
        data = ''
        while(data.find('FP()') == -1):
            data = data + self.tube_in.read(1)
        
        # The dialog Box
        db = DBAnswer(data)
        # Ask to destroy the DB
        command = "DG("+str(db.id)+")\n"
        self.tube_out.write(makeCami(command))
        # Parse the Answer
        return db 
    
    def end_tool(self,status_code):
        if self.standalone == False:
            command = 'END_TOOL(' + str(status_code)+')'
            self.tube_out.write(makeCami(command))
            self.tube_out.flush()
            self.tube_out.close()
            self.tube_in.close()
        else:
            print 'End TOOLS'
  