'''
Created on 21 sept. 2009

@author: hong
'''
from Util import *

class DBAnswer:
    BUTTON_OK = 1
    BUTTON_NOK = 2
    TRUE = 1
    FALSE = 2

    def parse(self,file):
      # First Find RD
      index = file.find('RD(')
      self.id,rem       = read_integer(file[index+3:])
      self.button,rem   = read_integer(rem[1:])
      self.modified,rem = read_integer(rem[1:])
      self.value,rem    = read_cami_text(rem[1:]) # Here value can be Empty
      # Second For All DS
      index = rem.find("DS(")
      while(index != -1):
          # Get the DS Value
          ii,rem       = read_integer(rem[index+3:])
          tmp,rem      = read_cami_text(rem[1:]) # Here value can be Empty
          if len(self.value) == 0:
              self.value = tmp
          else:
              self.value = self.value + '\n' + tmp
          index = rem.find("DS(")

    def __init__(self,file = None):
        if file != None:
            self.parse(file)
        else:
            self.button = self.BUTTON_NOK
            self.modified = self.FALSE
            self.value = ""
    
    def __str__(self):
        res = ""
        res = "ID = " + str(self.id)
        if(self.button == self.BUTTON_OK):
            res = res + " OK"
        else:
            res = res + " CANCEL"
        return res
        
    
class DialogBox:
    
    TYPE_NORMAL                 = 1
    TYPE_WARNING                = 2
    TYPE_ERROR                  = 3
    TYPE_INYTERACTIF            = 4
    
    BUTTON_NO                   = 1
    BUTTON_OK                   = 2
    BUTTON_OK_CANCEL            = 3
    
    INPUT_NO                    = 2
    INPUT_YES                   = 1
    INPUT_YES_WITH_ANNULATION   = 5
    
    SELECT_NO    = 1
    SELECT_LINE  = 2
    SELECT_LINES = 5
    
    def __init__(self,id,type,button,title,help,message,input,select,default):
        self.id = id
        self.type = type
        self.button = button
        self.title = title
        self.help = help
        self.message = message
        self.input = input
        self.select = select
        self.default = default
        self.value = []
    
    def add_ligne(self,value):
        self.value.append(value)
    
    def toCami(self):
        command = "DC()\n"
        command = command + "CE("
        command = command + str(self.id) + ","
        command = command + str(self.type) + ","
        command = command + str(self.button) + ","
        command = command + text2cami(self.title) + ","
        command = command + text2cami(self.message) + ","
        command = command + text2cami(self.help) + ","
        command = command +str(self.input) + ","
        command = command +str(self.select) + ","
        command = command +text2cami(self.default) + ")\n"
        for arg in self.value:
            command = command + "DS(1,"+ text2cami(arg) +")\n" 
        command = command + "FF()\n" + "AD(1)"
        return command

class ComboBox ( DialogBox ):
    def __init__(self,title,help,value=[]):
        DialogBox.__init__(self, 1, DialogBox.TYPE_NORMAL, DialogBox.BUTTON_OK_CANCEL, title, help, text2cami(""), DialogBox.INPUT_NO, DialogBox.SELECT_LINES, text2cami(""))
        for v in value:
            DialogBox.add_ligne(self, v)

class TextBox ( DialogBox ):
    def __init__(self,title,help,value=[]):
        # For coloane, we must put default value into default value
        default = ''
        if len(value) > 0:
            default = value[0]
        DialogBox.__init__(self, 1, DialogBox.TYPE_NORMAL, DialogBox.BUTTON_OK_CANCEL, title, help, text2cami(""), DialogBox.INPUT_YES, DialogBox.SELECT_LINES, text2cami(default))
        for v in value:
            DialogBox.add_ligne(self, v)
            
class YesNoBox ( DialogBox ):
    def __init__(self,title,help):
        DialogBox.__init__(self, 1, DialogBox.TYPE_NORMAL, DialogBox.BUTTON_OK_CANCEL, title, help, text2cami(""), DialogBox.INPUT_NO, DialogBox.SELECT_LINE, text2cami(""))