#!/usr/bin/env python
'''
Created on 22 sept. 2009

@author: hong
'''

import time
import sys
import os
from pycami.parser import *





# Strategy Pattern on the operation Generate Order Hierarchy
class IGenerateOrder:
    
    # Default constructor of the Generation Interface order
    def __init__(self,net):
        self.time = 0
        self.net = net
        self.modelname= ""
        self.places_count = 0
        self.transitions_count = 0
        if net != None:
            self.modelname = net.pathmodel
            self.places_count      = len([ p for p in net.places() ])
            self.transitions_count = len([ t for t in net.transitions() ])
    
    # Default operation for clean the workspace of the Generation order
    def clean(self):
         None
    
    def help(self):
        return ""
    
    def generate_order(self):
         raise NotImplementedError

# Catch API STDOUT
class STDOUT:
    def write(self,str):
        print str
        

# for use MODULE in Standalone
class HInput:
    def __init__(self):
        self.path_conf = None
        self.partitions = None
        self.order = None
        self.api = None
        self.path_patoh = None
        self.colored_net = None


# Factory class for create a new strategy and execute the strategy
class GenerateOrder(IGenerateOrder):
    
    
    def __setStrategy(self,net,input):
        print 'Initialisation Strategy ',input.order
        if input.order == 0:
            import generate_order_0
            input.api.write('Strategy Order 0 : Specific Generation Order by Tool ' + input.appname.upper())
            self.strategy = generate_order_0.GenerateOrder_0(net,input.path_conf,input.appname.upper() + ' Order ' + str(input.library))
        if input.order == 1:
            import generate_order_1
            input.api.write('Strategy Order 1 : Simple PaToH with predecessor -- successor')
            self.strategy = generate_order_1.GenerateOrder_1(net,input.partitions,input.path_patoh,input.path_conf)
        elif input.order == 2:
            import generate_order_2
            input.api.write('Strategy Order 2 : Simple PaToH + Pre-Ordering Variable (M Heiner, M Schwarick, A Tovchigrechko:DSSZ-MC - A Tool for Symbolic Analysis of Extended Petri Nets)')
            self.strategy = generate_order_2.GenerateOrder_2(net,input.partitions,input.path_patoh,input.path_conf)
        elif input.order == 3:
            import generate_order_3
            input.api.write('Strategy Order 3 : FLAT + Pre-Ordering Variable (M Heiner, M Schwarick, A Tovchigrechko:DSSZ-MC - A Tool for Symbolic Analysis of Extended Petri Nets)')
            self.strategy = generate_order_3.GenerateOrder_3(net,input.path_conf)
        elif input.order == 4:
            import generate_order_4
            input.api.write('Strategy Order 4 : FLAT PaToH')
            self.strategy = generate_order_4.GenerateOrder_4(net,input.path_patoh,input.path_conf)
        elif input.order == 5:
            import generate_order_5
            input.api.write('Strategy Order 5 : Simple PaToH with successor -- predecessor')
            self.strategy = generate_order_5.GenerateOrder_5(net,input.partitions,input.path_patoh,input.path_conf)
        elif input.order == 6:
            import generate_order_6
            input.api.write('Strategy Order 6 : Simple PaToH with multiple hierarchy')
            self.strategy = generate_order_6.GenerateOrder_6(net,input.partitions,input.path_patoh,input.path_conf)
        elif input.order == 7:
            import generate_order_7
            input.api.write('Strategy Order 7 : Firing Order Best with multiple hierarchy X Y')
            self.strategy = generate_order_7.GenerateOrder_7(net,input.path_conf,input.api)
        elif input.order == 8:
            import generate_order_8
            input.api.write('Strategy Order 8 : Firing Order and ignoring valuation with multiple hierarchy X Y')
            self.strategy = generate_order_8.GenerateOrder_8(net,input.path_conf,input.api)
        elif input.order == 9:
            import generate_order_9
            input.api.write('Strategy Order 9 : Firing Order and ignoring valuation with hierarchy graph successor')
            self.strategy = generate_order_9.GenerateOrder_9(net,input.path_conf,input.api)
        elif input.order == 10:
            import generate_order_10
            input.api.write('Strategy Order 10 : Firing Order and ignoring valuation with hierarchy graph successor')
            self.strategy = generate_order_10.GenerateOrder_10(net,input.path_conf,input.api)
        elif input.order == 11:
            input.api.write('Strategy Order 11 : Firing Order and ignoring valuation with hierarchy graph successor')
            import generate_order_11
            self.strategy = generate_order_11.GenerateOrder_11(net,input.path_conf,input.api)
        elif input.order == 12:
            input.api.write('Strategy Order 12 : FORCE Algorithm Heuristic Flat order + naive XY-Hierarchy ')
            import generate_order_12
            self.strategy = generate_order_12.GenerateOrder_12(net,input.path_conf)
        elif input.order == 13:
            input.api.write('Strategy Order 13 : In study')
            import generate_order_13
            self.strategy = generate_order_13.GenerateOrder_13(net,input.path_conf,input.api)
        elif input.order == 20:
            input.api.write('Ordered from Colored Model and Unfolding Model (not finish)')
            import generate_order_20
            self.strategy = generate_order_20.GenerateOrder_20(input.colored_net,net,input.path_conf,input.order,input.api)
        elif input.order == 21:
            input.api.write('DSSZ-MC [NOA99] variant heuristic + Naive XY-Hierarchy')
            import generate_order_21
            self.strategy = generate_order_21.GenerateOrder_21(net,input.path_conf)
        elif input.order == 22:
            input.api.write('H-13 Base + up communicate place with recursive hierarchy building')
            import generate_order_22
            self.strategy = generate_order_22.GenerateOrder_22(net,input.path_conf,input.api)
        elif input.order == 23:
            input.api.write('H-13 Base + up communicate place with recursive hierarchy building Variant 2')
            import generate_order_23
            self.strategy = generate_order_23.GenerateOrder_23(net,input.path_conf,input.api)
        elif input.order == 24:
            input.api.write('Random Flat orders + Naive XY-Hierarchy')
            import generate_order_24
            self.strategy = generate_order_24.GenerateOrder_24(net,input.path_conf)
        elif input.order >= 14:
            input.api.write('Strategy Order 14 : Ciardo Heuristics Study (H-14 to H-25)')
            import generate_order_14
            self.strategy = generate_order_14.GenerateOrder_14(net,input.path_conf,input.order)
    
    # Default constructor with the strategy choosen by user
    def __init__(self,net=None,input=None):
        self.strategy = None
        if input != None:
            self.__setStrategy(net,input)
    
    # For another initialization
    def initialization(self,net_model,order_number,order_file,root_tools='./',colored_net = None):
        input = HInput()
        if input_model == 'CAMI':
            net = parse_cami(net_model)
            if colored_net != None:
                input.colored_net = parse_cami(colored_net)
        elif input.input_model == 'ATPN':
            net = parse_atpn(net_model)
        input.path_conf = order_file
        input.partitions = 10 # Default for PaToH
        input.order = order_number
        input.api = STDOUT()
        input.path_patoh = root_tools
        self.__setStrategy(net,input)
        
    
    # Launch the operation
    def generate_order(self):
        # End time
        self.strategy.time = time.clock()
        print 'Start generation time : ',self.strategy.time
        res = self.strategy.generate_order()
        self.strategy.time = time.clock() - self.strategy.time
        print 'End generation time : ',time.clock() , ' TOTAL ==> ' , self.strategy.time ,' s'
        return res
   
    def clean(self):
        self.strategy.clean()
    
    def help(self):
        return self.strategy.help()
    
    def __str__(self):
        return str(self.strategy)




def help():
    print 'DEFAULT SCRIPT for use only the Heuristic Order Module'
    print 'This script take :'
    print ' --model  The model name path (must be ordinary petri net)'
    print ' --porder The order generation file'
    print ' --order  The order strategy to used (1-15)'
    print ' --cami   Specify model are in CAMI Format (default)'
    print ' --atpn   Specify model are in APNN Format'
    print ' --patoh  If you used H-1, you must specify the PaToH tools access'
    print ''
    print 'Note :'
    print 'In each strategy order, some options are available : '
    print ' --X <value> --Y <value> : User can specify the XY-parameters for the Naive Build Hierarchy (H-6 to H-13)'
    print ' --flat : Generate only a flat order (without hierarchy)' 
    print ' --i <value> : Use by H-12 only, define the maximum number of iteration for the gravity center calculation'
    print ''
    print 'Exemple :'
    print './IGenerateOrder.py --model ../BENCHMARKS/Peterson3.cami --porder conf.txt --order 13'
    print './IGenerateOrder.py --model ../BENCHMARKS/Peterson3.cami --porder conf.txt --order 13 --X 0 --Y 0'
    print './IGenerateOrder.py --model ../BENCHMARKS/Peterson3.cami --porder conf.txt --order 13 --flat'
    print ''
    print ''
    print ''


# DEFAULT SCRIPT for use only the Heuristics Order Module
# This script take one
if __name__ == '__main__':
    help()
    # Command parsing
    path_model_colored = None
    patoh = None
    if '--patoh' in sys.argv:
        patoh = sys.argv[sys.argv.index('--patoh')+1]
    if '--model' in sys.argv:
        path_model = sys.argv[sys.argv.index('--model')+1]
    if '--cmodel' in sys.argv:
        path_model_colored = sys.argv[sys.argv.index('--model')+1]
    if '--porder' in sys.argv:
        porder = sys.argv[sys.argv.index('--porder')+1]
    else:
        porder = path_model + '.json'
    # Default mode in CAMI
    input_model = 'CAMI'
    if '--cami' in sys.argv:
        input_model = 'CAMI' # CAMI
    if '--atpn' in sys.argv:
        input_model = 'ATPN' # ATPN
    if '--order' in sys.argv:
        order_number = int(sys.argv[sys.argv.index('--order')+1])
    else:
        order_number = 11
    
    # Generate order
    gen = GenerateOrder()
    gen.initialization(path_model, order_number, porder, patoh , path_model_colored)
    conf = gen.generate_order()
    print 'Tools have generate JSON Configuration file ' , conf[0]
    print gen

