#!/usr/bin/env python

'''
Created on 17 dec. 2009

@author: hong
'''

# Extending the LIST Vector Sequence for build a Tree
# Each node can be :
#    - A new vector hierarchy
#    - A Leaf
# Each node have a pointer on its sons and his parent
# So each Leaf can become a new Root tree
class Hierarchy (list):
    
    # Constructor with a default empty list vector sequence
    def __init__(self,vector=[]):
        list.__init__(vector)
        self.parent = None
    
    # Initialization of Parent
    def setParent(self,parent):
        self.parent = parent
    
    # Count the number of element by recursion, only the leaf is calculating
    def size(self):
        res = 0
        for elt in self:
            if type(elt).__name__!='Hierarchy':
                res += 1
            else:
                res += elt.size()
        return res
            
    
    # Count the number of element from the current node to the Root
    def countFromRoot(self):
        res = 0
        if self.parent != None:
            res += self.parent.countFromRoot() + len(self)
        return res
    
    def __str__(self):
        res = ""
        for h in self:
            res += str(h)+' '
        return res

# Public function for Flating on Hierarchy Order
def flating(order):
  flat = []
  __flating(flat,order)
  return flat

# Function write_conf :
# Write a JSON configuration file from an order specialize by user
# Order contains one or more hierarchy
def write_conf(path_conf,order):
  # Write JSON File
  file = open(path_conf,"w")
  __write_hierarchy(file,order)
  file.close()
  flat = []
  __flating(flat,order)
  flat.reverse()
  file = open(path_conf+'.idd',"w")
  __write_idd(file,flat)
  file.close()
      

# Function __write_hierarchy
# Description :
# Recursive function for write one hierarchy into JSON Format file
# Order element can be :
#  - A name place, to put in current hierarchy
#  - A new hierarchy to put in current hierarchy (by recursion)
def __write_hierarchy(file,order):
    file.write('[')
    virgule = False
    for elt in order:
        if not virgule:
            virgule = True
        else:
            file.write(',')
        if type(elt).__name__=='list' or type(elt).__name__=='Hierarchy':
            __write_hierarchy(file,elt)
        else:
            file.write('"'+elt.name+'"\n')
    file.write(']')

# Function __write_hierarchy
# Description :
# Recursive function for write one hierarchy into JSON Format file
# Order element can be :
#  - A name place, to put in current hierarchy
#  - A new hierarchy to put in current hierarchy (by recursion)
def __flating(flat,order):
    for elt in order:
        if type(elt).__name__=='list' or type(elt).__name__=='Hierarchy':
            __flating(flat,elt)
        else:
            flat.append(elt)

# Function __write_hierarchy
# Description :
# Recursive function for write one hierarchy into JSON Format file
# Order element can be :
#  - A name place, to put in current hierarchy
#  - A new hierarchy to put in current hierarchy (by recursion)
def __write_idd(file,order):
    for elt in order:
        if type(elt).__name__=='list' or type(elt).__name__=='Hierarchy':
            __write_idd(file,elt)
        else:
            file.write(elt.name+'\n')
    