#! /usr/bin/env python
import sys
import re
import math
import commands
import random
#Run ./program.py matrix.input order.output

#################
#Read input file#
#################
f=open(sys.argv[1], 'r')

N=int(f.readline())
M=int(f.readline())
Sis=[[] for i in range(M)]

matchLevel = re.compile('(\d+) :')
matchEvents = re.compile(' (\d+)')

#Read line by line
while 1 :
	line=f.readline()
	if not line: #End of file
		break
	level = matchLevel.match(line) # Find the number of the level
	events=matchEvents.findall(line)
	for event in events:
		Sis[int(event)-1].append(int(level.group(1))-1) 
f.close()
#print Sis
###############################
#End of the input file reading#
###############################


#Compute the cost
def score(temp_orderi):
	temp_order=[-1 for i in range(N)]
	for i in range(len(temp_orderi)):
		temp_order[temp_orderi[i]]=i
	NewSis=[[] for i in range(M)]
	cost=0
	for i in range(0,len(Sis)):
		for j in Sis[i]:
			if(temp_order[j]!=-1):
				NewSis[i].append(temp_order[j])
	for i in NewSis:
			if len(i)>0:
				cost+=max(max(i)-min(i)+1,0)
	return cost


def recurse(indexes, remaining_Sis):
	if(len(indexes)<=3):
		return [indexes]
	new_index=[0 for i in range(0,N)]
	for i in range(len(indexes)):
		new_index[indexes[i]]=i
	
	used_Sis=remaining_Sis[:]
	counter=0
	index=0
	len_used_Sis=len(used_Sis)
        while counter<len_used_Sis:
		remove=False 
		for j in Sis[used_Sis[index]]:
			if not j in indexes:
				remove=True
				break
		if len(Sis[used_Sis[index]])<2:
			remove=True
		if remove:
			del used_Sis[index]
		else:	
			index=index+1
		counter=counter+1

	f=open("metis.in", 'w')
	f.write("%i "%len(used_Sis))
	f.write("%i\n"%(len(indexes)+1))
	for i in used_Sis:
		for j in Sis[i]:
			f.write("%i "% (new_index[j]+1))
		f.write("%i "% (len(indexes)+1)) #Add a row of ones at the end
		f.write("\n")
	f.close()
	commands.getoutput("hmetis-1.5-linux/shmetis metis.in 2 16")
	f=open("metis.in.part.2", 'r')
	set0=[]
	set1=[]
	for i in range(len(indexes)):
		if int(f.readline()):
			set1.append(indexes[i])
		else:
			set0.append(indexes[i])

	set_with_last_row=int(f.readline())

	f.close()
	#print 'one step recurse'
	#print indexes
	#print set0
	#print set1
	if set_with_last_row:
		return [recurse(set1,used_Sis), recurse(set0,used_Sis)]
	else:
		return [recurse(set0,used_Sis), recurse(set1,used_Sis)]

def findopt_order_from_tree(tree):
	if len(tree)<=1:
		return tree[0]
	else:
		return findopt_order_from_tree(tree[0])+ findopt_order_from_tree(tree[1])


print Sis
Oder=[i for i in range(0,N)]
finalorder=Oder[:]
min_score=score(Oder)
for i in range(20):
	random.shuffle(Oder)
	order=recurse(Oder,[i for i in range(M)])
	#print recurse([0,1,3],[0, 1, 2, 3, 4, 9, 10, 11, 12])
	#print order
	temp_order= findopt_order_from_tree(order)
	print temp_order 
	print score(temp_order)
	if score(temp_order) < min_score:
		min_score=score(temp_order)
		finalorder=temp_order[:]
print "Score:"
print score(finalorder)
print "Original score:"
print score([i for i in range(N)])
####################
#Writes output file#
####################
f=open(sys.argv[2],'w')
f.write("%i\n"%len(finalorder))
for i in finalorder:
	f.write("%i\n"%(int(i)+1))


f.close()

############################
#End of output file writing#
############################




