'''
Created on 6 nov. 2009

@author: hong
'''

class Ordering_IDD:

    def __init__(self,net):
        self.net = net
        
    def getWeight (self,place, s):
        result = 0.0
        cardTouchP = 0
        # foreach transition in pre(place)
        for t, value in place.predecessors():
            # t is the predecessor transition
            cardT = 0.0
            cardNotInS = 0.0
            cardTouchP += 1
            # foreach place in pre(transtion)
            for preT, value in t.predecessors():
                # Pre of the current transition t
                cardT += 1
                if not preT in s:
                    cardNotInS+=1
            if cardT != 0:
                result = result + (cardNotInS / float(cardT))
        
        # foreach transition in post(place)
        for t, value in place.successors():
            # t is the successors transition
            cardT = 0.0
            cardNotInS = 0.0
            cardTouchP += 1
            # foreach place in post(transtion)
            for postT, value in t.successors():
                # Post of the current transition t
                cardT += 1
                if not postT in s:
                    cardNotInS+=1
            if cardT != 0:
                result = result + (cardNotInS / float(cardT))
    
        if cardTouchP != 0:
            result = result / float(cardTouchP);
    
        return result;
    
    
    def computeOrder(self):
        self.order = []
        # grab the set of places = variables in the input model
        places = []
        for p in self.net.places():
            places.append(p)
        
        # now, while there are places to add to the order
        # The set S of nodes already put in the order
        treatedNodes = []
        # find the heaviest place in the set
        while len(places) != 0 :
            max  = 0.0
            maxP = None
            for i in places:
                w = self.getWeight(i, treatedNodes);
                if w > max:
                    maxP = i;
                    max = w;
            if maxP != None:
                #add it to the treated set
                treatedNodes.append(maxP)
                # add it to the order
                self.order.append(maxP)
                # remove it from "places"
                places.remove(maxP)
            else:
                # Take all place marking
                for i in places:
                    if i.marking>0:
                        #add it to the treated set
                        treatedNodes.append(i)
                        # add it to the order
                        self.order.append(i)
                        # remove it from "places"
                        places.remove(i)
                        
                    
        
        # Return the new order
        return self.order
    
