#!/usr/bin/env python

from IGenerateOrder import *

# Ordering Generation Strategy 0 :
# When using a user ordering definition
class GenerateOrder_0(IGenerateOrder):
    
    # Constructor :
    # net        : The model
    # path_conf  : The directory where we generate the JSON File configuration
    # api        : Cami API Communication
    def __init__(self,net,path_conf,number):
        IGenerateOrder.__init__(self,net)
        self.order = number
        self.path_conf = path_conf
    
    # Help command
    # Print help about option of this generation order
    def help(self):
        str = "Generation order 0 :\n"
        str += " - Manual user definition of the order"
        return str
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(0)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(0)  + '\t' 
        res += str(0) + '\t'
        res += 'Internal Tools Order Number ' + self.order
        return res
  
    # Strategy Operation for generate one Configuration
    def generate_order(self):
      
      map = {}
      unexisting = []
      for place in self.net.places():
          map[place.name] = 0
      
      # Check if ordre is complete
      file = open(self.path_conf,"rU")
      model = ""
      for line in file.readlines():
          model += line
          model = model.replace("\n", "")
          model = model.replace("[", "")
          model = model.replace("]", "")
      
      # Split by ,
      for word in model.split(","):
          word = word.replace('"','')
          if map.has_key(word):
              map[word] += 1
          else:
              unexisting.append(word) 
      
      # Print the result
      stop = False
      print 'Result of the checker :'
      for k,v in map.items():
        if v == 0:
            print ' - Missing place ', k
            stop = True
        elif v > 1:
            print ' - Doublon place ', k
            stop = True
            
      for word in unexisting:
          print ' - Unknown place ', word
      
      if stop:
          raise Exception("Error in the configuration order file")
      
      # Write JSON File
      conf = []
      conf.append(self.path_conf)
      return conf

          

