#!/usr/bin/env python

from IGenerateOrder import *
from generate_order_8 import *
import sys



    

# Ordering Generation Strategy 11 :
# Same Heuristic like Strategy 8, but we change the weight Calculation (with SPAN),
# and we add user parameters for use this order with Random or first one transition
# choose if more than one transition have the same calculation weight
class GenerateOrder_11(GenerateOrder_8):
    
    # Constructor :
    # net        : The model
    # path_conf  : The directory where we generate the JSON File configuration
    # api        : Cami API Communication
    def __init__(self,net,path_conf,api):
        GenerateOrder_8.__init__(self,net,path_conf,api)
        # Redefinition of Function
        self.function_chooseNTransition = self.chooseNTransition
        self.function_weight = self.weight
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(self.X)  + '\t' 
        res += str(self.Y) + '\t'
        res += 'Pre-Fired Model (PF2) with Preds search link + naive XY-Hierarchy'
        return res
    
    
    # Help command
    # Print help about option of this generation order
    def help(self):
        str = "Generation order 11 : Pre-Firing variable ordering 2 (PF-3) with Preds search link + Hierarchy build with N-Cut-Naive \n"
        str += " --flat : desactivate the hierarchy (flat order)\n"
        str +="Parameters for N-Cut-Naive Hierarchy\n"
        str +="   --X <value> : Maximum height of structure\n"
        str +="   --Y <value> : Number of element per list (Y=2 by default)\n"
        str +="If X is not set, X is automatically calculated from X(Y)=Log[Y](count_places)"
        
        return str
    
    # Function weight :
    # Description :
    # Calculation of the transition weight and return all transition with the MAX Weight calculation
    def weight(self,order,ts):
        min = None
        min_w = []
        global all_p
    
        # For each transition, calculate the Weight of the transition
        #print '***************************'
        for t in ts:
            # Calculate W(T)
            w = 0.0
            places = set() 
            for p, tmp in t.predecessors():places.add(p)
            for p, tmp in t.successors():places.add(p)
            for p in places:
                #if p in order:
                if all_p[p] != None:
                    w += 1
            # If W == T(PRED) + T(SUCC)
            if len(places) == w:
                w = -1
            else:
                w = (w / len(places)) + float(self.span(order,t))
                
            
            #print w,' = ',t.name
            # Build the list of transition with W = MIN
            if min < w or min == None:
                min_w = [] # Reseting
                min_w.append(t)
                min = w
            elif min == w:
                min_w.append(t)
    
        return min_w


    # Redefinition of the ChooseNTransition
    # Give Random Choose
    def chooseNTransition(self, min_w):
        import random
        if '--random' in sys.argv:
            return  min_w[random.randint(0,len(min_w)-1)]
        else:
            return  min_w[0]#random.randint(0,len(min_w)-1)]

    # SPAN Function
    # From a Ordering Vector, we search the Index Element near the current transition
    # Local Effect
    def span(self,order,transition):
        i1 = 0
        for pla,arc in transition.predecessors():
            if pla in order:
                temp = order.index(pla)
                if temp > i1:
                    i1 = temp
        return i1
    
    def print_order(self,order):
        cpt = 0
        for p in order:
            print '[',cpt,'] ',p.name
            cpt += 1
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
      
      # Generate 1-Hierarchy order
      order,torder = self.function_pre_firing_order()
      # Print Order
      #self.print_order(order)
      # Calculate Automatic or a User definition of XY-Hierarchy
      self.X , self.Y = self.calculate_XY(len(order))
      # Naive XY Build Hierarchy
      order = self.write_partition(order,self.X,self.Y)
      if '--flat' in sys.argv:
          order =flating(order)
      # Write JSON File
      conf = []
      conf.append(self.path_conf)
      write_conf(self.path_conf,order)
    
      return conf
          

