#!/usr/bin/env python

from IGenerateOrder import *
from generate_order_12 import *
import sys

# Ordering Generation Strategy 13 :
class GenerateOrder_14(GenerateOrder_12):
    
    # Constructor :
    # net        : The model
    # path_conf  : The directory where we generate the JSON File configuration
    # api        : Cami API Communication
    def __init__(self,net,path_conf,api):
        GenerateOrder_12.__init__(self,net,path_conf,api)
        self.function_fire = self.fire
        self.function_weight = self.weight
        self.function_chooseFire = self.chooseFire
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(self.X)  + '\t' 
        res += str(self.Y) + '\t'
        res += 'Pre-Firing in Path Width with a Parallel Sequence Hierarchy + naive XY-Hierarchy in each Sequence'
        return res
    
    
    
    # This function is used at each Firing Transition for build a default Hierarchy
    # Description :
    # At each transition firing, we search if one element is link with on partition
    # if YES :
    #   - We add the current element in the partition linked
    # if NO :
    #   - We create a new Hierarchy
    def build_hierarchy(self,transition,order):
        # First check a partition link
        partition = None
        min = None
        for place, arc in transition.predecessors(): 
            if all_p[place] != None and partition == None:
                partition = all_p[place]
                min = len(partition)
            elif all_p[place] != None and partition != None and len(all_p[place]) < min:
                partition = all_p[place]
                min = len(partition)
                
        if partition == None:
            partition = Hierarchy()
            order.append(partition)
        else:
            None
        
        return partition
    
        
    # Function weight :
    # Redefinition : No calculation Weight, we take all transition which
    # can be firing at one time and return it (path width) 
    def weight(self,order,ts):
        min_w = []
        # For each transition, calculate the Weight of the transition
        for t in ts:
           min_w.append(t)
           
        return min_w

    # Redefinition of ChooseFire for a path width Firing Model
    def chooseFire(self,order , ts , torder):
        min_w = self.function_weight(order,ts)
        # We choose all transition at one time
        if len(min_w) == 0:
            # No transition can be fired : Break ALGO
            transitionChoose = None
        else:
            for t in min_w:
                self.fire(order, t, torder)
            transitionChoose = min_w[0]
                                
        return transitionChoose
    
    # Function fire :
    # Redefinition of FIRE :
    # Same as H9 but we call a different build_hierarchy function
    def fire(self,order,transition,torder):
        # Global used
        global fires,all_t,all_p,tss,tps2,order_len,other
        # Increment firing counter
        fires += 1

        # Check of transition was not removed from a previous firing
        # It can be happened when algorithme have fired some transition in structural conflict
        if not transition in tss:
            # Avoid function
            return
        ## Before search the first partition link
        save = order
        order = self.build_hierarchy(transition,order)
        
        
        # Add the Predecessors places in vector
        for place, arc in transition.predecessors():
            if all_p[place] == None:
                order.append(place)
                all_p[place] = order
            
                
                    
                    
                # Add the Successors places in vector
        
        succ = []
        for p,a in transition.successors():
            if all_p[p] == None:
                succ.append(p)
        
        
        for place in succ:
            place.marking = 1 # Now we work only in True, False Value on place marking
            order.append(place)
            all_p[place] = order
            hie = True
        
        
                
        # Note that current transition fired, and remove it from TSS vector
        all_t[transition] = 1
        if transition in tss:
            tss.remove(transition)
        
        # After a fired, check if all transition in TSS vector will impact
        # the ordering vector, of not remove, removed it and note it
        ttttt = []
        for t in tss:
            if not self.function_checkFire(t):
                all_t[t] = 1
                ttttt.append(t)
        for t in ttttt:
            tss.remove(t)
                
            
        # After a fired, update the new transition will can be fire
        # Check only transition impacted by the current successors places 
        for place, arc in transition.successors():
            for T,arc in place.successors():
                # only if we can use the transition t
                if all_t[T] == None:
                    if self.function_canFire(T):
                        # Say that current transition is in vector
                        tss.append(T)
                        #tss.insert(0,T)
                        all_t[T] = 2
        order = save
    
 
            
        
    # Strategy Operation for generate one Configuration
    def generate_order(self):
      # Generate Order
      order,torder = self.function_pre_firing_order()
      order2 = []
      i = 0
      for h in order:
          if type(h).__name__=='Hierarchy' or type(h).__name__=='list':
              # Reversing if user want to reverse
              if '--reverse' in sys.argv and (i % 2 != 0):
                  h.reverse()
              if '--force' in sys.argv:
                  h = self.FORCE(h, 1, 1)
              # Naive XY Build Hierarchy
              self.X , self.Y = self.calculate_XY(len(h))
              h = self.write_partition(h,self.X,self.Y)
              print 'Elements Number Before Partition [',i,'] = : ', len(h)
              order2.append(h)
              i += 1
    
      while len(order2) > 10:
          order2 = self.write_partition(order2,1,self.Y)
          
      if '--flat' in sys.argv:
          order2 =flating(order2)
      
      # Write JSON File
      conf = []
      conf.append(self.path_conf)
      write_conf(self.path_conf,order2)
    
      return conf

          

