#!/usr/bin/env python


from IGenerateOrder import *
from generate_order_1 import *
from Ordering_IDD import *
import sys

# Ordering Generation Strategy 2:
# Pre-Odering Variable with IDD then we use PaToH for build 1-Hierarchy
class GenerateOrder_2(GenerateOrder_1):
    
    # Constructor :
    # net        : The model
    # partitions : The number of places into one partitions
    # patoh      : Tools access to patoh
    # path_conf  : The directory where we generate the JSON File configuration
    def __init__(self,net,partitions,patoh,path_conf):
        GenerateOrder_1.__init__(self,net, partitions, patoh, path_conf)
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(1)  + '\t' 
        res += str(self.partitions) + '\t'
        res += 'IDD Heuritstic + PaToH'
        return res
    
    # Help command
    # Print help about option of this generation order
    def help(self):
        str = "Generation order 2 : Hyper-graph partionning with PaToH and Pre-ordering with NOA99 \n"
        str += " --flat : desactivate hierarchy\n"
        str += " --partition_size <integer> : give the size of one partitions\n"
        return str
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
        # Execution of ordering place with PaToH : Activation of hierarchy + PRED and SUCC + PreOrdering with IDD
        order = self.PaToH(False,True,True)
        if '--flat' in sys.argv:
          order =flating(order)
        # Write JSON File
        conf = []
        conf.append(self.path_conf)
        write_conf(self.path_conf,order)
        return conf

