#!/usr/bin/env python

from generate_order_11 import *
from IGenerateOrder import *
from pycami.converter import *
from greedy_first import *
from greedy_min_sum_topi import *
from JSONWrite import *
import sys

# Ordering Generation Strategy 20 :
class GenerateOrder_20(GenerateOrder_11):
    
    # Constructor :
    # net        : The model
    # partitions : The number of places into one partitions
    # patoh      : Tools access to patoh
    # path_conf  : The directory where we generate the JSON File configuration
    def __init__(self, colored_net,ordinary_net, path_conf,order,api):
        GenerateOrder_11.__init__(self, colored_net,path_conf,api)
        self.colored_net = colored_net
        self.path_conf = path_conf
        self.function_canFire = self.canFire
        self.order = order
        self.function_fire = self.fire
    
    # Help command
    # Print help about option of this generation order
    def help(self):
        str = "Generation order 20 : Colored Building Hierarchy\n"
        str += "In study" 
        return str
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(0)  + '\t' 
        res += str(0) + '\t'
        res += 'Hierarchicalization with Colored Class Heuristic'
        return res
    
    
    def fire(self,order,transition,torder):
        # Global used
        global fires,all_t,all_p,tss,tps2
        # Increment firing counter
        fires += 1
        # Check of transition was not removed from a previous firing
        # It can be happened when algorithme have fired some transition in structural conflict
        if not transition in tss:
            # Avoid function
            return
        
        # Add the Predecessors places in vector
        for place, arc in transition.predecessors():
            if all_p[place] == None:
                order.append(place)
                all_p[place] = 1
        # Add the Successors places in vector
        for place, arc in transition.successors():
            place.marking = "XX" # Now we work only in True, False Value on place marking
            if all_p[place] == None:
                order.append(place)
                all_p[place] = 1
                
        # Note that current transition fired, and remove it from TSS vector
        all_t[transition] = 1
        if transition in tss:
            tss.remove(transition)
        
        # After a fired, check if all transition in TSS vector will impact
        # the ordering vector, of not remove, removed it and note it
        ttttt = []
        for t in tss:
            if not self.function_checkFire(t):
                all_t[t] = 1
                ttttt.append(t)
        for t in ttttt:
            tss.remove(t)
                
            
        # After a fired, update the new transition will can be fire
        # Check only transition impacted by the current successors places 
        for place, arc in transition.successors():
            for T,arc in place.successors():
                # only if we can use the transition t
                if all_t[T] == None:
                    if self.function_canFire(T):
                        # Say that current transition is in vector
                        tss.append(T)
    
    
        # Function canFire :
    # Description :
    # Check if on transition can be fire and if yes,
    # we assure that the transition will impact the ordering vector
    # Parameter :
    #  - transition : the current transition to check
    def canFire(self,transition):
        for place, arc in transition.predecessors():
            if len(place.marking) == 0:
                return False
        return self.function_checkFire(transition)
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
    # Generate 1-Hierarchy order
      order,torder = self.function_pre_firing_order()  
      # Write JSON File
      conf = []
      conf.append(self.path_conf)
      write_conf(self.path_conf,order)
    
      return conf

          

