#!/usr/bin/env python

from IGenerateOrder import *
from generate_order_6 import *
from pycami.converter import *
from JSONWrite import *
import sys
import os

# Internal Class use for simulate Output IO file (Redirection)
class IOTest:
    def __init__(self,file):
        self.file = file
        
    def fileno(self):
        return self.file.fileno()
    
    def write(self,str):
        print 'Writting STR' , str
    
    def close(self):
        self.file.close()

# Ordering Generation Strategy 21 :
class GenerateOrder_21(GenerateOrder_6):
    
    # Constructor :
    # net        : The model
    # partitions : The number of places into one partitions
    # patoh      : Tools access to patoh
    # path_conf  : The directory where we generate the JSON File configuration
    def __init__(self, net, path_conf):
        GenerateOrder_6.__init__(self, net, 0, None, path_conf)
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(0)  + '\t' 
        res += str(0) + '\t'
        res += 'IDDMC Heuristic [NOA99]'
        return res
    
    
    def help(self):
        res = "Input Command Generation order 21 : IDDMC Ordering [NOA99]\n"
        res +="--flat   : produce flat order\n"
        res +="--test   : Mode Benchmark --> study performances with evaloution of N-Cut [X,N]\n"
        res +="   --borneX <value> : Maximum height of structure on interval [1,X]\n"
        res +="   --borneY <value> : Number of element in list on interval [1,Y]\n"
        res += "\n"+GenerateOrder_6.help()
        return res
    
    def clean(self):
        # Clean workspace before
        command = 'rm -f converted.model.atpn order_temp.txt out.txt'
        process = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        process.wait()
        
    # Execution of IDDMC for get Ordering File
    def iddmc_noa99(self):
        # Declaration
        order = []
        self.clean()
        
        # Convert NET into ATPN File
        ToAtpn(self.net,'converted.model.atpn') 
        
        # Class net places by name
        places = {}
        for p in self.net.places():places[p.name] = p
        
        # Generate Order
        ff=IOTest(open('out.txt','w'))
        command = './iddmc --net-file=converted.model.atpn --Porder-write=order_temp.txt'
        process = Popen(command,shell=True,stdout=ff,stdin=PIPE,stderr=PIPE)
        # Check the out.txt File if we found the line
        stop = False
        while stop == False:
            if os.path.exists("order_temp.txt"):
                file = open('order_temp.txt',"rU")
                for line in file:
                    order.append(places[line.replace('\n','')])
                file.close()
                print "End of IDDMC Generation order : checking places : ",len(order),'/',self.places_count
                if len(order) == self.places_count:
                    stop = True
                    command = 'killall iddmc'
                    print 'Find and kill'
                    process = Popen(command,shell=True,stdin=PIPE, stdout = PIPE,stderr=PIPE)
                    process.wait()
                order = []
                
                
        
        
        
        # Get the ordering file and parse it into FLAT Order
        ff.close()
        file = open('order_temp.txt',"rU")
        for line in file:
            order.append(places[line.replace('\n','')])
        file.close()
        
        self.clean()
        
        print 'Generation Flat Order IDDMC [NOA99] finish : ' , len(order) , ' places ordered'
        return order
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
      # Generate Flat Order
      flat = self.iddmc_noa99()
      t1 = time.clock()
      print 'Flat Time generation : ',  t1 -  self.time, ' s'  
      # Calculate Automatic or a User definition of XY-Hierarchy
      self.X , self.Y = self.calculate_XY(len(flat))
      # Naive XY Build Hierarchy
      order = self.write_partition(flat,self.X,self.Y)
      print 'Hierarchichalization Time generation : ',  time.clock() - t1, ' s'
      if '--flat' in sys.argv:
          order = flat
          
      # Write JSON File
      conf = []
      conf.append(self.path_conf)
      write_conf(self.path_conf,order)
      toXX = 6
      toYY = 6
      fromXX = 1
      fromYY = 2
      if '--borneX' in sys.argv:
          fromXX = int(sys.argv[sys.argv.index('--borneX')+1])
          toXX = int(sys.argv[sys.argv.index('--borneX')+2])
      if '--borneY' in sys.argv:
          fromYY = int(sys.argv[sys.argv.index('--borneY')+1])
          toYY = int(sys.argv[sys.argv.index('--borneY')+2])
      if '--test' in sys.argv:
          for x in (range(fromXX,toXX)):
              for y in (range(fromYY,toYY)):
                  print 'Generation X=',x,' Y=',y
                  order = self.write_partition(flat,x,y)
                  name = self.path_conf+'_'+str(x)+str(y)
                  conf.append(name)
                  write_conf(name,order)
                  
          
      
      return conf

          

