#!/usr/bin/env python

from IGenerateOrder import *
from generate_order_12 import *
import sys


next_round = []
ii = 0
nbCOM = 0
nbPS = 0

# Ordering Generation Strategy 21 :
class GenerateOrder_22(GenerateOrder_12):
    
    # Constructor :
    # net        : The model
    # path_conf  : The directory where we generate the JSON File configuration
    # api        : Cami API Communication
    def __init__(self,net,path_conf,api):
        GenerateOrder_12.__init__(self,net,path_conf,api)
        self.function_fire = self.fire
        self.function_chooseFire = self.chooseFire
        self.function_pre_firing_order = self.pre_firing_order
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(self.X)  + '\t' 
        res += str(self.Y) + '\t'
        res += 'H-13 (parallel sequence) + extracting communicate places'
        return res
    
    # Help command
    # Print help about option of this generation order
    def help(self):
        str = "Generation order 22 : Hierarchy Building and Communication places\n"
        str += "In study" 
        return str
    
    # This function is used at each Firing Transition for build a default Hierarchy
    # Description :
    # At each transition firing, we search if one element is link with on partition
    # if YES :
    #   - We add the current element in the partition linked
    # if NO :
    #   - We create a new Hierarchy
    def build_hierarchy(self,transition,order):
        
        global nbPS
        # First check a partition link
        partition = None
        min = None
        print ""
        print "Search Link PRED by transition ", transition.name
        for place, arc in transition.predecessors(): 
            if all_p[place] != 1:
                if all_p[place] != None and partition == None and place.ignored == False:
                    print order.index(all_p[place]) ," - Link with Place in Hierarchy : " , place.name 
                    partition = all_p[place]
                    min = len(partition)
                elif all_p[place] != None and partition != None and len(all_p[place]) < min and place.ignored == False:
                    print order.index(all_p[place]) ," - Link with Place in Hierarchy : " , place.name
                    partition = all_p[place]
                    min = len(partition)
                
        if partition == None:
            partition = Hierarchy()
            nbPS += 1
            order.append(partition)
        else:
            None
    
        return partition
    
        
  

    # Redefinition of ChooseFire for a path width Firing Model
    def chooseFire(self,order , ts , torder):
        global next_round,tss,ii
        
        # We choose all transition at one time
        if len(ts) == 0:
            # No transition can be fired : Break ALGO
            transitionChoose = None
        else:
            for t in ts:
                if not t in torder:
                    torder.append(t)
                self.fire(order, t, torder)
            # Get all next_round and put it into tss vector
            ii += 1
            print 'Round ', ii
            tss = []
            for t in next_round:
                tss.append(t)
            next_round=[]
    
    # Function fire :
    # Redefinition of FIRE :
    # Same as H9 but we call a different build_hierarchy function
    def fire(self,order,transition,torder):
        # Global used
        global fires,all_t,all_p,tss,tps2,order_len,other,next_round,nbCOM
        # Increment firing counter
        fires += 1

        # Check of transition was not removed from a previous firing
        # It can be happened when algorithme have fired some transition in structural conflict
        if not transition in tss:
            # Avoid function
            return
        ## Before search the first partition link
        save = order # The root
        order = self.build_hierarchy(transition,order)
        
        
        
        # From TSS vector, check structural conflict
        for place, arc in transition.predecessors():
            for trans, arc in place.successors():
                if transition != trans and trans in tss:
                    #print 'Place ' , place.name , ' in conflict !'
                    place.conflict = True
        
        # Add the Predecessors places in vector
        print 'Fire ' , transition.name , ' PS = ' , save.index(order)
        for place, arc in transition.predecessors():
            if all_p[place] == None:
                order.append(place)
                all_p[place] = order
                # Memorize the transition which have sit this place
                place.old_position = (order,order.index(place))
                print "ADD place " , place.name , ' in ', order
                #print 'OLD POSITION >>> ', place.old_position
            # If place are :
            #  - In Conflict and place already in on PS
            #  - Its PS is not the same as finding
            elif all_p[place] != None and all_p[place] != order  and all_p[place] != 1 and place.conflict:
                print ' Communicating Place : ' , place.name , '\n IN H[',all_p[place],'] and COM with H[',order,']'
                # Removed Communicate place
                all_p[place].remove(place)
                # Place it into ROOT after its hierarchy
                save.insert(save.index(all_p[place])+1,place)
                #save.insert(0,place)
                # If place has not been yet in ROOT :
                if all_p[place] != 1:
                    nbCOM += 1
                all_p[place] = 1
                # Removed conflict
                place.conflict = False
                place.ignored = True
#            elif all_p[place] == None and place.conflict:
#                if not place in save:
#                    save.append(place)
#                    #save.insert(0,place)
#                    # Removed conflict
#                    place.conflict = False
#                    place.ignored = True
#                    all_p[place] = 1
#            elif all_p[place] == 1 and place.conflict:
#                if place in save:
#                    # Replacing place
#                    print 'Replacing ' , place.name
#                    save.remove(place)
#                    save.insert(save.index(order)+1,place)
#                    place.conflict = False
#                    place.ignored = True
#                    all_p[place] = 1
                
            
                
                    
                    
                # Add the Successors places in vector
        
        succ = []
        for p,a in transition.successors():
            if all_p[p] == None:
                succ.append(p)
                
        
        
        for place in succ:
            place.marking = 1 # Now we work only in True, False Value on place marking
            order.append(place)
            all_p[place] = order
            place.old_position = (order,order.index(place))
            #print 'OLD POSITION >>> ', place.old_position
            hie = True
        
        # At the end remove all empty PS
        to_remove = []
        for ps in save:
            if type(ps).__name__=='Hierarchy':
                if len(ps) == 0:
                    to_remove.append(ps)
        
        for ps in to_remove:
            save.remove(ps)
            
            
        # Note that current transition fired, and remove it from TSS vector
        all_t[transition] = 1
        #if transition in tss:
        #    tss.remove(transition)
        
        # After a fired, check if all transition in TSS vector will impact
        # the ordering vector, of not remove, removed it and note it
#        ttttt = []
#        for t in tss:
#            if not self.function_checkFire(t):
#                all_t[t] = 1
#                ttttt.append(t)
#        for t in ttttt:
#            tss.remove(t)
                
            
        # After a fired, update the new transition will can be fire
        # Check only transition impacted by the current successors places 
        for place, arc in transition.successors():
            for T,arc in place.successors():
                # only if we can use the transition t
                if all_t[T] == None:
                    if self.function_canFire(T):
                        # Say that current transition is in vector
                        next_round.append(T)
                        all_t[T] = 2
        #print 'ENDFire ' , transition.name , ' PS = ' , order
        order = save
        
    
 
    def pre_firing_order(self):
          # Ordering Variable consist into Pre-firing Net
          # and list an order on the first Variable Firing
          # Ordering Transition by Pre-Firing order Net
          order = Hierarchy()
          torder = Hierarchy()
          
          # Total of place and transition and global initialization
          # We must initialize TSS vector with the current firing transition
          global all_t,all_p,tss,nbCOM,nbPS
          for p in self.net.places():
              all_p[p] = None # Not in ordering vector
              p.ignored = False # Used for check predecessor link
              p.conflict = False # USed for stock conflict place
          for t in self.net.transitions():
              all_t[t] = None # Not fired and not used
              if self.function_canFire(t):
                tss.append(t)
                all_t[t] = 2 # In used
          
          # Reversing TSS
          if '--s1' in sys.argv:
            tss.reverse()
          print 'There are ' , len(tss), 'transitions firing at the beginning'
          self.api.write('Number of places into model : ' + str(self.places_count))
          self.api.write('Number of transitions into model : ' + str(self.transitions_count))
    
          # While we can fired any transitions
          while len(tss) !=  0 and len(order) != self.places_count:
              if len(tss) != 0:
                  tt = self.function_chooseFire(order,tss,torder)
          
          # If all places is not in ordering vector, replacing it by First Predecessors heuristics
          diffP = self.places_count - order.size()        
          if diffP > 0:
              for p in self.net.places():
                  if not p in order:
                    for tra,arc in p.predecessors():
                        for pla,arc in tra.predecessors():
                            if pla in order and not (p in order):
                                order.insert( order.index(pla),p)
                  # At the end, if P not in the end, adding it to the end of vector
                  if not p in order:
                      order.append(p)     
          
          # Transition File
          if len(torder) != self.transitions_count:
              for t in self.net.transitions():
                  if not t in torder:
                      torder.append(t)
          
          global fires
          self.api.write('')
          self.api.write('')
          self.api.write('Statistic of the Pre-Fired Heuristic')
          self.api.write('Total of transition firing                         : '+ str(fires))
          self.api.write('Total of place touched by firing                   : ' + str(self.places_count-diffP) + '/' + str(self.places_count))
          self.api.write('Number of COM Places                               : '+ str(nbCOM))
          self.api.write('Number of Parallel Sequence                        : '+ str(nbPS))
          self.api.write('Total time of the ordering                         : '+str(self.time) + ' s')
          self.api.write( '')
          self.api.write('')
          
          return order,torder       
    
    
    # Build a basic 1-hierarchy communication
    # Order : Group of PS distance by COM Place in ROOT
    def build_hierarchy_by_communication(self,order):
        h1 = Hierarchy()
        new_order = Hierarchy()
        cpt = 0
        for h in order:
            if type(h).__name__=='Hierarchy':
                if cpt == 2:
                    new_order.append(h1)
                    h1 = Hierarchy()
                    cpt = 0
                h1.append(h)
                cpt += 1
            else:
                h1.append(h)
        # At the end : Check if there are some element in H1, if yes
        # we have not find 2 partitions for put it, so we up all in order
        if cpt == 2 :
            a = 0
            new_order.append(h1)
        else:
            a = 0
            for h in h1:
                a+=1
                new_order.append(h)
        
        if (len(new_order)-a) >= 5:
            new_order = self.build_hierarchy_by_communication(new_order)
        
        return new_order
   
    def searchLink(self,order,place):
        
        # Initialize places Link within
        setPlaces = set()
        for t,a in place.successors():
            for p,aa in t.predecessors():
                setPlaces.add(p)
        link = []
        #print ''
        #print 'Place ' , place.name , ' is linked with : '
        for ps in order:
            if type(ps).__name__=='Hierarchy' or type(ps).__name__=='list':
                for p in setPlaces:
                    if p in ps and not ps in link:
                        link.append(ps)
                        #print ' - ' , p.name

        
        return link
    
    # - Get all Leaf Node of Root
    # - Build graph dependance
    def step2_graph(self,order):
        print ' WORKING ON GRAPH COMMUNICATION PLACES !!!!'
        comPlaces = []
        paralleSequence = []
        mod = {}
        
        for h in order:
            if type(h).__name__=='Hierarchy' or type(h).__name__=='list':
                paralleSequence.append(h)
        
        print "Before SORT :"
        for ps in paralleSequence:
            print ' - [',len(ps), ']'
        
        if '--with-rev' in sys.argv:
            paralleSequence.sort(lambda x,y : cmp(len(x) , len(y)) , reverse=True)
            print "After SORT :"
            for ps in paralleSequence:
                print ' - [',len(ps), ']'
        # 1) Apply link PSi for each COM places
        max = -1
        for h in order:
            if not (type(h).__name__=='Hierarchy' or type(h).__name__=='list'):
                # We work on COM Place
                h.link = self.searchLink(order, h)
                
                if len(h.link) <= 1:
                    # Exist only one link, so remove COM place from order and re-put it it into PS
                    px,ii = h.old_position
                    #print "OLD Position Find for place ", h.name
                    cog = -1
                    res = 'NIL - '
                    for ps in h.link:
                         res += str(paralleSequence.index(ps)) + ' '
                    px.insert(ii,h)
                else:
                    res = ''
                    cog = 0.0
                    min = len(paralleSequence)
                    maxx = -1
                    for ps in h.link:
                        index = paralleSequence.index(ps)
                        if min > index:
                            min = index
                        if maxx < index:
                            maxx = index
                        cog += paralleSequence.index(ps)
                        res += str(paralleSequence.index(ps)) + ' '
                    # Strategy 1 : Calculation of COG (default)
                    cog = int ( cog / len(h.link)) + 1
                    if '--F1' in sys.argv:
                        # Strategy 2 PUT Place after the first one PS
                        cog = min + 1
                    if '--F2' in sys.argv:
                        # Strategy 2 PUT Place after the first one PS
                        cog = maxx + 1
                    if '--F3' in sys.argv:
                        # Strategy 2 PUT Place after the first one PS
                        cog = maxx 
                
                # At the end, add COM place into MOD Offset
                if not mod.has_key(cog):
                    mod[cog] = []
                mod[cog].append(h)
                if cog > -1:
                    comPlaces.append(h)
                
                # PRINT Iformation
                print 'COM place ' , h.name , ' is linked with [' , res,'] = ' ,  cog , ' : ' , len(mod[cog])
                if max < cog:
                    max = cog
        
        # At the end we have all COM place range by COG Position
        # Inserting into Main Vector
        
        offset = 0
        for a in mod.iterkeys():
            print a
        for i in range(0,max+1):
            if mod.has_key(i):
                if len(mod[i]) > 1:
                    paralleSequence.insert(i+offset,mod[i])
                else:
                    paralleSequence.insert(i+offset,mod[i][0])
                offset+=1
        
        
        print ''
        print ''
        print ''
        print 'COM places after filtering  : ' , len(comPlaces)
        for p in  comPlaces:
            print ' - ' , p.name
                            
        return paralleSequence
                
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
      # Generate Order
      order,torder = self.function_pre_firing_order()
      # Re-organize the COM places
      order = self.step2_graph(order)
      i = 0
      for h in order:
      #    if type(h).__name__=='Hierarchy' or type(h).__name__=='list':
              # Reversing if user want to reverse
      #        if '--reverse' in sys.argv and (i % 2 != 0):
      #          h.reverse()
      #        if '--force' in sys.argv:
      #            h = self.FORCE(h, 1, 1)
              # Naive XY Build Hierarchy
              #self.X , self.Y = self.calculate_XY(len(h))
              #h = self.write_partition(h,self.X,self.Y)
          if type(h).__name__=='Hierarchy':
            print 'Partition [',i,'] = : ', len(h)
            i += 1
            self.X , self.Y = self.calculate_XY(len(h))
            newH = self.write_partition(h,self.X,self.Y)
            order.insert(order.index(h),newH)
            order.remove(h)
    
      # Build Hierarchy on each PS
      order2 = self.build_hierarchy_by_communication(order)
      while len(order2) > 10:
          order2 = self.write_partition(order2,1,self.Y)
          
      if '--flat' in sys.argv:
          order =flating(order)
      
      
      
      # Write JSON File
      conf = []
      conf.append(self.path_conf)
      write_conf(self.path_conf,order2)
      write_conf(self.path_conf+'.transition',torder)
    
      return conf



