#!/usr/bin/env python

# TODO:
# Get PaToH tool for your architecture:
# http://bmi.osu.edu/~umit/software.html
# Put binary in current directory.

from JSONWrite import *
from subprocess import *
from IGenerateOrder import *
from generate_order_6 import *
from Ordering_IDD import *
import sys

# Ordering Generation Strategy 1:
# Here after we use the PATOH tools for generate a automatic ordering variable with hierarchy
class GenerateOrder_24(GenerateOrder_6):
    
    # Constructor :
    # net        : The model
    # partitions : The number of places into one partitions
    # patoh      : Tools access to patoh
    # path_conf  : The directory where we generate the JSON File configuration
    def __init__(self, net,path_conf):
        GenerateOrder_6.__init__(self,net,None,None,path_conf)
        self.path_conf = path_conf
        self.nbRandom = 1
        if '--NB-Random' in sys.argv:
            self.nbRandom = int(sys.argv[sys.argv.index('--NB-Random')+1])
        
    
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time) + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count) + '\t' 
        res += str(self.X) + '\t' 
        res += str(self.Y) + '\t'
        res += 'Random Flat Order + Naive XY-Hierarchy'
        return res
    
    def randomization(self):
        order = Hierarchy()
        for p in self.net.places():
            order.append(p)
        
        # Shuffle Order
        import random
        for i in range(0,10):
            random.shuffle(order)
        
        return order
    
    def clean(self):
        print 'Cleaning Generation order directory'
        # Clean workspace before
        command = 'rm -f ' + self.path_conf + '*'
        process = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        process.wait()
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
      # Write JSON File
      conf_F = []
      conf_H = []
      
      # How many Random Order you want to generate
      for i in range(0,self.nbRandom):
          confName = self.path_conf+'.'+str(i)
          conf_H.append(confName)
          conf_F.append(confName+'.flat')
          # Automatic Shufflization 
          order = self.randomization()
          # Write the Flat CONF
          write_conf(confName+'.flat',order)
          # Then Naive XY-Hierarchy
          self.X , self.Y = self.calculate_XY(len(order))
          order = self.write_partition(order,self.X,self.Y)
          write_conf(confName,order)
      
      for iter in conf_H:
          conf_F.append(iter)
      
      return conf_F

