#!/usr/bin/env python

from IGenerateOrder import *
from Ordering_IDD import *
from JSONWrite import *
import sys

# Ordering Generation Strategy 3:
# Using IDD for generate a Flat Order of model
class GenerateOrder_3(IGenerateOrder):
    
    # Constructor :
    # net        : The model
    # path_conf  : The directory where we generate the JSON File configuration
    def __init__(self,net,path_conf):
        IGenerateOrder.__init__(self,net)
        self.path_conf = path_conf
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(0)  + '\t' 
        res += str(0) + '\t'
        res += 'Flat IDD Order'
        return res
    
    # Help command
    # Print help about option of this generation order
    def help(self):
        str = "Generation order 3 : Flat Ordering with NOA99 \n"
        return str
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
      # Choose numbers for places with the pre - ordering variable:
      ordering = Ordering_IDD(self.net)
      order = ordering.computeOrder()
      if '--flat' in sys.argv:
          order =flating(order)
          
      # Write JSON File
      conf = []
      conf.append(self.path_conf)
      write_conf(self.path_conf,order)
      return conf

