#!/usr/bin/env python


from IGenerateOrder import *
from generate_order_1 import *
from Ordering_IDD import *
import sys


# Ordering Generation Strategy 4:
# Use PaToH for have a Flat order
class GenerateOrder_4(GenerateOrder_1):
    
    # Constructor :
    # net        : The model
    # patoh      : Tools access to patoh
    # path_conf  : The directory where we generate the JSON File configuration
    def __init__(self,net,patoh,path_conf):
        GenerateOrder_1.__init__(self,net,5,patoh,path_conf)
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(0)  + '\t' 
        res += str(0) + '\t'
        res += 'Flat PaToH Order'
        return res
    
    # Help command
    # Print help about option of this generation order
    def help_command(self):
        str = "Generation order 4 : Hyper-graph partitioning with PaToH and force a Flat order\n"
        str += " --partition_size <integer> : give the size of one partitions\n"
        return str
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
       # Execution of ordering place with PaToH : Desactivation of hierarchy + PRED and SUCC + PreOrdering with IDD
        order = self.PaToH(True,True,False)
        if '--flat' in sys.argv:
          order =flating(order)
        # Write JSON File
        conf = []
        conf.append(self.path_conf)
        write_conf(self.path_conf,order)
        return conf

