#!/usr/bin/env python

from IGenerateOrder import *
from generate_order_1 import *
from Ordering_IDD import *
import sys


# Ordering Generation Strategy 5:
# Here after we use the PaToH for odering variable and build a 1-Hierarchy
# Same with heuristic 1 but we use the SUCESSOR-PREDECESSOR definition of PaToH input 
class GenerateOrder_5(GenerateOrder_1):
    
    # Constructor :
    # net        : The model
    # patoh      : Tools access to patoh
    # path_conf  : The directory where we generate the JSON File configuration
    def __init__(self,net,partitions,patoh,path_conf):
        GenerateOrder_1.__init__(self,net,partitions,patoh,path_conf)
    
    # Print Information Order into XLS information
    def __str__(self):
        res = ''
        res += str(self.time)   + '\t' 
        res += str(self.places_count) + '\t' 
        res += str(self.transitions_count)  + '\t' 
        res += str(1)  + '\t' 
        res += str(self.partitions) + '\t'
        res += 'PaToH 1-Hierarchy with SUCCESSOR-PREDECESSOR'
        return res
    
    # Help command
    # Print help about option of this generation order
    def help_command(self):
        str = "Generation order 5 : Hyper-graph partitioning with PaToH (Inversion of PRED/SUCC)\n"
        str += " --partition_size <integer> : give the size of one partitions\n"
        str += " --flat : desactivate the hierarchy (flat order)\n"
        return str
    
    # Strategy Operation for generate one Configuration
    def generate_order(self):
       # Execution of ordering place with PaToH : Activation of hierarchy + PRED and SUCC + PreOrdering with IDD
        order = self.PaToH(False,False,False)
        if '--flat' in sys.argv:
          order =flating(order)
        # Write JSON File
        conf = []
        conf.append(self.path_conf)
        write_conf(self.path_conf,order)
        return conf