'''
Created on 16 juin 2009

@author: hong
'''

import sys
import testLexer
import testParser
from antlr3 import *
from antlr3.compat import set, frozenset





class DeclarationParser:
    
    def __init__(self):
        self.list = {}
        self.list['variable'] = {}
        self.list['class'] = {}
        self.list['domain'] = {}
    
    def add_variable(self,name,type):
        # Check if there is no other
        if self.list['variable'].has_key(name):
            raise SyntaxError('Variable ' + name + ' have already been declared')
        # Check if the type have been declared
        if self.list['class'].has_key(type):
             color = self.list['class'][type]
             self.list['variable'][name] = Variable(name,color)
        elif self.list['domain'].has_key(type):
             domain = self.list['domain'][type]
             self.list['variable'][name] = Variable(name,domain)
        else:
            raise SyntaxError('The type ' + type + ' of variable ' + name + ' is unknown')
    
    def add_class_by_enum(self,name,tab):
        val = []
        if tab == None:
            return
        if tab[0] > tab[1]:
                raise SyntaxError( "Wrong enumeration color from color " + tab[0].__str__() + ".." + tab[1].__str__())
        for i in range(tab[0],tab[1]+1):
            val.append(i.__str__())
        self.add_class(name,val)
    
    def add_class(self,name,value):
        # Check if there is no other
        if value == None:
            print 'Value NONE SKIPPING'
            return
        if self.list['class'].has_key(name):
            raise SyntaxError('Color ' + name + ' have already been declared')
        # Build the possible instance of Color
        dict = {}
        cpt = 0
        for v in value:
            if(dict.has_key(v) == False):
                dict[v]=cpt
                cpt += 1
            else:
                raise SyntaxError('Doublon was found into the declaration of color ' + name + ' on element ' + v)
         
         # By default, one Class Color is a Domain with one color
        self.list['class'][name] = Color(name,dict)
        val = []
        val.append(name)
        self.add_domain(name,val)
    
    def add_domain(self,name,value):
        # Check if there is no other
        if self.list['domain'].has_key(name):
            raise SyntaxError('Domain ' + name + ' have already been declared')
        # Check if each domain have been declared and build the new vector
        colors = []
        for v in value:
            if self.list['class'].has_key(v):
                colors.append(self.list['class'][v])
            else:
                raise SyntaxError('Color ' + v.__str__() + ' have not been declared')
             
        self.list['domain'][name] = Domain(name,colors)


class Color:
    
    def __init__(self,name,val):
        self.name = name
        self.the_val = val
        
    def isValidToken(self,token):
        return self.the_val.has_key(token)
    
    def __str__(self):
        str = 'Color : ' + self.name + '\n'
        for key in self.the_val.iterkeys():
            str = str + ' ' + key.__str__()
        return str
        
    
class Variable:
    
    def __init__(self,name,type):
        self.name = name
        self.type = type
    
    def __str__(self):
        str = 'Variable ' + self.name + ' TYPE : ' + self.type.name
        
        return str


class Domain:
    
    def __init__(self,name,colored):
        self.colors = colored
        self.name = name
    
    def isValidToken(self,tokens):
        # First Check the good number of token
        if len(tokens) != len(self.colors):
            return False
        for i in range(len(tokens)):
            if self.colors[i].isValidToken(tokens[i]) == False:
                return False
        
        return True
    
    def __str__(self):
        str = 'Domain : ' + self.name + '\n'
        for key in self.colors:
           str = str + '  ' + key.name
        return str
  


def parse_declaration(the_str):
    
    input = ANTLRStringStream(the_str)
    lexer  = testLexer.testLexer(input)
    tokens = CommonTokenStream(lexer)
    parser = testParser.testParser(tokens)
    tokens = CommonTokenStream(lexer)
    lexer.setCharStream(input)
    parser.setTokenStream(tokens)
    
    parser.r_2()
    res = parser.getResultat()
    
    # Add the default Black and White Color
    res.add_class_by_enum(None,[1,1])
    
    print "END"
    return res.list