###############################################################

def export(net):
  
  """
  Return the DOT description of a set of places as a string.
  Transitions will be exported as well as places have 
  references to their connected transitions.
  """
  
  res = "digraph pn{\n"
  
  for p in net.places():

    res += """  %(id)s [shape=circle,label="%(name)s : %(marking)s"];\n""" \
           % { 'id' : p.id , 'name' : p.name , 'marking' : p.marking}

    for t_in , arc in p.predecessors():
      res += """  %(tid)s -> %(pid)s [label="%(valuation)s"];\n""" \
             % { 'tid' : t_in.id , 'tname' : t_in.name , 'pid' : p.id , 'valuation' : arc.valuation }
      res += """  %(tid)s [shape=rectangle,label="%(tname)s"];\n""" \
             % { 'tid':t_in.id , 'tname':t_in.name }
             
    for t_out , arc in p.successors():
      res += """  %(pid)s -> %(tid)s [label="%(valuation)s"];\n""" \
             % { 'tid' : t_out.id , 'tname' : t_out.name , 'pid' : p.id , 'valuation' : arc.valuation }
      res += """  %(tid)s [shape=rectangle,label="%(tname)s"];\n""" \
             % { 'tid':t_out.id , 'tname':t_out.name }


  res += "}\n"
  
  return res
  
###############################################################
