#!/usr/bin/env python

'''
Created on 24 nov. 2009

@author: hong
'''
import sys
import os
from subprocess import *
from CAMI.APICami import *
from CAMI.DialogBox import *



class FileINI:
    # Default constructor with a initialization file
    def __init__(self,filename):
        self.host = []
        self.remote = 'localhost'
        try:
            file = open(filename)
            for line in file:
                line = line.replace('\n','')
                try:
                    if(line.find('remote') != -1):
                        index = line.find('=')
                        self.remote = line[index+1:]
                    if(line.find('host') != -1):
                        index = line.find('=')
                        self.host.append(line[index+1:])
                    env.append(line.replace('\n',''))
                except:
                    pass
            file.close()
        except Exception, ee:
            print ee



# Define the Kill Class Object Process
# progname : The list name of process to kill
# host : Execution on localhost (None) or on Remote Host by SSH
class Kill:
    # Kill Shell Command
    def kill(self):
        command = 'killall ' + self.progname
        if self.host != None:
            command = 'ssh '+ self.host + ' ' + command
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        p1.wait()
        oo,ii = p1.communicate()
        return oo
    
    # Constructor
    def __init__(self,host,command):
        self.host = host
        self.progname = ''
        if command == 0:
            self.progname = 'pnsdd'
        if command == 1:
            self.progname = 'pnits'
        if command == 2:
            self.progname = 'pnsdd pnits'
    
    # PS Command for show any pnsdd or pnits process in execution before killing
    def ps_command(self):
        command = 'ps -e'
        if self.host != None:
            command = 'ssh '+ self.host + ' ' + command
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        p1.wait()
        oo,ii = p1.communicate()
        # Filter the command with PNSDD or PNITS keyword
        res = ''
        first = True
        for line in oo.splitlines():
            if first:
                first = False
                res = line
            elif (not first) and (line.find('pnsdd') != -1 or  line.find('pnits') != -1):
                res = res + '\n' + line 
        return res
        
       
    

# Class definition for parse the command line in
#  - Standalone execution
#  - Framekit execution

class InputArgument:
    # Initialization from ARGV
    def __init__(self,standalone):
        if standalone:
            self.__parse_arg_standalone()
        else:
            self.__parse_arg_framekit()
    
    def __parse_arg_framekit(self):
        # Calling FrameKit MODE
        if len(sys.argv) > 4:
            # Command is type PIPE FIFO
            self.api = APICami(sys.argv[3],sys.argv[4])
            # Search the end of FrameKit Command (-end_env_p)
            index = sys.argv.index('-end_env_p')
            file = open("fk_basic_info")
            env = []
            for line in file:
                env.append(line.replace('\n',''))
            file.close()
            self.path = env[5] + "/" + "AMI-Net" + "/" + env[0] + "/PNSDD"
            self.host = None
            self.fileini       = self.path + '/remote_host.ini'
            self.command = -1
        else:
            exit(0)
    
    def __parse_arg_standalone(self):
        # Default API Cami
        self.api = APICami()
        # Default path execution
        try:
            if len(sys.argv) < 6:
                raise Exception('Missing some argument')
            if '--root' in sys.argv:
                self.path = sys.argv[sys.argv.index('--root')+1]
            else:
                raise Exception('Missing --root argument')
            if '--command' in sys.argv:
                self.command = int(sys.argv[sys.argv.index('--command')+1])
            else:
                self.command = -1
            if '--host' in sys.argv:
                self.host = sys.argv[sys.argv.index('--host')+1]
            else:
                self.host = None
            self.fileini       = self.path + 'remote_host.ini'
        except Exception, ee:
            print 'Error during the initialization standalone commande : ' + str(ee)
            self.print_help()
            exit(0)

    
    def print_help(self):
        print './Kill.py -s --root <root-dir> --host <remote host name>'
        print '--root    : Specify the root directory of the driver'
        print '--command : Specify the command to execute :'
        print '  0 Kill PNSDD'
        print '  1 Kill PNITS'
        print '  2 Kill ALL'
        print '--host    : Which host you want to execute Kill by SSH Command (give the username@hostname)'


class CurrentHost:
    def __init__(self):
        # get the host name
        self.name = 'unknow'
        command = 'echo $HOSTNAME'
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        oo,ii = p1.communicate()
        p1.wait()
        self.name = oo.replace('\n','')



def application(standalone):
    # Initialize the API Communication with FrameKit
    input = InputArgument(standalone)
    kill = None
    try:
        
        # Inform FK the Start application
        input.api.start_tool("KILL","1.0","S. HONG, E. PAVIOT-ADET, F. KORDON - LIP6 Copyright")
        
        # Automatic configuration of the remote host
        tab = ["Kill PNSDD on localhost",
               "Kill PNITS on localhost",
               "Kill ALL   on localhost"]
        if not standalone:
            ini = FileINI(input.fileini)
            current_host = CurrentHost()
            input.api.send_Trace(str(ini.host))
            if current_host.name in ini.host:
                input.host = ini.remote
            if input.host != None:
                tab.append("Kill PNSDD on "+ input.host)
                tab.append("Kill PNITS on "+ input.host)
                tab.append("Kill ALL   on "+ input.host)
            
            db = ComboBox("KILL Tools PNSDD or PNITS","Select the command to execute",tab)
            input.api.send_DB(db)
            answer = input.api.wait_ADB()
            if answer.button == answer.BUTTON_OK:
                if answer.value.find('PNSDD') != -1:
                    input.command = 0
                if answer.value.find('PNITS') != -1:
                    input.command = 1
                if answer.value.find('ALL') != -1:
                    input.command = 2
                if answer.value.find('localhost') != -1:
                    input.host = None
        
        if input.command != -1:
            kill = Kill(input.host,input.command)
            if input.host == None:
                input.api.send_Trace('Current Executing PNSDD or PNITS Process on localhost')
            else:
                input.api.send_Trace('Current Executing PNSDD or PNITS Process on ' +input.host)
            input.api.send_Trace_Bloc(kill.ps_command())
            input.api.send_Trace('Executing KILL Command for process ' + kill.progname)
            kill.kill()
            input.api.send_Trace('All process PNSDD or PNITS was killed !')
        else:
            input.api.send_Trace('Command was canceled !')
        
        
            
    except Exception, ee:
#        # Exception Raised during the execution python script
#        # We must send a wrong ending to Framekit
        input.api.send_Trace("***************************************************************")
        input.api.send_Trace("***************************************************************")
        input.api.send_Trace("Error during the execution script, error message is : "+str(ee))
        input.api.send_Trace("***************************************************************")
        input.api.send_Trace("***************************************************************")
        # Ending tools with error
        input.api.end_tool(1)
        exit(0)
    # End of Application
    input.api.end_tool(0)

if __name__ == '__main__':
    standalone = False
    if '-kit_name' in sys.argv:
        print "KILL"
        exit(0)
    if '-version' in sys.argv:
        print "DataMngr 2.1 EnvCom 2.6 UsrInterf 2.3 Tools 3.5"
        exit(0)
    if '-s' in sys.argv:
        print "StandAlone Execution Command"
        standalone = True
    
    # Execute the Application
    application(standalone)


    