#!/usr/bin/python



from subprocess import *


# Class definition for get the Machine Name Host
class CurrentHost:
    # Initialization of the name Host by command echo $HOSTNAME
    # and initialization of the attribute self.name
    def __init__(self):
        # get the host name
        self.name = 'unknow'
        command = 'echo $HOSTNAME'
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        oo,ii = p1.communicate()
        p1.wait()
        self.name = oo.replace('\n','')

# Define the class operation for initialize Maximum Memory for Linux System
# The maximum memory finder is defined on the command /proc/meminfo available on all Linux system
# Initialization strategy of the variable MaxMemory
# This module is also used for calcultate :
#  - The total memory used by system (all process)
#  - The maximum memory used by pnsdd
# For that, we use the TOP Linux Command where 
class MemoryChecker_Linux:
    # Initialization of the Agent, by default we must get the total physical memory available
    # on the system define by <host>, if None so it is the localhost else it is a remote host
    def __init__(self,host,process_name):
        command = 'cat /proc/meminfo'
        self.process_name = process_name
        self.Mcurrent = 0.0
        self.Mprocess = 0.0
        self.MaxMemory = 0.0
        self.host = host
        if host != None:
            command = 'ssh '+host + ' ' + command
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        p1.wait()
        oo,ii = p1.communicate()
        index = oo.find(":")
        oo = oo[index+1:]
        oo = oo.replace(' ','')
        index = len(oo)
        factor = 1
        if oo.lower().find('k') != -1:
           index =  oo.find('k')
           factor = 1024
        elif oo.lower().find('m') != -1:
            index =  oo.find('m')
            factor = 1024 * 1024
        self.MaxMemory = int(oo[0:index]) * factor
        

    # This function is a general used for parse one line of the TOP Command for get only
    # the field VIRT, represents the total memory used by one process
    # During the parsing, we check if the current line is the calculation for one specialized process
    # specified by process variable parameter. If yes, we return TRUE else FALSE
    def get_process_memory(self,line,res_index):
        # First check if process is the process to search
        bool = False
        if line.lower().find(self.process_name) != -1:
            bool = True
            
        # Split the line by space, we use the 5 split word
        Mcurrent = 0.0
        cpt = 0
        for virgule in line.split(' '):
            if len(virgule) == 0:
                continue
            elif len(virgule) > 0 and cpt < res_index:
                cpt+=1
                continue
            elif len(virgule) > 0 and cpt == res_index:
                # Remove all space
                virgule = virgule.replace(' ','')
                giga = virgule.upper().find('G')
                mega = virgule.upper().find('M')
                kilo = virgule.upper().find('K')
                if giga != -1:
                    Mcurrent = float(virgule[0:giga]) * 1024
                elif mega != -1:
                    Mcurrent = float(virgule[0:mega])
                elif kilo != -1:
                    Mcurrent = float(virgule[0:kilo]) / 1024.0
                else:
                    Mcurrent = float(virgule) / 1024.0
                cpt += 1
            else:
                cpt += 1
                
        return bool,Mcurrent
          
        
    
    # Reseting the MAC System agent for checking memory, and prepare it for another using
    def reset(self):
        self.Mcurrent = 0.0
        self.Mprocess = 0.0
    
    # This function use the TOP Command for MAC OS Type
    # Becarefull MAC TOP command is different than the Linux TOP Command 
    def verify(self):
        # After that search the percents of memory used by system (remove from the max memory)
        command = "top -n 1 -b"
        if self.host != None:
            command = 'ssh ' + self.host + ' ' + command
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        p1.wait()
        oo,ii = p1.communicate()
        process = False
        self.Mcurrent = 0.0
        for line in oo.split('\n'):
            # Remove all unused character
            line = line.replace('\n','')
            if process:
                bool,Mcurrent = self.get_process_memory(line,res_index)
                self.Mcurrent += Mcurrent 
                # Here we must only memorize the maximum value of memory calculation
                if bool and self.Mprocess <= Mcurrent:
                    self.Mprocess = Mcurrent
                continue
            # If PhysMem Field detecting (manage the general resources of the system)
            if line.lower().find('pid') != -1:
                process = True
                # Check the index of field RES
                res_index = 0
                cpt = 0
                for virgule in line.split(' '):
                    if len(virgule) == 0:
                        continue
                    elif len(virgule) > 0:
                        if virgule.lower().find('res') != -1:
                            res_index = cpt
                        cpt+=1 
                        continue

# Define the class operation for initialize Maximum Memory for Darwin System
# The maximum memory finder is defined on the command sysctl available on all Darwin system
# Initialization strategy of the variable MaxMemory
# This module is also used for calculate :
#  - The total memory used by system (all process)
#  - The maximum memory used by pnsdd
# For that, we use the TOP Darwin Command where 
class MemoryChecker_Darwin:
    
    # Initialization of the Agent, by default we must get the total physical memory available
    # on the system define by <host>, if None so it is the localhost else it is a remote host
    def __init__(self,host,process_name):
        command = 'sysctl hw.memsize'
        self.host = host
        self.process_name = process_name
        self.Mcurrent = 0.0
        self.Mprocess = 0.0
        if host != None:
            command = 'ssh '+host + ' ' + command
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        p1.wait()
        oo,ii = p1.communicate()
        index = oo.find(":")
        oo = oo[index+1:]
        self.MaxMemory = int(oo)
    
    # Line correspond to the description define by MAC Top where Physical Memory is calculate
    # Instance : 
    # PhysMem:  591M wired,  648M active,  118M inactive, 1613M used, 2483M free.
    def verify_general_system(self,line):
        for virgule in line.split(','):
            virgule = virgule.replace(',','')
            if virgule.lower().find('used') != -1:
                giga = virgule.lower().find('g')
                mega = virgule.lower().find('m')
                kilo = virgule.lower().find('k')
                if giga != -1:
                    self.Mcurrent = float(virgule[0:giga]) * 1024
                elif mega != -1:
                    self.Mcurrent = float(virgule[0:mega])
                elif kilo != -1:
                    self.Mcurrent = float(virgule[0:kilo]) / 1024.0
                else:
                    self.Mcurrent = float(virgule[0:virgule.lower().find('used')]) / (1024.0 * 1024.0)
                # Break the loop, we have found information
                return
    
    # This function is used for get the current memory used by PNSDD Process
    # Here after we parse the result of the TOP Darwin Command
    # Instance
    def verify_pnsdd_memory(self,line):
        Mprocess = 0.0
        if len(line.split(',')) == 2:
            # Format of TOP is correct : name_process<,>memory<G/M/K>
            # We work only on the second argument after the first <,>
            virgule = line.split(',')[1]
            virgule = virgule.replace(',','')
            # Check the unit memory
            # G GBytes - M MBytes - K KBytes - ELSE Bytes
            giga = virgule.lower().find('g')
            mega = virgule.lower().find('m')
            kilo = virgule.lower().find('k')
            # Calculation into MB
            if giga != -1:
                Mprocess = float(virgule[0:giga]) * 1024
            elif mega != -1:
                Mprocess = float(virgule[0:mega])
            elif kilo != -1:
                Mprocess = float(virgule[0:kilo]) / 1024.0
            else:
                Mprocess = float(virgule) / (1024.0 * 1024.0)
            # Here we must only memorize the maximum value of memory calculation
            if self.Mprocess <= Mprocess:
                self.Mprocess = Mprocess
    
    # Reseting the MAC System agent for checking memory, and prepare it for another using
    def reset(self):
        self.Mcurrent = 0.0
        self.Mprocess = 0.0
    
    # This function use the TOP Command for MAC OS Type
    # Becarefull MAC TOP command is different than the Linux TOP Command 
    def verify(self):
        # After that search the percents of memory used by system (remove from the max memory)
        command = "top -l 1 -p '^bbbbbbbbbb,^jjjjjjj'"
        if self.host != None:
            command = 'ssh ' + self.host + ' ' + command
        p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
        p1.wait()
        oo,ii = p1.communicate()
        for line in oo.splitlines():
            # Remove all unused character
            line = line.replace('\n','')
            line = line.replace(' ','')
            # If PhysMem Field detecting (manage the general resources of the system)
            if line.lower().find('physmem') != -1:
                self.verify_general_system(line)
            # If pnsdd Fiel detecting (manage the current memory of PNSDD Process)
            if line.lower().find(self.process_name) != -1:
                self.verify_pnsdd_memory(line)
                # Break
                return
    
# Class Manager of the global memory into the current computer
# This Manager define two second manager specific for a OS
#  - Mac Darwin OS Agent
#  - Linux OS Agent
# Theirs agents use the TOP Command define by system, becarefull, TOP Command has a different
# using between MAC and LINUX (explain 2 agents)
class MemoryChecker:
    def __init__(self,host,process_name=""):
        # Default value of Maximum limit of memory application
        self.os_name = 'unknow'
        self.current = 0.0
        self.host = host
        self.checked = False
        try:
            command = 'uname -a'
            if host != None:
                command = 'ssh ' + host + ' ' + command
            # Get the system name
            p1 = Popen(command,shell=True,stdin=PIPE,stdout=PIPE,stderr=PIPE)
            p1.wait()
            oo,ii = p1.communicate()
            if oo.find("Linux") != -1:
                self.os_name = 'Linux'
                if oo.find("X86_64") != -1:
                    self.arch_type = "X86_64"
                else:
                    self.arch_type = "X86_32"
                self.checker = MemoryChecker_Linux(host,process_name)                
            elif oo.find("Darwin") != -1:
                self.os_name = 'Darwin'
                if oo.find("X86_64") != -1:
                    self.arch_type = "X86_64"
                else:
                    self.arch_type = "X86_32"
                self.checker = MemoryChecker_Darwin(host,process_name)
        except:
            # If error choose a default limit memory
            self.checker.MaxMemory = 1024 * 1024 * 1024 * 4
        self.current_host = CurrentHost().name
        # Default bounded memory to 90 %
        self.percents = 90.0
        self.verify()
        self.base = self.current
    
    # Print information about System and Memory System
    def __str__(self):
        res = ''
        res = res + 'System Information' + '\n'
        res = res + 'Current Host                           : ' + self.current_host + '\n'
        if self.host == None:
            res = res + 'Remote Host                            : localhost\n'
        else:
            res = res + 'Remote Host                            : ' + self.host + '\n'
        res = res + 'System                                 : ' + self.os_name + '\n'
        res = res + 'Maximum Memory                         : ' + str(self.checker.MaxMemory/ (1024*1024) ) + ' Mb' + '\n'
        res = res + 'Limitation Memory                      : ' + str(self.percents) + ' %' + '\n'
        res = res + 'Current Memory used                    : ' + str(self.base)  + ' %' + '\n'
        return res 
    
    # This operation reseting all variable of the memory checker
    # and prepare it for another checking of memory
    def reset(self):
        self.checked = False
        self.current = 0.0
        self.checker.reset()
    
    # This operation aim is to :
    #  1) Calculate the general resources memory system in used, and check if we have not up-used the maximum memory define by user
    #  2) Calculate the process memory (pnsdd) memory accuracy, only the maximum memory used
    # This function write self.checked = False if there are a uploading memory (must stop process)
    # This function write self.current = % The total memory used by system in %
    # This function write 
    def verify(self):
        self.checker.verify()
        self.current = (self.checker.Mcurrent * 100) / (self.checker.MaxMemory / (1024 * 1024))
        
        # Check Memory condition
        self.checked = self.percents >= self.current
