#!/usr/bin/perl                                                               
                                                                                
use Getopt::Std;                                                                
                                                                                
getopt ('ioe');                                                               
my $usage="\n\nThis script transforms cami to hide immediate transitions and inhibitor arcs from sandrine.\n It will create an cami error trace iff. there are errors."                                                                      ."(c) 2006 Yann Thierry-Mieg, Laboratoire d'Informatique de Paris 6 \n"       
  ."Usage:\n"                                                                   
  ."cleanForSandrine -i [input_file = xxx.cami] -o [output file] -e [error output file]";
 
my $inff = $opt_i or  die $usage;
my $outff = $opt_o or die $usage;                                             
my $errff = $opt_e or die $usage;                                             
                                                                                
use strict 'vars';      

# check existence of everybody                                                                                                                       
if (! -r $inff) {                                                                                                                                   
    die "ERROR : model file $inff not found, please check existence and permissions. \n $usage";                                                      
}   

                                                                                                                                                    
open(OUT,"> $outff") or die "Couldn't create output file $outff";                                                                          
open(IN,"< $inff");                                                                                                                                 

my @inhib;
my @immed;
#one pass to replace strings                                                                                                                        
while (my $line = <IN>) {                                                                                                                            
 if ($line =~ s/^CN\(20:immediate transition,(\d+)/CN(10:transition,$1/ ) {
     push (@immed,$1);
 }
 if ($line =~ s/^CA\(13:inhibitor arc,(\d+)/CA(3:arc,$1/ ) {
     push (@inhib,$1);
 }
 print OUT $line;
}
close IN;
close OUT;

# output error(s) if necessary
if (@inhib || @immed) {
    open(OUT,"> $errff") or die "Couldn't create output file $errff";
    if (@inhib) {
	print OUT "DE(7:Warning,1)\n";                                                                                                                 	
	foreach (@inhib) {
	    print OUT "ME($_)\n";
	}
	my $line = "Inhibitor arcs are not supported by all tools. GreatSPN based tools support it (LTL).";
	print OUT "RT(".length($line).":".$line.")\n" unless ( length($line) == 0);                                                                      
	print OUT "FE()\n";
    }                                                                                                                                                  
    if (@immed) {
	print OUT "DE(7:Warning,1)\n";                                                                                                                 	
	foreach (@immed) {
	    print OUT "ME($_)\n";
	}
	my $line = "Immediate transitions are not supported by all tools. GreatSPN based tools support it (LTL).";
	print OUT "RT(".length($line).":".$line.")\n" unless ( length($line) == 0);                                                                      
	print OUT "FE()\n";
    }                                                                                                                                                  
    close OUT;
}
