#!/bin/sh
#
# Copyright (c) 1989 -- 2000
# by Helsinki University of Technology, Digital Systems Laboratory,
# a.k.a. Laboratory for Theoretical Computer Science.
# All rights reserved.
#
# Author of Clean.sh: Kimmo Varpaaniemi
#
# Current version:
#     $Id$
#
# Description:
#     Clean is a UNIX shell script for deleting all the files
#     that have been created by make.
#
# Version history:
#     $Log$

MYNAME=`echo "${0}" | sed -e 's/^.*\/\([^\/]*\)$/\1/g'`
if [ "${PRODPATH}" = "" ] ; then
    echo "${MYNAME}: PRODPATH should be defined properly"
    exit 1
fi
BT=".sh"
C=".c"
DELETE="/bin/rm -f"
H=".h"
LB=".a"
O=".o"
PREFIX=`echo "${PRODPATH}" | sed -e 's/^\(.*\)\/$/\1/g'`
PRODDIR="${PREFIX}/"
PRBIN="${PRODDIR}bin/"
PRINCL="${PRODDIR}include/"
PRLIB="${PRBIN}lib/"
PRSOURCE="${PRODDIR}source/"
X=""

${DELETE} "${PRBIN}Compile${BT}"
${DELETE} "${PRBIN}Link${BT}"
${DELETE} "${PRBIN}araprod${X}"
${DELETE} "${PRBIN}probe${X}"
${DELETE} "${PRBIN}prpp${X}"
${DELETE} "${PRBIN}strong${X}"
${DELETE} ${PRINCL}*${H}
${DELETE} ${PRLIB}*${LB}
${DELETE} ${PRLIB}*${O}
${DELETE} ${PRSOURCE}*${O}
${DELETE} "${PRSOURCE}absolute${X}"
${DELETE} "${PRSOURCE}absolute${H}"
${DELETE} "${PRSOURCE}araprod${X}"
${DELETE} "${PRSOURCE}gen${C}"
${DELETE} "${PRSOURCE}gen2${C}"
${DELETE} "${PRSOURCE}gen3${C}"
${DELETE} "${PRSOURCE}gen4${C}"
${DELETE} "${PRSOURCE}probe${X}"
${DELETE} "${PRSOURCE}prpp${X}"
${DELETE} "${PRSOURCE}strong${X}"
${DELETE} "${PRSOURCE}t${X}"
