#!/bin/sh
#
# Copyright (c) 1989 -- 2000
# by Helsinki University of Technology, Digital Systems Laboratory,
# a.k.a. Laboratory for Theoretical Computer Science.
# All rights reserved.
#
# Author of Double.sh: Kimmo Varpaaniemi
#
# Current version:
#     $Id$
#
# Description:
#     Double is a UNIX shell script for making a symbolic link
#     with all permissions. (There was a machine called hutds
#     whose "/bin/ln -s" respected umask.)
#
# Version history:
#     $Log$

MYNAME=`echo "${0}" | sed -e 's/^.*\/\([^\/]*\)$/\1/g'`
if [ "${#}" -ne "2" ] ; then
    echo "${MYNAME}: exactly two arguments expected"
    exit 1
fi
if [ \( "${1}" = "" \) -o \( "${2}" = "" \) ] ; then
    echo "${MYNAME}: exactly two arguments expected"
    exit 2
fi
CURDIR=`pwd | sed -e 's/^\(.*\)\/$/\1/g'`
MASK=`umask`
umask 000
/bin/ln -s "${CURDIR}/${1}" "${2}"
EXITSTATUS="${?}"
umask "${MASK}"
exit "${EXITSTATUS}"
