#!/bin/sh
d="-DARGV0 -DDEBUG -DDOSBATCH -DFIND_STRERROR -DPROTOZOA -DSMODELS -DTRAIN -DUNIX -D_POSIX_SOURCE"
for i do
        gcc ${d} -E -P -ansi -pedantic "${i}" \
        | egrep '[^ 	]' \
        | sed -e 's/^__extension__ //g' \
        | sed -e 's/ __attribute__.*;$/;/g' \
        > "_${i}"
        lclint -abstract -boolcompare +boolint -boolops -branchstate \
        -castfcnptr +charint -compdef -compmempass -dependenttrans \
        -duplicatequals -fcnuse -fullinitblock -globstate -ifempty \
        -immediatetrans -incondefs -kepttrans -mayaliasunique -modobserver \
        -mustfree -mutrep -nullassign -nullderef -nullpass -nullret \
        -nullstate -observertrans -onlytrans -predboolint -predboolothers \
        -statictrans -systemunrecog -temptrans -unqualifiedtrans \
        -usereleased +voidabstract \
        "_${i}" > "_${i}.lcl" 2>&1
done
