/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  dassert.h
*
* Part of: PROD's program probe
*
* Authors: Keijo Heljanko
*
* Current version:
*     $Id: dassert.h,v 3.1 1997/04/17 15:43:55 kepa Exp $
*
* Description:
*     Assertions, define ASSERT_DEBUG or DEBUG before compilation to
*     have assertions compiled in.
*
* Version history:
*     $Log: dassert.h,v $
 * Revision 3.1  1997/04/17  15:43:55  kepa
 * *** empty log message ***
 *
***************************************************************************/

#ifdef DEBUG
#ifndef ASSERT_DEBUG
#define ASSERT_DEBUG
#endif
#endif

#ifdef ASSERT_DEBUG
#define DEBUG_ASSERT(expr) assert(expr)
#else
#define DEBUG_ASSERT(expr)
#endif

#define ASSERT(expr) assert(expr)
