/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  alloc.c
*
* Part of: PROD's programs araprod, "gphgen", probe, prod, prpp,
*          strong, and t
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module is an interface to the "built-in" variable errno.
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#ifdef FIND_STRERROR
#include <string.h>
#include <errno.h>
#else
/* At this point, standard headers would merely complicate the
 * compilation. */
extern int errno;           /* the system error indicator */
extern char *sys_errlist[]; /* the messages associated with different
                             * values of errno */
#endif

#include "absolute.h"
#include "prod.h"
#include "error.h"


/***************************************************************************
*
* Function:  ClearErrno
* Purpose:   This routine clears the system error indicator.
* Arguments:
* Returns:
* See also:
*
****************************************************************************
*/
FE0(void, ClearErrno)
{
    errno = 0;
}

/***************************************************************************
*
* Function:  ErrnoVal
* Purpose:   This routine returns the value of the system error indicator.
* Arguments:
* Returns:   as said
* See also:
*
****************************************************************************
*/
FE0(int, ErrnoVal)
{
    return((int) errno);
}

/***************************************************************************
*
* Function:  SysErrStr
* Purpose:   This routine returns the potential error message associated
*            with a given integer value.
* Arguments: value - as said
* Returns:   as said
* See also:
*
****************************************************************************
*/
FE1(char *, SysErrStr,
    int, value)
{
    return(
#ifdef FIND_STRERROR
	   strerror(value)
#else
	   sys_errlist[value]
#endif
	   );
}
