/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  gen4.tpl
*
* Part of: PROD's program prpp
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See gen.tpl.
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include "gen.h"

/***************************************************************************
*
* Function:  ARoutine
* Purpose:   This routine produces the actions performed in Accept() in the
*            case that the net is not unfolded.
* Arguments:
* Returns:
* See also:  DRoutine, FRoutine
*
****************************************************************************
*/
FE0(void, ARoutine)
{
    ((void) fprintf(f, "FE0(void, _A%s", UnsStr(t)), (void) fprintf(f, ")/*%s*/\n", TraGName(transition)), nOutpLines++);
    ((void) fprintf(f, "{\n"), nOutpLines++);
    ADLimits();
    if (NetGAtoms(net))
	((void) fprintf(f, "    _visible = 1;\n"), nOutpLines++);
    if (TraGComputation(transition))
	{
	    if (NetGNofClasses(net) != 1)
		((void) fprintf(f, "    _list = _tmpBundle[_class];\n"), nOutpLines++);
	    if (dimension == iVarCount)
		{
		    ((void) fprintf(f, "    if (!LstEmpty(_list))\n"), nOutpLines++);
		    ((void) fprintf(f, "        return;\n"), nOutpLines++);
		    ((void) fprintf(f, "    LstSet(_list, (VOID *) NULL);\n"), nOutpLines++);
		}
	    else
		{
		    ((void) fprintf(f, "    _cursor = NULL;\n"), nOutpLines++);
		    ((void) fprintf(f, "    LSTFOR (_list, _peer, PEER)\n"), nOutpLines++);
		    ((void) fprintf(f, "        {\n"), nOutpLines++);
		    ((void) fprintf(f, "            _instance = PeeGInstance(_peer);\n"), nOutpLines++);
		    LSTNUM (TraGVariables(transition), variable,
			    VARIABLE, i)
			{
                            if (VarIsIn(variable))
				continue;
			    ((void) fprintf(f, "            if (_instance[%s", UnsStr(i)), (void) fprintf(f, "] >"));
			    ((void) fprintf(f, " %s)\n", VarGLabel(variable)), nOutpLines++);
			    ((void) fprintf(f, "                break;\n"), nOutpLines++);
			    ((void) fprintf(f, "            if (_instance[%s", UnsStr(i)), (void) fprintf(f, "] <"));
			    ((void) fprintf(f, " %s)\n", VarGLabel(variable)), nOutpLines++);
			    ((void) fprintf(f, "                {\n"), nOutpLines++);
			    ((void) fprintf(f, "                    _cursor = LstGet(_list);\n"), nOutpLines++);
			    ((void) fprintf(f, "                    continue;\n"), nOutpLines++);
			    ((void) fprintf(f, "                }\n"), nOutpLines++);
			}
		    ((void) fprintf(f, "            return;\n"), nOutpLines++);
		    ((void) fprintf(f, "        }\n"), nOutpLines++);
		    ((void) fprintf(f, "    LstSet(_list, _cursor);\n"), nOutpLines++);
		}
	}
    if (NetGNofClasses(net) != 1)
	{
	    ((void) fprintf(f, "    if (_kind[_class] == _CL_INHIBITOR)\n"), nOutpLines++);
	    ((void) fprintf(f, "        goto C_O_N_T;\n"), nOutpLines++);
	}
    ((void) fprintf(f, "    _folState = StaFrCopy(_state);\n"), nOutpLines++);
    LSTFOR (TraGOutputs(transition), arc, ARC)
	{
	    if (LstEmpty(ArcGSymsum(arc)))
		continue;
	    p = LstWhich(NetGPlaces(net), (char *)
			 ArcGPlace(arc)) - 1;
	    ((void) fprintf(f, "    _marking = StaGMarking(_folState, (unsigned) /*%s*/%s", PlaGName(ArcGPlace(arc)), UnsStr(p)), (void) fprintf(f, ");\n"), nOutpLines++);
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		{
		    if (SytGCffSym(symmultup))
			{
			    ((void) fprintf(f, "    if (0L != (unsigned long) ("));
			    PrintSymbol(f, SytGCffSym(symmultup));
			    ((void) fprintf(f, "))\n"), nOutpLines++);
			    ((void) fprintf(f, "        {\n"), nOutpLines++);
		            ((void) fprintf(f, "            _tuple ="));
                            ((void) fprintf(f, " TupCons((unsigned) %s", UnsStr(SytGArity(symmultup))), (void) fprintf(f, ");\n"), nOutpLines++);
			    for (i = 0; i < SytGArity(symmultup); i++)
				{
				    ((void) fprintf(f, "            TupSField(_tuple,"));
                                    ((void) fprintf(f, " (unsigned) %s", UnsStr(i)), (void) fprintf(f, ", (DOMAIN) ("));
				    PrintSymbol(f, SytGSymbol(symmultup, i));
				    ((void) fprintf(f, "));\n"), nOutpLines++);
				}
			    ((void) fprintf(f, "            MarInsert(_marking,"));
			    ((void) fprintf(f, " MultupCons((unsigned long) ("));
			    PrintSymbol(f, SytGCffSym(symmultup));
			    ((void) fprintf(f, "), _tuple));\n"), nOutpLines++);
			    ((void) fprintf(f, "        }\n"), nOutpLines++);
			}
		    else
			{
		            ((void) fprintf(f, "    _tuple ="));
                            ((void) fprintf(f, " TupCons((unsigned) %s", UnsStr(SytGArity(symmultup))), (void) fprintf(f, ");\n"), nOutpLines++);
			    for (i = 0; i < SytGArity(symmultup); i++)
				{
				    ((void) fprintf(f, "    TupSField(_tuple,"));
                                    ((void) fprintf(f, " (unsigned) %s", UnsStr(i)), (void) fprintf(f, ", (DOMAIN) ("));
				    PrintSymbol(f, SytGSymbol(symmultup, i));
				    ((void) fprintf(f, "));\n"), nOutpLines++);
				}
			    ((void) fprintf(f, "    MarInsert(_marking,"));
                            ((void) fprintf(f, " MultupCons((unsigned long)"));
                            ((void) fprintf(f, " %s", UlongStr(SytGMulti(symmultup))), (void) fprintf(f, ", _tuple));\n"), nOutpLines++);
			}
		}
	}
    if (NetGAtoms(net))
	{
	    if (TraGKind(transition) == TK_NORM)
		{
		    if (NetGNofClasses(net) != 1)
			{
			    ((void) fprintf(f, "    if (_kind[_class] != _CL_MEDIUM)\n"), nOutpLines++);
			    ((void) fprintf(f, "        _someEnb = TRUE;\n"), nOutpLines++);
			}
		    else
			{
			    ((void) fprintf(f, "    _someEnb = TRUE;\n"), nOutpLines++);
			}
		}
	    ((void) fprintf(f, "    _evalState = _folState;\n"), nOutpLines++);
	    ((void) fprintf(f, "    if (!((*_buchiOK)()))\n"), nOutpLines++);
	    ((void) fprintf(f, "        {\n"), nOutpLines++);
	    ((void) fprintf(f, "            StaDiscard(_folState);\n"), nOutpLines++);
	    if (NetGNofClasses(net) != 1)
		{
		    ((void) fprintf(f, "            goto C_O_N_T;\n"), nOutpLines++);
		}
	    else
		{
		    ((void) fprintf(f, "            return;\n"), nOutpLines++);
		}
	    ((void) fprintf(f, "        }\n"), nOutpLines++);
	}
    if (NetGNofClasses(net) != 1)
	{
	    ((void) fprintf(f, "    if (_kind[_class] == _CL_MEDIUM)\n"), nOutpLines++);
	    ((void) fprintf(f, "        {\n"), nOutpLines++);
	    ((void) fprintf(f, "            (void) StaEncode(_folState, EngABuffer(),"));
	    ((void) fprintf(f, " EngABufSize());\n"), nOutpLines++);
	    ((void) fprintf(f, "            StaDiscard(_folState);\n"), nOutpLines++);
	    if (!TraGComputation(transition))
		{
		    ((void) fprintf(f, "            (void) LstInsLast(_bundle[_class]"));
		}
            else
		{
		    ((void) fprintf(f, "            (void) LstInsNext(_list"));
		}
            ((void) fprintf(f, ", (char *)\n"), nOutpLines++);
            ((void) fprintf(f, "                              PeeCons((unsigned) %s", UnsStr(t)), (void) fprintf(f, ","));
            if (LstEmpty(TraGVariables(transition)))
		{
		    ((void) fprintf(f, " (DOMAIN *) NULL"));
		}
            else
		{
		    ((void) fprintf(f, " _v"));
		}
	    ((void) fprintf(f, ", EngBuffer(), _visible));\n"), nOutpLines++);
            ((void) fprintf(f, "            return;\n"), nOutpLines++);
            ((void) fprintf(f, "        }\n"), nOutpLines++);
	}
    ((void) fprintf(f, "    _len = StaEncode(_folState, EngABuffer(), EngABufSize());\n"), nOutpLines++);
    ((void) fprintf(f, "    _ndAddr = GphPutNode(_graph[0], EngBuffer(), _len, &_back);\n"), nOutpLines++);
    ((void) fprintf(f, "    _len = InsEncode((unsigned) %s", UnsStr(t)), (void) fprintf(f, ","));
    if (NetGNofClasses(net) != 1)
        ((void) fprintf(f, " _class,"));
    else
	((void) fprintf(f, " (unsigned) 0,"));
    if (LstEmpty(TraGVariables(transition)))
        ((void) fprintf(f, " (DOMAIN *) NULL"));
    else
        ((void) fprintf(f, " _v"));
    ((void) fprintf(f, ", EngABuffer(), EngABufSize());\n"), nOutpLines++);
    ((void) fprintf(f, "    _awAddr = GphPutArrow(_graph[0], EngBuffer(), _len,\n"), nOutpLines++);
    ((void) fprintf(f, "                          _awCount, PthEnd(nowPath), _ndAddr,\n"), nOutpLines++);
    ((void) fprintf(f, "                          _awFirst, _back,"));
    if (NetGMonPlace(net))
	((void) fprintf(f, " !_visible"));
    else
	((void) fprintf(f, " TRUE"));
    ((void) fprintf(f, ");\n"), nOutpLines++);
    ((void) fprintf(f, "    if (Ara())\n"), nOutpLines++);
    ((void) fprintf(f, "        AraStep(_visible);\n"), nOutpLines++);
    ((void) fprintf(f, "    if ((_awCount == 0L) || FreeExpansion())\n"), nOutpLines++);
    ((void) fprintf(f, "        {\n"), nOutpLines++);
    ((void) fprintf(f, "            _awFirst = _awAddr;\n"), nOutpLines++);
    ((void) fprintf(f, "            _ndFirst = _ndAddr;\n"), nOutpLines++);
    ((void) fprintf(f, "        }\n"), nOutpLines++);
    ((void) fprintf(f, "    _awCount++;\n"), nOutpLines++);
    if (NetGMonPlace(net))
	{
	    ((void) fprintf(f, "    if (((unsigned long) -1L) != _back)\n"), nOutpLines++);
            ((void) fprintf(f, "        {\n"), nOutpLines++);
            ((void) fprintf(f, "            if (InfNow())\n"), nOutpLines++);
            ((void) fprintf(f, "                IllInfTrace(TRUE);\n"), nOutpLines++);
	    ((void) fprintf(f, "            else if (DivNow() && !_visible)\n"), nOutpLines++);
            ((void) fprintf(f, "                IllDivTrace(TRUE);\n"), nOutpLines++);
	    ((void) fprintf(f, "        }\n"), nOutpLines++);
	    ((void) fprintf(f, "    else if (Reject() && _visible)\n"), nOutpLines++);
	    ((void) fprintf(f, "        IllTrace();\n"), nOutpLines++);
	}
    ((void) fprintf(f, "    StaDiscard(_folState);\n"), nOutpLines++);
    if (NetGNofClasses(net) != 1)
	{
	    ((void) fprintf(f, "C_O_N_T: ;\n"), nOutpLines++);
	}
    if ((NetGNofClasses(net) != 1) && !TraGComputation(transition))
	{
	    ((void) fprintf(f, "    if (_kind[_class] == _CL_INDEPENDENT)\n"), nOutpLines++);
	    ((void) fprintf(f, "        return;\n"), nOutpLines++);
	    ((void) fprintf(f, "    (void) LstInsLast(_bundle[_class]"));
	}
    else if (TraGComputation(transition))
	{
	    ((void) fprintf(f, "    (void) LstInsNext(_list"));
	}
    if ((NetGNofClasses(net) != 1) || TraGComputation(transition))
	{
            ((void) fprintf(f, ", (char *)\n"), nOutpLines++);
            ((void) fprintf(f, "                      PeeCons((unsigned) %s", UnsStr(t)), (void) fprintf(f, ","));
            if (LstEmpty(TraGVariables(transition)))
                ((void) fprintf(f, " (DOMAIN *) NULL"));
	    else
	        ((void) fprintf(f, " _v"));
            ((void) fprintf(f, ", (DATATYPE *) NULL, _visible));\n"), nOutpLines++);
        }
    ((void) fprintf(f, "}\n"), nOutpLines++);
}

/***************************************************************************
*
* Function:  DRoutine
* Purpose:   This routine produces the actions performed in Accept()
*            in the case that the net is unfolded.
* Arguments:
* Returns:
* See also:  ARoutine, ERoutine, IRoutine
*
****************************************************************************
*/
FE0(void, DRoutine)
{
    unsigned long *numBlock;

    ((void) fprintf(f, "FE0(void, _D%s", UnsStr(t)), (void) fprintf(f, ")/*%s*/\n", TraGName(transition)), nOutpLines++);
    ((void) fprintf(f, "{\n"), nOutpLines++);
    ADLimits();
    ((void) fprintf(f, "    (void) InsEncode((unsigned) %s", UnsStr(t)), (void) fprintf(f, ","));
    if (NetGNofClasses(net) != 1)
	((void) fprintf(f, " _class,"));
    else
        ((void) fprintf(f, " (unsigned) 0,"));
    if (LstEmpty(TraGVariables(transition)))
        ((void) fprintf(f, " (DOMAIN *) NULL"));
    else
	((void) fprintf(f, " _v"));
    ((void) fprintf(f, ", EngABuffer(), EngABufSize());\n"), nOutpLines++);
    ((void) fprintf(f, "    _trn = GetTrn("));
    if (NetGNofClasses(net) != 1)
	((void) fprintf(f, " _class,"));
    else
        ((void) fprintf(f, " (unsigned) 0,"));
    ((void) fprintf(f, " EngBuffer(), &_new);\n"), nOutpLines++);
    ((void) fprintf(f, "    if (!_new)\n"), nOutpLines++);
    ((void) fprintf(f, "        return;\n"), nOutpLines++);
    if (NetGAtoms(net))
	{
	    if (TraGKind(transition) == TK_DUMMY)
		((void) fprintf(f, "    TrnSDummy(_trn);\n"), nOutpLines++);
	    else if (TraGKind(transition) == TK_INITIAL)
		((void) fprintf(f, "    TrnSInitial(_trn);\n"), nOutpLines++);
            else if (!LstEmpty(TraGBlocks(transition)))
                {
                    ((void) fprintf(f, "    TrnSVisible(_trn);\n"), nOutpLines++);
                    ((void) fprintf(f, "    if (Blocked())\n"), nOutpLines++);
                    ((void) fprintf(f, "        {\n"), nOutpLines++);
                    ((void) fprintf(f, "            TrnABlocks(_trn, (unsigned)"));
                    ((void) fprintf(f, " %s", UnsStr(LstSize(TraGBlocks(transition)) + 1)), (void) fprintf(f, ");\n"), nOutpLines++);
                    LSTNUM (TraGBlocks(transition), numBlock,
                            unsigned long, i)
                        {
                            ((void) fprintf(f, "            (void) LstInsLast(Block((unsigned)"));
                            ((void) fprintf(f, " %s", UnsStr((unsigned) *numBlock)), (void) fprintf(f, "), (char *) _trn);\n"), nOutpLines++);
                            ((void) fprintf(f, "            TrnSBlock(_trn, (unsigned) %s", UnsStr(i)), (void) fprintf(f, ","));
                            ((void) fprintf(f, " (unsigned) %s", UnsStr((unsigned) *numBlock)), (void) fprintf(f, ");\n"), nOutpLines++);
                        }
                    ((void) fprintf(f, "            TrnSBlock(_trn, (unsigned) %s", UnsStr(i)), (void) fprintf(f, ","));
                    ((void) fprintf(f, " (unsigned) -1);\n"), nOutpLines++);
                    ((void) fprintf(f, "        }\n"), nOutpLines++);
                }
	}
    else
	{
	    ((void) fprintf(f, "    if (_visible)\n"), nOutpLines++);
	    ((void) fprintf(f, "        TrnSVisible(_trn);\n"), nOutpLines++);
	}
    LSTFOR (TraGInputs(transition), arc, ARC)
	{
	    if (LstEmpty(ArcGSymsum(arc)) ||
		(NetGAtoms(net) && (ArcGPlace(arc) == NetGMonPlace(net))))
		continue;
	    p = LstWhich(NetGPlaces(net), (char *) ArcGPlace(arc)) - 1;
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		{
		    if (SytGCffSym(symmultup))
			{
			    ((void) fprintf(f, "    if (0L != (unsigned long) ("));
		            PrintSymbol(f, SytGCffSym(symmultup));
		            ((void) fprintf(f, "))\n"), nOutpLines++);
		            ((void) fprintf(f, "        {\n"), nOutpLines++);
			    ((void) fprintf(f, "            TupSArity(_w, (unsigned)"));
			    ((void) fprintf(f, " %s", UnsStr(SytGArity(symmultup))), (void) fprintf(f, ");\n"), nOutpLines++);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            ((void) fprintf(f, "            TupSField(_w, (unsigned) %s", UnsStr(i)), (void) fprintf(f, ","));
			            if (SymIsVariable(symbol))
				        ((void) fprintf(f, " %s", VarGLabel(SymGVariable(symbol))));
			            else
				       {
					   ((void) fprintf(f, " (DOMAIN) ("));
	                                   PrintSymbol(f, symbol);
				           ((void) fprintf(f, ")"));
				       }
				    ((void) fprintf(f, ");\n"), nOutpLines++);
				}
		            ((void) fprintf(f, "            PutInArc(_trn, (unsigned long) ("));
		            PrintSymbol(f, SytGCffSym(symmultup));
                            ((void) fprintf(f, "), (unsigned) /*%s*/%s", PlaGName(ArcGPlace(arc)), UnsStr(p)), (void) fprintf(f, ", _w);\n"), nOutpLines++);
		            ((void) fprintf(f, "        }\n"), nOutpLines++);
			}
		    else
			{
			    ((void) fprintf(f, "    TupSArity(_w, (unsigned)"));
			    ((void) fprintf(f, " %s", UnsStr(SytGArity(symmultup))), (void) fprintf(f, ");\n"), nOutpLines++);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            ((void) fprintf(f, "    TupSField(_w, (unsigned) %s", UnsStr(i)), (void) fprintf(f, ","));
			            if (SymIsVariable(symbol))
				        ((void) fprintf(f, " %s", VarGLabel(SymGVariable(symbol))));
			            else
				       {
					   ((void) fprintf(f, " (DOMAIN) ("));
	                                   PrintSymbol(f, symbol);
				           ((void) fprintf(f, ")"));
				       }
				    ((void) fprintf(f, ");\n"), nOutpLines++);
				}
		            ((void) fprintf(f, "    PutInArc(_trn, (unsigned long)"));
                            ((void) fprintf(f, " %s", UlongStr(SytGMulti(symmultup))), (void) fprintf(f, ", (unsigned) /*%s*/%s", PlaGName(ArcGPlace(arc)), UnsStr(p)), (void) fprintf(f, ", _w);\n"), nOutpLines++);
			}
		}
	}
    LSTFOR (TraGOutputs(transition), arc, ARC)
	{
	    if (LstEmpty(ArcGSymsum(arc)) ||
		(NetGAtoms(net) && (ArcGPlace(arc) == NetGMonPlace(net))))
		continue;
	    p = LstWhich(NetGPlaces(net), (char *) ArcGPlace(arc)) - 1;
	    LSTFOR (ArcGSymsum(arc), symmultup, SYMMULTUP)
		{
		    if (SytGCffSym(symmultup))
			{
			    ((void) fprintf(f, "    if (0L != (unsigned long) ("));
		            PrintSymbol(f, SytGCffSym(symmultup));
		            ((void) fprintf(f, "))\n"), nOutpLines++);
		            ((void) fprintf(f, "        {\n"), nOutpLines++);
			    ((void) fprintf(f, "            TupSArity(_w, (unsigned)"));
			    ((void) fprintf(f, " %s", UnsStr(SytGArity(symmultup))), (void) fprintf(f, ");\n"), nOutpLines++);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            ((void) fprintf(f, "            TupSField(_w, (unsigned) %s", UnsStr(i)), (void) fprintf(f, ","));
			            if (SymIsVariable(symbol))
				        ((void) fprintf(f, " %s", VarGLabel(SymGVariable(symbol))));
			            else
				       {
					   ((void) fprintf(f, " (DOMAIN) ("));
	                                   PrintSymbol(f, symbol);
				           ((void) fprintf(f, ")"));
				       }
				    ((void) fprintf(f, ");\n"), nOutpLines++);
				}
		            ((void) fprintf(f, "            PutOutArc(_trn, (unsigned long) ("));
		            PrintSymbol(f, SytGCffSym(symmultup));
                            ((void) fprintf(f, "), (unsigned) /*%s*/%s", PlaGName(ArcGPlace(arc)), UnsStr(p)), (void) fprintf(f, ", _w);\n"), nOutpLines++);
		            ((void) fprintf(f, "        }\n"), nOutpLines++);
			}
		    else
			{
			    ((void) fprintf(f, "    TupSArity(_w, (unsigned)"));
			    ((void) fprintf(f, " %s", UnsStr(SytGArity(symmultup))), (void) fprintf(f, ");\n"), nOutpLines++);
		            for (i = 0; i < SytGArity(symmultup); i++)
			        {
			            symbol = SytGSymbol(symmultup, i);
			            ((void) fprintf(f, "    TupSField(_w, (unsigned) %s", UnsStr(i)), (void) fprintf(f, ","));
			            if (SymIsVariable(symbol))
				        ((void) fprintf(f, " %s", VarGLabel(SymGVariable(symbol))));
			            else
				       {
					   ((void) fprintf(f, " (DOMAIN) ("));
	                                   PrintSymbol(f, symbol);
				           ((void) fprintf(f, ")"));
				       }
				    ((void) fprintf(f, ");\n"), nOutpLines++);
				}
		            ((void) fprintf(f, "    PutOutArc(_trn, (unsigned long)"));
                            ((void) fprintf(f, " %s", UlongStr(SytGMulti(symmultup))), (void) fprintf(f, ", (unsigned) /*%s*/%s", PlaGName(ArcGPlace(arc)), UnsStr(p)), (void) fprintf(f, ", _w);\n"), nOutpLines++);
			}
		}
	}
    ((void) fprintf(f, "    TrnReform(_trn);\n"), nOutpLines++);
    ((void) fprintf(f, "}\n"), nOutpLines++);
}

/***************************************************************************
*
* Function:  ERoutine
* Purpose:   Together with DRoutine and IRoutine, this routine produces
*            the unfolding of a high level transition.
* Arguments:
* Returns:
* See also:  DRoutine, IRoutine, FRoutine
*
****************************************************************************
*/
FE0(void, ERoutine)
{
    ((void) fprintf(f, "FE0(void, _E%s", UnsStr(t)), (void) fprintf(f, ")/*%s*/\n", TraGName(transition)), nOutpLines++);
    ((void) fprintf(f, "{\n"), nOutpLines++);
    if (letVarCount)
        {
            LSTFOR (TraGVariables(transition), variable, VARIABLE)
                VarReset(variable);
            LSTFOR (TraGGates(transition), gate, SYMBOL)
                SymReset(symbol);
            if (letVarCount & 1)
                {
                    LSTFOR (TraGVariables(transition), variable, VARIABLE)
                        if (VarIsLet(variable))
                            {
                                VarSet(variable);
                                VarCEscape(variable);
                            }
                        else
                            break;
                    WhatNew(TraGArcs(transition), FALSE);
                }
            else
                {
                    i = 0;
                    LSTFOR (TraGVariables(transition), variable, VARIABLE)
                        if (VarIsLet(variable))
                            {
                                ((void) fprintf(f, "    %s =", VarGLabel(variable)));
                                ((void) fprintf(f, " TupGField(_w, (unsigned) %s", UnsStr(i)), (void) fprintf(f, ");\n"), nOutpLines++);
                                VarSet(variable);
                                VarCEscape(variable);
                                WhatNew(TraGArcs(transition), FALSE);
                                i++;
                            }
                }
        }
    if (NetGNofClasses(net) != 1)
	((void) fprintf(f, "    _class = 0;\n"), nOutpLines++);
    if (!NetGMonPlace(net))
	((void) fprintf(f, "    _visible = PtDefVis() ? 1 : 0;\n"), nOutpLines++);
    if (!TraGComputation(transition))
	((void) fprintf(f, "    _D%s", UnsStr(t)), (void) fprintf(f, "();\n"), nOutpLines++);
    else
	{
	    if (NetGNofClasses(net) != 1)
                ((void) fprintf(f, "#define Precedence(class) (_class = (class))\n"), nOutpLines++);
	    if (!NetGMonPlace(net))
		{
                    ((void) fprintf(f, "#define Visible() (_visible = 1)\n"), nOutpLines++);
                    ((void) fprintf(f, "#define Invisible() (_visible = 0)\n"), nOutpLines++);
		}
            ((void) fprintf(f, "#define Accept() _D%s", UnsStr(t)), (void) fprintf(f, "()\n"), nOutpLines++);
	    ((void) fprintf(f, "    {"));
	    LSTFOR (TraGComputation(transition), str, char)
		((void) fprintf(f, "%s", str));
	    ((void) fprintf(f, "}\n"), nOutpLines++);
	    if (NetGNofClasses(net) != 1)
                ((void) fprintf(f, "#undef Precedence\n"), nOutpLines++);
	    if (!NetGMonPlace(net))
		{
                    ((void) fprintf(f, "#undef Visible\n"), nOutpLines++);
                    ((void) fprintf(f, "#undef Invisible\n"), nOutpLines++);
		}
            ((void) fprintf(f, "#undef Accept\n"), nOutpLines++);
	}
    ((void) fprintf(f, "}\n"), nOutpLines++);
}
