/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  mace.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen, Kimmo Valkealahti, and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See lxymace.c and ytbmace.c.
*
* Version history:
*     $Log$
***************************************************************************/

DE0(int, yylex)
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#ifndef YY_NO_UNPUT
#define YY_NO_UNPUT
#endif
#ifdef yyparse
#undef yyparse
#endif
#define yyparse mace_yyparse
DE0(int, yyparse)
#ifdef yyerror
#undef yyerror
#endif
#define yyerror(m) ((void) fprintf(_err, "%s\n", m), (void) fflush(_err))
#ifdef yywrap
#undef yywrap
#endif
#define yywrap O_n_e
#ifdef YY_INPUT
#undef YY_INPUT
#endif
#define YY_INPUT(buf,result,max_size) \
do \
    {  \
	register int _c_, _i_, _j_; \
        register char *_p_; \
 \
	for (_i_ = 0, _j_ = (max_size), _p_ = (buf); \
             _j_-- && ((_c_ = MbufGet(ioBuf)) != (int) EOF) && \
             ((char) _c_) && ((_p_[_i_++] = (char) _c_) != '\n');) \
	    ; \
	(result) = _i_; \
    } while (0)
#ifdef ECHO
#undef ECHO
#endif
#define ECHO (void) fwrite(yytext, (size_t) yyleng, (size_t) 1, yyout)
#ifdef isatty
#undef isatty
#endif
#define isatty Z_e_r_o
#ifdef fileno
#undef fileno
#endif
#define fileno(file) ((int) 0) 
#ifdef YY_MALLOC_DECL
#undef YY_MALLOC_DECL
#endif
#define YY_MALLOC_DECL
#ifdef alloca
#undef alloca
#endif
#define alloca(n) Allocate(n)
#define malloc(n) Allocate(n)
#define calloc(m,n) AllocArray(m,n)
#define realloc(p,n) Reallocate(p,n)
#define free(p) Deallocate((char *) (p))
#ifdef stdin
#undef stdin
#endif
#define stdin _in
#ifdef stdout
#undef stdout
#endif
#define stdout _out
#ifdef stderr
#undef stderr
#endif
#define stderr _err

extern unsigned macePlc;

typedef union 
{
    LIST *strl;
    LIST *ll;
    struct
	{
	    unsigned start, length;
	} token;
    struct
	{
	    unsigned start, length;
	    MACPELEM *macpElem;
	} macp;
} YYSTYPE;
