/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  macptree.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See macptree.h.
*
* Version history:
*     $Log$
***************************************************************************/

typedef struct MACPELEM
{
    unsigned type;
    char *sid;   
    union
	{
	    unsigned slot;
	    unsigned arity;
	} ua;
    char **args;
    unsigned expCount;
    struct MACPELEM **exps;
} MACPELEM;

#define MacpAlloc() ((MACPELEM *) Allocate(sizeof(MACPELEM)))
extern TOOLS macpTools;
extern BALTOOLS macpBalTools;

extern BALTREE *probeMacros, *probeHelps;
extern unsigned mEvalTimes, mEvalLimit;

extern FILE *shmFile;
extern char *shdPrefix;

#define ML_CONST       1
#define ML_MACRO       2
#define ML_PARM        3
#define ML_STRING      4
#define ML_SLOT        5

typedef struct HELPITEM
{
    LIST *key;
    LIST *header;
    LIST *data;
} HELPITEM;

#define HelpAlloc() ((HELPITEM *) Allocate(sizeof(HELPITEM)))
extern BALTOOLS helpBalTools;

DE6(MACPELEM *, MacpCons,
    unsigned, type,
    char *, cid,
    unsigned, arity,
    char **, args,
    unsigned, expCount,
    MACPELEM **, exps)
DE1(MACPELEM *, MacpCopy,
    MACPELEM *, macpElem)
DE1(void, MacpDiscard,
    MACPELEM *, macpElem)
#ifdef DEBUG
DE2(void, MacpDump,
    MACPELEM *, macpElem,
    unsigned, depth)
#endif
DE2(int, MacpKeyCmp,
    MACPELEM *, macpElem,
    char *, key)
DE2(BOOL, MacpPrefix,
    MACPELEM *, macpElem,
    char *, prefix)
DE1(BOOL, ShowMacro,
    MACPELEM *, macpElem)
DE1(BOOL, ShowDef,
    char *, str)
DE1(BOOL, Undefine,
    char *, str)
DE4(void, Define,
    unsigned, type,
    char *, name,
    LIST *, argList,
    LIST *, defList)
DE2(LIST *, Evaluate,
    MACPELEM *, macpElem,
    LIST *, plist)
DE3(HELPITEM *, HelpCons,
    LIST *, key,
    LIST *, header,
    LIST *, data)
DE1(HELPITEM *, HelpCopy,
    HELPITEM *, helpItem)
DE1(void, HelpDiscard,
    HELPITEM *, helpItem)
#ifdef DEBUG
DE2(void, HelpDump,
    HELPITEM *, helpItem,
    unsigned, depth)
#endif
DE2(int, HelpKeyCmp,
    HELPITEM *, helpItem,
    LIST *, key)
DE2(BOOL, HelpPrefix,
    HELPITEM *, helpItem,
    LIST *, prefix)
DE0(void, ReadHelp)
DE1(void, HelpOutput,
    LIST *, strList)
