/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  macro.h
*
* Part of: PROD's program prpp
*
* Authors: Heikki Suonsivu and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See macro.c.
*
* Version history:
*     $Log$
***************************************************************************/

#define DV_DEFINE 1
#define DV_UNDEF 2
#define DV_IF 3
#define DV_IFDEF 4
#define DV_IFNDEF 5
#define DV_ELSE 6
#define DV_ENDIF 7
#define DV_INCLUDE 8
#define DV_ENUM 9
#define DV_PREC 10
#define DV_PLACE 11
#define DV_TRANS 12
#define DV_ENDTR 13
#define DV_TESTER 14
#define DV_VERIFY 15

typedef struct MACRO
{
    char *name;
    LIST *expand_scheme;
    int args;
    unsigned long flag;
} MACRO;

#define mc_visited(macrop) ((macrop)->flag & 1L)
#define mc_enter(macrop) ((macrop)->flag |= 1L)
#define mc_unvisit(macrop) ((macrop)->flag &= ~1L)
#define mc_instack(macrop) ((macrop)->flag & 2L)
#define mc_push(macrop) ((macrop)->flag |= 2L)
#define mc_pop(macrop) ((macrop)->flag &= ~2L)
#define mc_refers(macrop) ((macrop)->flag & 4L)
#define mc_cite(macrop) ((macrop)->flag |= 4L)
#define mc_unrefer(macrop) ((macrop)->flag &= ~4L)
#define mc_locked(macrop) ((macrop)->flag >> 3)
#define mc_inclock(macrop) ((macrop)->flag += 8L)
#define mc_declock(macrop) ((macrop)->flag -= 8L)

DE0(void, macro_init)
DE1(MACRO *, ismacro,
    char *, name)
DE1(int, isdirective,
    char *, name)
DE1(void, undefine_macro,
    MACRO *, macrop)
DE3(MACRO *, memorize_macro,
    char *, name,
    LIST *, args,
    LIST *, body)
DE2(void, expand_macro,
    MACRO *, macrop,
    LIST **, args)
#ifdef TRAIN
DE1(char *, simple_expansion,
    MACRO *, macrop)
#endif
