/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  ptvisit2.c
*
* Part of: PROD's programs araprod and "gphgen"
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See ptvisit.c.
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include <stdio.h>
#include "absolute.h"
#include "prod.h"
#include "alloc.h"
#include "dynam.h"
#include "ptrbl.h"
#include "baltree.h"
#include "bdd.h"
#include "gphutil.h"
#include "graph.h"
#include "mark.h"
#include "encode.h"
#include "ptnet.h"

/***************************************************************************
*
* Function:  TrnEnMsIn
* Purpose:   This is an auxiliary routine for TrnStub
* Arguments: trn - a transition
* Returns:
* See also:  TrnStub
*
****************************************************************************
*/
FE1(void, TrnEnMsIn,
    TRN *, trn)
{
    switch (TrnGWhere(trn))
        {
        case 1:
            TrnSWhere(trn, (unsigned) 0);
            goto L1;
        case 2:
            TrnSWhere(trn, (unsigned) 0);
            goto L2;
        case 3:
            TrnSWhere(trn, (unsigned) 0);
            goto L3;
        case 4:
            TrnSWhere(trn, (unsigned) 0);
            goto L4;
        }
    LSTFOR (TrnGMosIn(trn), ptTrDrc, TRDRC)
	{
	    ptPlc = TrDrcGPlc(ptTrDrc);
	    if (PlcGPurOut(ptPlc))
		LSTFOR (PlcGPurOut(ptPlc), ptPlArc, PLARC)
		    {
			ptTrn = PlArcGTrn(ptPlArc);
			ptV = TrnGVal(ptTrn);
			if (ptV == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGPurOut(ptPlc)));
                                TrnSWhere(trn, (unsigned) 1);
                                return;
L1: ;
				if ((PtSzBest() == 1L) ||
				    (PtLazy() && (PtBest() != 0L)))
				    return;
				ptTrDrc = (TRDRC *)
				    LstThis(TrnGMosIn(trn));
				ptPlc = TrDrcGPlc(ptTrDrc);
                                LstSet(PlcGPurOut(ptPlc), TrnGCursor(trn));
				ptPlArc = (PLARC *)
				    LstThis(PlcGPurOut(ptPlc));
				ptTrn = PlArcGTrn(ptPlArc);
			    }
                        if (ptV < TrnGMin(trn))
                            TrnSMin(trn, ptV);
			if (TrnSatisfied(ptTrn))
			    TrnFeed(trn);
		    }
	    if (PlcGMosOut(ptPlc))
		LSTFOR (PlcGMosOut(ptPlc), ptPlDrc, PLDRC)
		    {
			ptTrn = PlDrcGTrn(ptPlDrc);
			ptV = TrnGVal(ptTrn);
			if (ptV == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGMosOut(ptPlc)));
                                TrnSWhere(trn, (unsigned) 2);
                                return;
L2: ;
				if ((PtSzBest() == 1L) ||
				    (PtLazy() && (PtBest() != 0L)))
				    return;
				ptTrDrc = (TRDRC *)
				    LstThis(TrnGMosIn(trn));
				ptPlc = TrDrcGPlc(ptTrDrc);
                                LstSet(PlcGMosOut(ptPlc), TrnGCursor(trn));
				ptPlDrc = (PLDRC *)
				    LstThis(PlcGMosOut(ptPlc));
				ptTrn = PlDrcGTrn(ptPlDrc);
			    }
                        if (ptV < TrnGMin(trn))
                            TrnSMin(trn, ptV);
			if (TrnSatisfied(ptTrn))
			    TrnFeed(trn);
		    }
	    ptLimit = PlcGCount(ptPlc)
		- TrDrcGIn(ptTrDrc) + TrDrcGOut(ptTrDrc);
	    if (PlcGNeutral(ptPlc))
		LSTFOR (PlcGNeutral(ptPlc), ptPlArc, PLARC)
		    {
			if (PlArcGWeight(ptPlArc) <= ptLimit)
			    continue;
			ptTrn = PlArcGTrn(ptPlArc);
			ptV = TrnGVal(ptTrn);
			if (ptV == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGNeutral(ptPlc)));
                                TrnSWhere(trn, (unsigned) 3);
                                return;
L3: ;
				if ((PtSzBest() == 1L) ||
				    (PtLazy() && (PtBest() != 0L)))
				    return;
				ptTrDrc = (TRDRC *)
				    LstThis(TrnGMosIn(trn));
				ptPlc = TrDrcGPlc(ptTrDrc);
				ptLimit = PlcGCount(ptPlc)
				    - TrDrcGIn(ptTrDrc)
					+ TrDrcGOut(ptTrDrc);
                                LstSet(PlcGNeutral(ptPlc), TrnGCursor(trn));
				ptPlArc = (PLARC *)
				    LstThis(PlcGNeutral(ptPlc));
				ptTrn = PlArcGTrn(ptPlArc);
			    }
                        if (ptV < TrnGMin(trn))
                            TrnSMin(trn, ptV);
			if (TrnSatisfied(ptTrn))
			    TrnFeed(trn);
		    }
	    if (PlcGMosIn(ptPlc))
		LSTFOR (PlcGMosIn(ptPlc), ptPlDrc, PLDRC)
		    {
			if (PlDrcGOut(ptPlDrc) <= ptLimit)
			    continue;
			ptTrn = PlDrcGTrn(ptPlDrc);
			ptV = TrnGVal(ptTrn);
			if (ptV == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGMosIn(ptPlc)));
                                TrnSWhere(trn, (unsigned) 4);
                                return;
L4: ;
				if ((PtSzBest() == 1L) ||
				    (PtLazy() && (PtBest() != 0L)))
				    return;
				ptTrDrc = (TRDRC *)
				    LstThis(TrnGMosIn(trn));
				ptPlc = TrDrcGPlc(ptTrDrc);
				ptLimit = PlcGCount(ptPlc)
				    - TrDrcGIn(ptTrDrc)
					+ TrDrcGOut(ptTrDrc);
                                LstSet(PlcGMosIn(ptPlc), TrnGCursor(trn));
				ptPlDrc = (PLDRC *)
				    LstThis(PlcGMosIn(ptPlc));
				ptTrn = PlDrcGTrn(ptPlDrc);
			    }
                        if (ptV < TrnGMin(trn))
                            TrnSMin(trn, ptV);
			if (TrnSatisfied(ptTrn))
			    TrnFeed(trn);
		    }
	}
}

/***************************************************************************
*
* Function:  TrnTivis
* Purpose:   This is an auxiliary routine for TrnStub.
* Arguments: trn - a transition
* Returns:
* See also:  TrnStub
*
****************************************************************************
*/
FE1(void, TrnTivis,
    TRN *, trn)
{
    switch (TrnGWhere(trn) >> 3)
        {
        case 1:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L1;
        case 2:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L2;
        case 3:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L3;
        case 4:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L4;
        case 5:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L5;
        case 6:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L6;
        case 7:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L7;
        case 8:
                TrnSWhere(trn, TrnGWhere(trn) & 7);
                goto L8;
        }
    (void) LstInsFirst(PtList(), (char *) trn);
    PtINow();
    TrnSVal(trn, PtNow());
    TrnSMin(trn, PtNow());
    if (!TrnEnabled(trn))
	{
	    ptV = 0L;
	    if (PlRnd())
		{
		    if (TrnGPurIn(trn))
			LSTFOR (TrnGPurIn(trn), ptTrArc, TRARC)
			    if (PlcGCount(TrArcGPlc(ptTrArc)) <
				TrArcGWeight(ptTrArc))
				ptV++;
		    if (TrnGNeutral(trn))
			LSTFOR (TrnGNeutral(trn), ptTrArc, TRARC)
			    if (PlcGCount(TrArcGPlc(ptTrArc)) <
				TrArcGWeight(ptTrArc))
				ptV++;
		    if (TrnGMosIn(trn))
			LSTFOR (TrnGMosIn(trn), ptTrDrc, TRDRC)
			    if (PlcGCount(TrDrcGPlc(ptTrDrc)) <
				TrDrcGIn(ptTrDrc))
				ptV++;
		    if (TrnGMosOut(trn))
			LSTFOR (TrnGMosOut(trn), ptTrDrc, TRDRC)
			    if (PlcGCount(TrDrcGPlc(ptTrDrc)) <
				TrDrcGIn(ptTrDrc))
				ptV++;
		    ptV = (unsigned long) PtRandom((UNS32) ptV);
		}
	    if (TrnGPurIn(trn) && !LstEmpty(TrnGPurIn(trn)))
		{
L1: ;
                    if (TrnDsPrIn(trn))
                        {
                            if (!TrnGWhere(trn))
                                goto VISCONT;
                            TrnSWhere(trn, TrnGWhere(trn) | (1 << 3));
                            return;
                        }
		}
	    if (TrnGNeutral(trn) && !LstEmpty(TrnGNeutral(trn)))
		{
L2: ;
                    if (TrnDsNeutral(trn))
                        {
                            if (!TrnGWhere(trn))
                                goto VISCONT;
                            TrnSWhere(trn, TrnGWhere(trn) | (2 << 3));
                            return;
                        }
		}
	    if (TrnGMosIn(trn) && !LstEmpty(TrnGMosIn(trn)))
		{
L3: ;
                    if (TrnDsMsIn(trn))
                        {
                            if (!TrnGWhere(trn))
                                goto VISCONT;
                            TrnSWhere(trn, TrnGWhere(trn) | (3 << 3));
                            return;
                        }
		}
	    if (TrnGMosOut(trn) && !LstEmpty(TrnGMosOut(trn)))
		{
L4: ;
                    if (TrnDsMsOut(trn))
                        {
                            if (!TrnGWhere(trn))
                                goto VISCONT;
                            TrnSWhere(trn, TrnGWhere(trn) | (4 << 3));
                            return;
                        }
		}
	VISCONT: ;
	    if ((PtSzBest() == 1L) || (PtLazy() && (PtBest() != 0L)))
                {
                    ptV = 0L;
                    return;
                }
	}
    else
	{
	    if (TrnGNeutral(trn) && !LstEmpty(TrnGNeutral(trn)))
		{
L5: ;
                    TrnEnNeutral(trn);
                    if (TrnGWhere(trn))
                        {
                            TrnSWhere(trn, TrnGWhere(trn) | (5 << 3));
                            return;
                        }
		    if ((PtSzBest() == 1L) || (PtLazy() && (PtBest() != 0L)))
                        {
                            ptV = 0L;
                            return;
                        }
		}
	    if (TrnGMosOut(trn) && !LstEmpty(TrnGMosOut(trn)))
		{
L6: ;
                    TrnEnMsOut(trn);
                    if (TrnGWhere(trn))
                        {
                            TrnSWhere(trn, TrnGWhere(trn) | (6 << 3));
                            return;
                        }
		    if ((PtSzBest() == 1L) || (PtLazy() && (PtBest() != 0L)))
                        {
                            ptV = 0L;
                            return;
                        }
		}
	    if (TrnGPurIn(trn) && !LstEmpty(TrnGPurIn(trn)))
		{
L7: ;
                    TrnEnPrIn(trn);
                    if (TrnGWhere(trn))
                        {
                            TrnSWhere(trn, TrnGWhere(trn) | (7 << 3));
                            return;
                        }
		    if ((PtSzBest() == 1L) || (PtLazy() && (PtBest() != 0L)))
                        {
                            ptV = 0L;
                            return;
                        }
		}
	    if (TrnGMosIn(trn) && !LstEmpty(TrnGMosIn(trn)))
		{
L8: ;
                    TrnEnMsIn(trn);
                    if (TrnGWhere(trn))
                        {
                            TrnSWhere(trn, TrnGWhere(trn) | (8 << 3));
                            return;
                        }
		    if ((PtSzBest() == 1L) || (PtLazy() && (PtBest() != 0L)))
                        {
                            ptV = 0L;
                            return;
                        }
		}
	}
    if (TrnGMin(trn) != TrnGVal(trn))
        {
            ptV = TrnGMin(trn);
            return;
        }
    ptV = ((unsigned long) -1L) - PtSgCount();
    if (!TrnSatisfied(trn))
        {
            ptSz = 0L;
            ptTrn = (TRN *) LstBegin(PtList());
            ptVisible = NULL;
            ptInvisible = NULL;
            while (TRUE)
                {
                    if (TrnEnabled(ptTrn))
                        {
                            if (TrnVisible(ptTrn))
                                ptVisible = ptTrn;
                            else
                                ptInvisible = ptTrn;
                            ptSz++;
                            TrnFeed(trn);
                        }
                    if (ptTrn == trn)
                        break;
                    ptTrn = (TRN *) LstStep(PtList());
                }
            if (TrnSatisfied(trn) && (ptSz < PtSzBest())
                && ((!PtCFFD()) || !ptVisible)
                && ((!OnTheFly()) || PtCFFD() || ptInvisible))
                {
                    PtSzSBest(ptSz);
                    PtSetBest(ptV);
                    PtSKingTrn(ptInvisible);
                }
        }
        do
            {
                ptTrn = (TRN *) LstDelFirst(PtList(), FALSE);
                TrnSVal(ptTrn, ptV);
                if (TrnSatisfied(trn))
                    TrnFeed(ptTrn);
                if ((!PtKingTrn()) && TrnEnabled(ptTrn) &&
                    !TrnVisible(ptTrn))
                    PtSKingTrn(ptTrn);
            } while (ptTrn != trn);
        PtISgCount();
}

/***************************************************************************
*
* Function:  TrnVisit
* Purpose:   This is an auxiliary routine for TrnStub.
* Arguments: trn - a transition
* Returns:
* See also:  TrnStub
*
****************************************************************************
*/
FE1(void, TrnVisit,
    TRN *, trn)
{
    while (TRUE)
        {
            TrnTivis(trn);
            if (TrnGWhere(trn))
                {
                    TrnSDown(ptTrn, trn);
                    trn = ptTrn;
                }
            else if ((PtSzBest() == 1L) || (PtLazy() && (PtBest() != 0L)))
                {
                    while (TrnGDown(trn))
                        {
                            ptTrn = TrnGDown(trn);
                            TrnCDown(trn);
                            trn = ptTrn;
                            TrnSWhere(trn, (unsigned) 0);
                        }
                    return;
                }
            else if (TrnGDown(trn))
                {
                    ptTrn = TrnGDown(trn);
                    TrnCDown(trn);
                    trn = ptTrn;
                }
            else
                return;
        }
}

/***************************************************************************
*
* Function:  TrnStub
* Purpose:   The construction of a stubborn set in the incremental
*            algorithm is normally done with the aid of this routine.
* Arguments: trn - a transition
* Returns:   TRUE if and only if an acceptable preliminary stubborn set
*            has been found
* See also:  TrnVisStub
*
****************************************************************************
*/
FE1(BOOL, TrnStub,
    TRN *, trn)
{
    if (TrnEnabled(trn) && (TrnGVal(trn) == 0L) &&
	(((!PtCFFD()) && !OnTheFly()) || !TrnVisible(trn)))
	{
	    if (PtLazy())
		{
		    if (PtCFFD() || (PtDCounter() == 0L))
			{
                            TrnVisit(trn);
			    if (PtBest() != 0L)
				return(TRUE);
			}
		}
	    else
		{
                    TrnVisit(trn);
		    if (PtSzBest() == 1L)
			return(TRUE);
		}
	}
    return(FALSE);
}

/***************************************************************************
*
* Function:  TrnDvPrIn
* Purpose:   This is an auxiliary routine of TrnSpan.
* Arguments: trn - a transition
* Returns:
* See also:  TrnSpan
*
****************************************************************************
*/
FE1(BOOL, TrnDvPrIn,
    TRN *, trn)
{
    switch (TrnGWhere(trn))
        {
        case 1:
            TrnSWhere(trn, (unsigned) 0);
            goto L1;
        case 2:
            TrnSWhere(trn, (unsigned) 0);
            goto L2;
        }
    LSTFOR (TrnGPurIn(trn), ptTrArc, TRARC)
	{
	    ptPlc = TrArcGPlc(ptTrArc);
	    if (PlcGCount(ptPlc) >= TrArcGWeight(ptTrArc))
		continue;
	    if (ptV-- != 0L)
		continue;
	    if (PlcGPurIn(ptPlc))
		LSTFOR (PlcGPurIn(ptPlc), ptPlArc, PLARC)
		    {
			ptTrn = PlArcGTrn(ptPlArc);
			if (TrnGVal(ptTrn) == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGPurIn(ptPlc)));
                                TrnSWhere(trn, (unsigned) 1);
                                return(TRUE);
L1: ;
				ptTrArc = (TRARC *)
				    LstThis(TrnGPurIn(trn));
				ptPlc = TrArcGPlc(ptTrArc);
                                LstSet(PlcGPurIn(ptPlc), TrnGCursor(trn));
			    }
		    }
	    ptLimit = PlcGCount(ptPlc);
	    if (PlcGMosIn(ptPlc))
		LSTFOR (PlcGMosIn(ptPlc), ptPlDrc, PLDRC)
		    {
			if (PlDrcGOut(ptPlDrc) > ptLimit)
			    continue;
			ptTrn = PlDrcGTrn(ptPlDrc);
			if (TrnGVal(ptTrn) == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGMosIn(ptPlc)));
                                TrnSWhere(trn, (unsigned) 2);
                                return(TRUE);
L2: ;
				ptTrArc = (TRARC *)
				    LstThis(TrnGPurIn(trn));
				ptPlc = TrArcGPlc(ptTrArc);
				ptLimit = PlcGCount(ptPlc);
                                LstSet(PlcGMosIn(ptPlc), TrnGCursor(trn));
			    }
		    }
	    return(TRUE);
	}
    return(FALSE);
}

/***************************************************************************
*
* Function:  TrnDvNeutral
* Purpose:   This is an auxiliary routine of TrnSpan.
* Arguments: trn - a transition
* Returns:
* See also:  TrnSpan
*
****************************************************************************
*/
FE1(BOOL, TrnDvNeutral,
    TRN *, trn)
{
    switch (TrnGWhere(trn))
        {
        case 1:
            TrnSWhere(trn, (unsigned) 0);
            goto L1;
        case 2:
            TrnSWhere(trn, (unsigned) 0);
            goto L2;
        }
    LSTFOR (TrnGNeutral(trn), ptTrArc, TRARC)
	{
	    ptPlc = TrArcGPlc(ptTrArc);
	    if (PlcGCount(ptPlc) >= TrArcGWeight(ptTrArc))
		continue;
	    if (ptV-- != 0L)
		continue;
	    if (PlcGPurIn(ptPlc))
		LSTFOR (PlcGPurIn(ptPlc), ptPlArc, PLARC)
		    {
			ptTrn = PlArcGTrn(ptPlArc);
			if (TrnGVal(ptTrn) == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGPurIn(ptPlc)));
                                TrnSWhere(trn, (unsigned) 1);
                                return(TRUE);
L1: ;
				ptTrArc = (TRARC *)
				    LstThis(TrnGNeutral(trn));
				ptPlc = TrArcGPlc(ptTrArc);
                                LstSet(PlcGPurIn(ptPlc), TrnGCursor(trn));
			    }
		    }
	    ptLimit = PlcGCount(ptPlc);
	    if (PlcGMosIn(ptPlc))
		LSTFOR (PlcGMosIn(ptPlc), ptPlDrc, PLDRC)
		    {
			if (PlDrcGOut(ptPlDrc) > ptLimit)
			    continue;
			ptTrn = PlDrcGTrn(ptPlDrc);
			if (TrnGVal(ptTrn) == 0L)
			    {
                                TrnSCursor(trn, LstGet(PlcGMosIn(ptPlc)));
                                TrnSWhere(trn, (unsigned) 2);
                                return(TRUE);
L2: ;
				ptTrArc = (TRARC *)
				    LstThis(TrnGNeutral(trn));
				ptPlc = TrArcGPlc(ptTrArc);
				ptLimit = PlcGCount(ptPlc);
                                LstSet(PlcGMosIn(ptPlc), TrnGCursor(trn));
			    }
		    }
	    return(TRUE);
	}
    return(FALSE);
}
