/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  sgsig.c
*
* Part of: PROD's program strong
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module takes care of the signal handling of the "strong"
*     program.
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include <stdio.h>
#ifdef UNIX
#include <sys/types.h>
#include <unistd.h>
#endif
#include <signal.h>
#include "absolute.h"
#include "prod.h"
#include "alloc.h"
#include "dynam.h"
#include "sgsig.h"

/***************************************************************************
*
* Function:  IgnoreSignals
* Purpose:   This routine forces certain signals to be ignored.
* Arguments:
* Returns:
* See also:
*
****************************************************************************
*/
FE0(void, IgnoreSignals)
{
#ifndef _WINDOWS
    (void) signal(SIGINT, SIG_IGN);
#endif
#ifdef UNIX
    (void) signal(SIGHUP, SIG_IGN);
    (void) signal(SIGQUIT, SIG_IGN);
    (void) signal(SIGTERM, SIG_IGN);
#endif
}
