/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  temporal.h
*
* Part of: PROD's program probe
*
* Authors: Keijo Heljanko
*
* Current version:
*     $Id: temporal.h,v 3.1 1997/04/17 15:44:16 kepa Exp $
*
* Description:
*     See temporal.c.
*
* Version history:
*     $Log: temporal.h,v $
 * Revision 3.1  1997/04/17  15:44:16  kepa
 * *** empty log message ***
 *
***************************************************************************/

/* The following typedefs are not final! */

typedef unsigned long NODE;
typedef unsigned long SUCC_NUM;
typedef unsigned long DFSARRAY;
typedef unsigned long DFS_NUM;


typedef struct _graph_succ
{
    unsigned long *cad;            /* CTL arrow address table. */
    unsigned long *caw;            /* CTL successor node table. */
} GRAPH_SUCC;

#define DFS_START 1
#define DFS_ONE 1

#define SetDfsArray(root, s, val) (root)[(s)] = (val)
#define GetDfsArray(root, s) ((root)[(s)])
#define NO_SUCCESSOR ((unsigned long) ~((unsigned long) 0L))
#define GetSuccessor(g, s, succ_num) \
((g)->caw[(g)->cad[(s)] + (succ_num)])

/* The real "meat" of the CTL model checker is here. */

DE7(BOOL, CheckEX,
    NODE, s,
    BITARRAY *, f1,
    BITARRAY *, f2,
    GRAPH_SUCC *, g,
    unsigned long, num_states,
    BOOL, top_level,
    STACK *, path)
DE7(BOOL, CheckAX,
    NODE, s,
    BITARRAY *, f1,
    BITARRAY *, f2,
    GRAPH_SUCC *, g,
    unsigned long, num_states,
    BOOL, top_level,
    STACK *, path)
DE2(void, InitBits,
    BITARRAY *, f1,
    BITARRAY *, f2)
DE7(BOOL, CheckAU,
    NODE, s,
    BITARRAY *, f1,
    BITARRAY *, f2,
    GRAPH_SUCC *, g,
    unsigned long, num_states,
    BOOL, top_level,
    STACK *, path)
DE6(BOOL, VisitAU,
    NODE, s,
    BITARRAY *, f,
    BITARRAY *, marked,
    STACK *, st,
    STACK *, sn,
    GRAPH_SUCC *, g)
DE7(BOOL, CheckEU,
    NODE, s,
    BITARRAY *, f1,
    BITARRAY *, f2,
    GRAPH_SUCC *, g,
    unsigned long, num_states,
    BOOL, top_level,
    STACK *, path)
DE9(BOOL, VisitEU,
    NODE, s,
    BITARRAY *, f,
    BITARRAY *, marked,
    BITARRAY *, modify,
    STACK *, st,
    STACK *, sn,
    STACK *, cst,
    DFSARRAY *, root,
    GRAPH_SUCC *, g)
