/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  token.h
*
* Part of: PROD's program prpp
*
* Authors: Heikki Suonsivu and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module defines the types of tokens. See also lexer.c.
*
* Version history:
*     $Log$
***************************************************************************/

#define PP_TOKEN_TYPE int

#define OPENING_BRACKET 0
#define OPENING_SQUARE_BRACKET 1
#define OPENING_PARENTHESIS 2
#define TUPLE_LEFT 3
#define QUOTED_EXPRESSION 4
#define SPACE 5
#define NAME 6
#define DV 7
#define SPECIAL 8
#define CLOSING_BRACKET 9
#define CLOSING_SQUARE_BRACKET 10
#define CLOSING_PARENTHESIS 11
#define NEWLINE 12
#define NUMBER 13
#define NOT 14
#define BINARY_NOT 15
#define MULTIPLY 16
#define DIVIDE 17
#define REMAINDER 18
#define PLUS 19
#define MINUS 20
#define SHIFT_LEFT 21
#define SHIFT_RIGHT 22
#define LESS_THAN 23
#define LESS_THAN_OR_EQUAL 24
#define MORE_THAN 25
#define MORE_THAN_OR_EQUAL 26
#define EQUAL 27
#define NOT_EQUAL 28
#define BINARY_AND 29
#define BINARY_XOR 30
#define BINARY_OR 31
#define AND 32
#define OR 33
#define CONDITIONAL 34
#define COLON 35
#define COMMA 36
#define TUPLE_RIGHT 37
#define TUPLE_RANGE 38
#define SEMICOLON 39
#define COMMENT 40
#define NOTHING 41
#define NEVERMATCH 42

typedef struct PP_TOKEN
{
    char *token;
    PP_TOKEN_TYPE type;
} PP_TOKEN;

DE2(PP_TOKEN *, PpTokCons,
    char *, s,
    PP_TOKEN_TYPE, type)
DE1(void, PpTokDracsid,
    PP_TOKEN *, token)
#define PpTokDiscard(token) (PpTokDracsid(token), (token) = (PP_TOKEN *) NULL)
extern TOOLS ppTokTools;

extern PP_TOKEN_TYPE closing_bracket_pair[4];
