/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.hlpn.booleans.util;

import java.util.Map;

import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.util.EObjectValidator;
import org.eclipse.ocl.ParserException;
import org.eclipse.ocl.Query;
import org.eclipse.ocl.ecore.Constraint;
import org.eclipse.ocl.ecore.OCL;

import fr.lip6.move.pnml.hlpn.booleans.And;
import fr.lip6.move.pnml.hlpn.booleans.Bool;
import fr.lip6.move.pnml.hlpn.booleans.BooleanConstant;
import fr.lip6.move.pnml.hlpn.booleans.BooleanOperator;
import fr.lip6.move.pnml.hlpn.booleans.BooleansPackage;
import fr.lip6.move.pnml.hlpn.booleans.Equality;
import fr.lip6.move.pnml.hlpn.booleans.Imply;
import fr.lip6.move.pnml.hlpn.booleans.Inequality;
import fr.lip6.move.pnml.hlpn.booleans.Not;
import fr.lip6.move.pnml.hlpn.booleans.Or;
import fr.lip6.move.pnml.hlpn.terms.util.TermsValidator;

/**
 * <!-- begin-user-doc --> The <b>Validator</b> for the model. <!--
 * end-user-doc -->
 * @see fr.lip6.move.pnml.hlpn.booleans.BooleansPackage
 * @generated
 */
public class BooleansValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final BooleansValidator INSTANCE = new BooleansValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "fr.lip6.move.pnml.hlpn.booleans";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * The cached base package validator.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected TermsValidator termsValidator;

	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint equality_inputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint inequality_inputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>InputSize</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint or_InputSizeInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>InputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint booleanOperator_InputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>InputSize</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint and_InputSizeInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>InputSize</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint imply_InputSizeInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>InputSize</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint not_InputSizeInvOCL;
	private static final String OCL_ANNOTATION_SOURCE = "http://www.pnml.org/models/OCL";

	private static final OCL OCL_ENV = OCL.newInstance();

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public BooleansValidator() {
		super();
		termsValidator = TermsValidator.INSTANCE;
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
		return BooleansPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
		case BooleansPackage.EQUALITY:
			return validateEquality((Equality) value, diagnostics, context);
		case BooleansPackage.INEQUALITY:
			return validateInequality((Inequality) value, diagnostics, context);
		case BooleansPackage.BOOLEAN_CONSTANT:
			return validateBooleanConstant((BooleanConstant) value,
					diagnostics, context);
		case BooleansPackage.OR:
			return validateOr((Or) value, diagnostics, context);
		case BooleansPackage.BOOLEAN_OPERATOR:
			return validateBooleanOperator((BooleanOperator) value,
					diagnostics, context);
		case BooleansPackage.AND:
			return validateAnd((And) value, diagnostics, context);
		case BooleansPackage.IMPLY:
			return validateImply((Imply) value, diagnostics, context);
		case BooleansPackage.NOT:
			return validateNot((Not) value, diagnostics, context);
		case BooleansPackage.BOOL:
			return validateBool((Bool) value, diagnostics, context);
		default:
			return true;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEquality(Equality equality,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(equality,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(equality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(equality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(equality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(equality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(equality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(equality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					equality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateEquality_inputOutputTypes(equality, diagnostics,
					context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>Equality</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEquality_inputOutputTypes(Equality equality,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (equality_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(BooleansPackage.Literals.EQUALITY);

			EAnnotation ocl = BooleansPackage.Literals.EQUALITY
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				equality_inputOutputTypesInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(equality_inputOutputTypesInvOCL);

		if (!query.check(equality)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "inputOutputTypes",
										getObjectLabel(equality, context) }),
						new Object[] { equality }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInequality(Inequality inequality,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(inequality,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(inequality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(inequality,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(inequality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(inequality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(inequality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(inequality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					inequality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateInequality_inputOutputTypes(inequality,
					diagnostics, context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>Inequality</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInequality_inputOutputTypes(Inequality inequality,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (inequality_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(BooleansPackage.Literals.INEQUALITY);

			EAnnotation ocl = BooleansPackage.Literals.INEQUALITY
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				inequality_inputOutputTypesInvOCL = helper
						.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(inequality_inputOutputTypesInvOCL);

		if (!query.check(inequality)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "inputOutputTypes",
										getObjectLabel(inequality, context) }),
						new Object[] { inequality }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBooleanConstant(BooleanConstant booleanConstant,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(booleanConstant,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(booleanConstant,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(booleanConstant,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(booleanConstant, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(booleanConstant, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(booleanConstant, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(booleanConstant,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					booleanConstant, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateOr(Or or, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(or, diagnostics,
				context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(or, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(or, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(or, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(or, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(or, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(or, diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(or,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validateBooleanOperator_InputOutputTypes(or, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validateOr_InputSize(or, diagnostics, context);
		return result;
	}

	/**
	 * Validates the InputSize constraint of '<em>Or</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateOr_InputSize(Or or, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (or_InputSizeInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(BooleansPackage.Literals.OR);

			EAnnotation ocl = BooleansPackage.Literals.OR
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("InputSize");

			try {
				or_InputSizeInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(or_InputSizeInvOCL);

		if (!query.check(or)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "InputSize",
										getObjectLabel(or, context) }),
						new Object[] { or }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBooleanOperator(BooleanOperator booleanOperator,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(booleanOperator,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(booleanOperator,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(booleanOperator,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(booleanOperator, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(booleanOperator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(booleanOperator, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(booleanOperator,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					booleanOperator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateBooleanOperator_InputOutputTypes(booleanOperator,
					diagnostics, context);
		return result;
	}

	/**
	 * Validates the InputOutputTypes constraint of '<em>Boolean Operator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBooleanOperator_InputOutputTypes(
			BooleanOperator booleanOperator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (booleanOperator_InputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(BooleansPackage.Literals.BOOLEAN_OPERATOR);

			EAnnotation ocl = BooleansPackage.Literals.BOOLEAN_OPERATOR
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("InputOutputTypes");

			try {
				booleanOperator_InputOutputTypesInvOCL = helper
						.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(booleanOperator_InputOutputTypesInvOCL);

		if (!query.check(booleanOperator)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
								.getString("_UI_GenericConstraint_diagnostic",
										new Object[] {
												"InputOutputTypes",
												getObjectLabel(booleanOperator,
														context) }),
						new Object[] { booleanOperator }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAnd(And and, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(and, diagnostics,
				context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(and, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(and, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(and, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(and, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(and, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(and, diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					and, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateBooleanOperator_InputOutputTypes(and,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAnd_InputSize(and, diagnostics, context);
		return result;
	}

	/**
	 * Validates the InputSize constraint of '<em>And</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateAnd_InputSize(And and, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (and_InputSizeInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(BooleansPackage.Literals.AND);

			EAnnotation ocl = BooleansPackage.Literals.AND
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("InputSize");

			try {
				and_InputSizeInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(and_InputSizeInvOCL);

		if (!query.check(and)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "InputSize",
										getObjectLabel(and, context) }),
						new Object[] { and }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateImply(Imply imply, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(imply, diagnostics,
				context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(imply, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(imply, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(imply, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(imply, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(imply, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(imply, diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					imply, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateBooleanOperator_InputOutputTypes(imply,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validateImply_InputSize(imply, diagnostics, context);
		return result;
	}

	/**
	 * Validates the InputSize constraint of '<em>Imply</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateImply_InputSize(Imply imply,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (imply_InputSizeInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(BooleansPackage.Literals.IMPLY);

			EAnnotation ocl = BooleansPackage.Literals.IMPLY
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("InputSize");

			try {
				imply_InputSizeInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(imply_InputSizeInvOCL);

		if (!query.check(imply)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "InputSize",
										getObjectLabel(imply, context) }),
						new Object[] { imply }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNot(Not not, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(not, diagnostics,
				context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(not, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(not, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(not, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(not, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(not, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(not, diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					not, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateBooleanOperator_InputOutputTypes(not,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validateNot_InputSize(not, diagnostics, context);
		return result;
	}

	/**
	 * Validates the InputSize constraint of '<em>Not</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateNot_InputSize(Not not, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (not_InputSizeInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(BooleansPackage.Literals.NOT);

			EAnnotation ocl = BooleansPackage.Literals.NOT
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("InputSize");

			try {
				not_InputSizeInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(not_InputSizeInvOCL);

		if (!query.check(not)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "InputSize",
										getObjectLabel(not, context) }),
						new Object[] { not }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBool(Bool bool, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(bool, diagnostics, context);
	}

} // BooleansValidator
