/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.hlpn.finiteEnumerations;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.hlpn.terms.OperatorDecl;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>FE Constant</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.lip6.move.pnml.hlpn.finiteEnumerations.FEConstant#getSort <em>Sort</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.lip6.move.pnml.hlpn.finiteEnumerations.FiniteEnumerationsPackage#getFEConstant()
 * @model annotation="http://www.pnml.org/models/ToPNML tag='feconstant' kind='son'"
 * @generated
 */
public interface FEConstant extends OperatorDecl {
	/**
	 * Returns the value of the '<em><b>Sort</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.lip6.move.pnml.hlpn.finiteEnumerations.FiniteEnumeration#getElements <em>Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sort</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sort</em>' container reference.
	 * @see #setSort(FiniteEnumeration)
	 * @see fr.lip6.move.pnml.hlpn.finiteEnumerations.FiniteEnumerationsPackage#getFEConstant_Sort()
	 * @see fr.lip6.move.pnml.hlpn.finiteEnumerations.FiniteEnumeration#getElements
	 * @model opposite="elements" required="true" transient="false" ordered="false"
	 * @generated
	 */
	FiniteEnumeration getSort();

	/**
	 * Sets the value of the '{@link fr.lip6.move.pnml.hlpn.finiteEnumerations.FEConstant#getSort <em>Sort</em>}' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sort</em>' container reference.
	 * @see #getSort()
	 * @generated
	 */
	void setSort(FiniteEnumeration value);

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML();

	/**
	 * set values to conform PNML document
	 */
	public void fromPNML(OMElement subRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	public boolean validateOCL(DiagnosticChain diagnostics);
} // FEConstant
