/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.hlpn.hlcorestructure.impl;

import java.util.Iterator;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.hlpn.hlcorestructure.Annotation;
import fr.lip6.move.pnml.hlpn.hlcorestructure.AnnotationGraphics;
import fr.lip6.move.pnml.hlpn.hlcorestructure.Fill;
import fr.lip6.move.pnml.hlpn.hlcorestructure.Font;
import fr.lip6.move.pnml.hlpn.hlcorestructure.HlcorestructureFactory;
import fr.lip6.move.pnml.hlpn.hlcorestructure.HlcorestructurePackage;
import fr.lip6.move.pnml.hlpn.hlcorestructure.Line;
import fr.lip6.move.pnml.hlpn.hlcorestructure.Offset;
import fr.lip6.move.pnml.hlpn.hlcorestructure.util.HlcorestructureValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Annotation Graphics</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.lip6.move.pnml.hlpn.hlcorestructure.impl.AnnotationGraphicsImpl#getOffset <em>Offset</em>}</li>
 *   <li>{@link fr.lip6.move.pnml.hlpn.hlcorestructure.impl.AnnotationGraphicsImpl#getFill <em>Fill</em>}</li>
 *   <li>{@link fr.lip6.move.pnml.hlpn.hlcorestructure.impl.AnnotationGraphicsImpl#getLine <em>Line</em>}</li>
 *   <li>{@link fr.lip6.move.pnml.hlpn.hlcorestructure.impl.AnnotationGraphicsImpl#getFont <em>Font</em>}</li>
 *   <li>{@link fr.lip6.move.pnml.hlpn.hlcorestructure.impl.AnnotationGraphicsImpl#getContainerAnnotation <em>Container Annotation</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AnnotationGraphicsImpl extends GraphicsImpl implements
		AnnotationGraphics {
	/**
	 * The cached value of the '{@link #getOffset() <em>Offset</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOffset()
	 * @generated
	 * @ordered
	 */
	protected Offset offset;

	/**
	 * The cached value of the '{@link #getFill() <em>Fill</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFill()
	 * @generated
	 * @ordered
	 */
	protected Fill fill;

	/**
	 * The cached value of the '{@link #getLine() <em>Line</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getLine()
	 * @generated
	 * @ordered
	 */
	protected Line line;

	/**
	 * The cached value of the '{@link #getFont() <em>Font</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFont()
	 * @generated
	 * @ordered
	 */
	protected Font font;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AnnotationGraphicsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return HlcorestructurePackage.Literals.ANNOTATION_GRAPHICS;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Offset getOffset() {
		return offset;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOffset(Offset newOffset,
			NotificationChain msgs) {
		Offset oldOffset = offset;
		offset = newOffset;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET,
					oldOffset, newOffset);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setOffset(Offset newOffset) {
		if (newOffset != offset) {
			NotificationChain msgs = null;
			if (offset != null)
				msgs = ((InternalEObject) offset)
						.eInverseRemove(
								this,
								HlcorestructurePackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS,
								Offset.class, msgs);
			if (newOffset != null)
				msgs = ((InternalEObject) newOffset)
						.eInverseAdd(
								this,
								HlcorestructurePackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS,
								Offset.class, msgs);
			msgs = basicSetOffset(newOffset, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET,
					newOffset, newOffset));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Fill getFill() {
		return fill;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFill(Fill newFill, NotificationChain msgs) {
		Fill oldFill = fill;
		fill = newFill;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL, oldFill,
					newFill);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setFill(Fill newFill) {
		if (newFill != fill) {
			NotificationChain msgs = null;
			if (fill != null)
				msgs = ((InternalEObject) fill)
						.eInverseRemove(
								this,
								HlcorestructurePackage.FILL__CONTAINER_ANNOTATION_GRAPHICS,
								Fill.class, msgs);
			if (newFill != null)
				msgs = ((InternalEObject) newFill)
						.eInverseAdd(
								this,
								HlcorestructurePackage.FILL__CONTAINER_ANNOTATION_GRAPHICS,
								Fill.class, msgs);
			msgs = basicSetFill(newFill, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL, newFill,
					newFill));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Line getLine() {
		return line;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLine(Line newLine, NotificationChain msgs) {
		Line oldLine = line;
		line = newLine;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE, oldLine,
					newLine);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setLine(Line newLine) {
		if (newLine != line) {
			NotificationChain msgs = null;
			if (line != null)
				msgs = ((InternalEObject) line)
						.eInverseRemove(
								this,
								HlcorestructurePackage.LINE__CONTAINER_ANNOTATION_GRAPHICS,
								Line.class, msgs);
			if (newLine != null)
				msgs = ((InternalEObject) newLine)
						.eInverseAdd(
								this,
								HlcorestructurePackage.LINE__CONTAINER_ANNOTATION_GRAPHICS,
								Line.class, msgs);
			msgs = basicSetLine(newLine, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE, newLine,
					newLine));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Font getFont() {
		return font;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFont(Font newFont, NotificationChain msgs) {
		Font oldFont = font;
		font = newFont;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT, oldFont,
					newFont);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setFont(Font newFont) {
		if (newFont != font) {
			NotificationChain msgs = null;
			if (font != null)
				msgs = ((InternalEObject) font)
						.eInverseRemove(
								this,
								HlcorestructurePackage.FONT__CONTAINER_ANNOTATION_GRAPHICS,
								Font.class, msgs);
			if (newFont != null)
				msgs = ((InternalEObject) newFont)
						.eInverseAdd(
								this,
								HlcorestructurePackage.FONT__CONTAINER_ANNOTATION_GRAPHICS,
								Font.class, msgs);
			msgs = basicSetFont(newFont, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT, newFont,
					newFont));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Annotation getContainerAnnotation() {
		if (eContainerFeatureID != HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION)
			return null;
		return (Annotation) eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContainerAnnotation(
			Annotation newContainerAnnotation, NotificationChain msgs) {
		msgs = eBasicSetContainer(
				(InternalEObject) newContainerAnnotation,
				HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setContainerAnnotation(Annotation newContainerAnnotation) {
		if (newContainerAnnotation != eInternalContainer()
				|| (eContainerFeatureID != HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION && newContainerAnnotation != null)) {
			if (EcoreUtil.isAncestor(this, newContainerAnnotation))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContainerAnnotation != null)
				msgs = ((InternalEObject) newContainerAnnotation).eInverseAdd(
						this,
						HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS,
						Annotation.class, msgs);
			msgs = basicSetContainerAnnotation(newContainerAnnotation, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION,
					newContainerAnnotation, newContainerAnnotation));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET:
			if (offset != null)
				msgs = ((InternalEObject) offset)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET,
								null, msgs);
			return basicSetOffset((Offset) otherEnd, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL:
			if (fill != null)
				msgs = ((InternalEObject) fill)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL,
								null, msgs);
			return basicSetFill((Fill) otherEnd, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE:
			if (line != null)
				msgs = ((InternalEObject) line)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE,
								null, msgs);
			return basicSetLine((Line) otherEnd, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT:
			if (font != null)
				msgs = ((InternalEObject) font)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT,
								null, msgs);
			return basicSetFont((Font) otherEnd, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetContainerAnnotation((Annotation) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET:
			return basicSetOffset(null, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL:
			return basicSetFill(null, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE:
			return basicSetLine(null, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT:
			return basicSetFont(null, msgs);
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION:
			return basicSetContainerAnnotation(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID) {
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION:
			return eInternalContainer().eInverseRemove(this,
					HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS,
					Annotation.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET:
			return getOffset();
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL:
			return getFill();
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE:
			return getLine();
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT:
			return getFont();
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION:
			return getContainerAnnotation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET:
			setOffset((Offset) newValue);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL:
			setFill((Fill) newValue);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE:
			setLine((Line) newValue);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT:
			setFont((Font) newValue);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION:
			setContainerAnnotation((Annotation) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET:
			setOffset((Offset) null);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL:
			setFill((Fill) null);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE:
			setLine((Line) null);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT:
			setFont((Font) null);
			return;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION:
			setContainerAnnotation((Annotation) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__OFFSET:
			return offset != null;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FILL:
			return fill != null;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__LINE:
			return line != null;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__FONT:
			return font != null;
		case HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION:
			return getContainerAnnotation() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML() {
		// id 0
		// idref 0
		// attributes 0
		// sons 4

		Boolean prettyPrintStatus = ModelRepository.getInstance()
				.isPrettyPrintActive();
		String retline = "";
		String headline = "";
		PrettyPrintData prpd = null;
		if (prettyPrintStatus) {
			retline = "\n";
			prpd = ModelRepository.getInstance().getPrettyPrintData();
			headline = prpd.getCurrentLineHeader();
		}

		StringBuffer sb = new StringBuffer();
		sb.append(headline);
		sb.append("<graphics");
		if (prettyPrintStatus) {
			headline = prpd.increaseLineHeaderLevel();
		}
		// begin attributes, id and id ref processing

		boolean haveSons = false;
		sb.append(">");
		sb.append(retline);

		// sons, follow processing

		if (getOffset() != null) {

			String top = getOffset().toPNML();
			if (!top.equals("")) {

				sb.append(top);

				haveSons = true;
			}

		}

		if (getFill() != null) {

			String top = getFill().toPNML();
			if (!top.equals("")) {

				sb.append(top);

				haveSons = true;
			}

		}

		if (getLine() != null) {

			String top = getLine().toPNML();
			if (!top.equals("")) {

				sb.append(top);

				haveSons = true;
			}

		}

		if (getFont() != null) {

			String top = getFont().toPNML();
			if (!top.equals("")) {

				sb.append(top);

				haveSons = true;
			}

		}

		/** * */

		if (prettyPrintStatus) {
			headline = prpd.decreaseLineHeaderLevel();
		}

		if (haveSons) {
			sb.append(headline);
			sb.append("</graphics>");
			sb.append(retline);
		} else {
			sb.delete(sb.lastIndexOf(">"), sb.length());
			sb.append("/>");
		}

		return sb.toString();
	}

	@SuppressWarnings("unchecked")
	public void fromPNML(OMElement locRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException {
		// 0
		// 0
		// 0
		// 4
		@SuppressWarnings("unused")
		HlcorestructureFactory fact = new HlcorestructureFactoryImpl();

		// processing id

		// processing idref

		// processing attributes

		// processing sons

		for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
			@SuppressWarnings("unused")
			OMElement type = (OMElement) iterator.next();

			if (type.getLocalName().equals("offset")) {
				Offset item;
				item = new HlcorestructureFactoryImpl().createOffset();
				item.fromPNML(type, idr);

				item.setContainerAnnotationGraphics(this);

				continue;
			}// end if

			if (type.getLocalName().equals("fill")) {
				Fill item;
				item = new HlcorestructureFactoryImpl().createFill();
				item.fromPNML(type, idr);

				item.setContainerAnnotationGraphics(this);

				continue;
			}// end if

			if (type.getLocalName().equals("line")) {
				Line item;
				item = new HlcorestructureFactoryImpl().createLine();
				item.fromPNML(type, idr);

				item.setContainerAnnotationGraphics(this);

				continue;
			}// end if

			if (type.getLocalName().equals("font")) {
				Font item;
				item = new HlcorestructureFactoryImpl().createFont();
				item.fromPNML(type, idr);

				item.setContainerAnnotationGraphics(this);

				continue;
			}// end if

		}

	}

	/**
	 * -
	 */
	public boolean validateOCL(DiagnosticChain diagnostics) {

		HlcorestructureValidator val = new HlcorestructureValidator();
		boolean retour = true;

		if (getOffset() != null) {
			retour &= getOffset().validateOCL(diagnostics);
		}

		if (getFill() != null) {
			retour &= getFill().validateOCL(diagnostics);
		}

		if (getLine() != null) {
			retour &= getLine().validateOCL(diagnostics);
		}

		if (getFont() != null) {
			retour &= getFont().validateOCL(diagnostics);
		}

		retour &= val.validate(this, diagnostics, null);
		return retour;

	}
} // AnnotationGraphicsImpl
