/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.hlpn.multisets.util;

import java.util.Map;

import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.util.EObjectValidator;
import org.eclipse.ocl.ParserException;
import org.eclipse.ocl.Query;
import org.eclipse.ocl.ecore.Constraint;
import org.eclipse.ocl.ecore.OCL;

import fr.lip6.move.pnml.hlpn.multisets.Add;
import fr.lip6.move.pnml.hlpn.multisets.All;
import fr.lip6.move.pnml.hlpn.multisets.Cardinality;
import fr.lip6.move.pnml.hlpn.multisets.CardinalityOf;
import fr.lip6.move.pnml.hlpn.multisets.Contains;
import fr.lip6.move.pnml.hlpn.multisets.Empty;
import fr.lip6.move.pnml.hlpn.multisets.MultisetsPackage;
import fr.lip6.move.pnml.hlpn.multisets.NumberOf;
import fr.lip6.move.pnml.hlpn.multisets.ScalarProduct;
import fr.lip6.move.pnml.hlpn.multisets.Subtract;
import fr.lip6.move.pnml.hlpn.terms.util.TermsValidator;

/**
 * <!-- begin-user-doc --> The <b>Validator</b> for the model. <!--
 * end-user-doc -->
 * @see fr.lip6.move.pnml.hlpn.multisets.MultisetsPackage
 * @generated
 */
public class MultisetsValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final MultisetsValidator INSTANCE = new MultisetsValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "fr.lip6.move.pnml.hlpn.multisets";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * The cached base package validator.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected TermsValidator termsValidator;

	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint cardinality_inputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint contains_inputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint cardinalityOf_inputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputType</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint add_inputTypeInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint all_inputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>InputSize</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint empty_InputSizeInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint numberOf_inputOutputTypesInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputType</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint subtract_inputTypeInvOCL;
	/**
	 * The parsed OCL expression for the definition of the '<em>inputOutputTypes</em>' invariant constraint.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static Constraint scalarProduct_inputOutputTypesInvOCL;
	private static final String OCL_ANNOTATION_SOURCE = "http://www.pnml.org/models/OCL";

	private static final OCL OCL_ENV = OCL.newInstance();

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MultisetsValidator() {
		super();
		termsValidator = TermsValidator.INSTANCE;
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
		return MultisetsPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
		case MultisetsPackage.CARDINALITY:
			return validateCardinality((Cardinality) value, diagnostics,
					context);
		case MultisetsPackage.CONTAINS:
			return validateContains((Contains) value, diagnostics, context);
		case MultisetsPackage.CARDINALITY_OF:
			return validateCardinalityOf((CardinalityOf) value, diagnostics,
					context);
		case MultisetsPackage.ADD:
			return validateAdd((Add) value, diagnostics, context);
		case MultisetsPackage.ALL:
			return validateAll((All) value, diagnostics, context);
		case MultisetsPackage.EMPTY:
			return validateEmpty((Empty) value, diagnostics, context);
		case MultisetsPackage.NUMBER_OF:
			return validateNumberOf((NumberOf) value, diagnostics, context);
		case MultisetsPackage.SUBTRACT:
			return validateSubtract((Subtract) value, diagnostics, context);
		case MultisetsPackage.SCALAR_PRODUCT:
			return validateScalarProduct((ScalarProduct) value, diagnostics,
					context);
		default:
			return true;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCardinality(Cardinality cardinality,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(cardinality,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(cardinality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(cardinality,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(cardinality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(cardinality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(cardinality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(cardinality, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					cardinality, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateCardinality_inputOutputTypes(cardinality,
					diagnostics, context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>Cardinality</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCardinality_inputOutputTypes(
			Cardinality cardinality, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (cardinality_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.CARDINALITY);

			EAnnotation ocl = MultisetsPackage.Literals.CARDINALITY
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				cardinality_inputOutputTypesInvOCL = helper
						.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(cardinality_inputOutputTypesInvOCL);

		if (!query.check(cardinality)) {
			if (diagnostics != null) {
				diagnostics
						.add(new BasicDiagnostic(Diagnostic.ERROR,
								DIAGNOSTIC_SOURCE, 0,
								EcorePlugin.INSTANCE.getString(
										"_UI_GenericConstraint_diagnostic",
										new Object[] {
												"inputOutputTypes",
												getObjectLabel(cardinality,
														context) }),
								new Object[] { cardinality }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateContains(Contains contains,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(contains,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(contains, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(contains, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(contains, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(contains, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(contains, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(contains, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					contains, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateContains_inputOutputTypes(contains, diagnostics,
					context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>Contains</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateContains_inputOutputTypes(Contains contains,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (contains_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.CONTAINS);

			EAnnotation ocl = MultisetsPackage.Literals.CONTAINS
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				contains_inputOutputTypesInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(contains_inputOutputTypesInvOCL);

		if (!query.check(contains)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "inputOutputTypes",
										getObjectLabel(contains, context) }),
						new Object[] { contains }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCardinalityOf(CardinalityOf cardinalityOf,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(cardinalityOf,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(cardinalityOf,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(cardinalityOf,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(cardinalityOf, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(cardinalityOf, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(cardinalityOf, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(cardinalityOf, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					cardinalityOf, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateCardinalityOf_inputOutputTypes(cardinalityOf,
					diagnostics, context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>Cardinality Of</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCardinalityOf_inputOutputTypes(
			CardinalityOf cardinalityOf, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (cardinalityOf_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.CARDINALITY_OF);

			EAnnotation ocl = MultisetsPackage.Literals.CARDINALITY_OF
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				cardinalityOf_inputOutputTypesInvOCL = helper
						.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(cardinalityOf_inputOutputTypesInvOCL);

		if (!query.check(cardinalityOf)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
								.getString("_UI_GenericConstraint_diagnostic",
										new Object[] {
												"inputOutputTypes",
												getObjectLabel(cardinalityOf,
														context) }),
						new Object[] { cardinalityOf }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAdd(Add add, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(add, diagnostics,
				context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(add, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(add, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(add, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(add, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(add, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(add, diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					add, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAdd_inputType(add, diagnostics, context);
		return result;
	}

	/**
	 * Validates the inputType constraint of '<em>Add</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateAdd_inputType(Add add, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (add_inputTypeInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.ADD);

			EAnnotation ocl = MultisetsPackage.Literals.ADD
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputType");

			try {
				add_inputTypeInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(add_inputTypeInvOCL);

		if (!query.check(add)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "inputType",
										getObjectLabel(add, context) }),
						new Object[] { add }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAll(All all, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(all, diagnostics,
				context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(all, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(all, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(all, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(all, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(all, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(all, diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					all, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAll_inputOutputTypes(all, diagnostics, context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>All</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateAll_inputOutputTypes(All all,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (all_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.ALL);

			EAnnotation ocl = MultisetsPackage.Literals.ALL
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				all_inputOutputTypesInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(all_inputOutputTypesInvOCL);

		if (!query.check(all)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "inputOutputTypes",
										getObjectLabel(all, context) }),
						new Object[] { all }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEmpty(Empty empty, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(empty, diagnostics,
				context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(empty, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(empty, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(empty, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(empty, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(empty, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(empty, diagnostics, context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					empty, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateEmpty_InputSize(empty, diagnostics, context);
		return result;
	}

	/**
	 * Validates the InputSize constraint of '<em>Empty</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateEmpty_InputSize(Empty empty,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (empty_InputSizeInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.EMPTY);

			EAnnotation ocl = MultisetsPackage.Literals.EMPTY
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("InputSize");

			try {
				empty_InputSizeInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(empty_InputSizeInvOCL);

		if (!query.check(empty)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "InputSize",
										getObjectLabel(empty, context) }),
						new Object[] { empty }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNumberOf(NumberOf numberOf,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(numberOf,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(numberOf, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(numberOf, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(numberOf, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(numberOf, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(numberOf, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(numberOf, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					numberOf, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateNumberOf_inputOutputTypes(numberOf, diagnostics,
					context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>Number Of</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNumberOf_inputOutputTypes(NumberOf numberOf,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (numberOf_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.NUMBER_OF);

			EAnnotation ocl = MultisetsPackage.Literals.NUMBER_OF
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				numberOf_inputOutputTypesInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(numberOf_inputOutputTypesInvOCL);

		if (!query.check(numberOf)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "inputOutputTypes",
										getObjectLabel(numberOf, context) }),
						new Object[] { numberOf }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSubtract(Subtract subtract,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(subtract,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(subtract, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(subtract, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(subtract, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(subtract, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(subtract, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(subtract, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					subtract, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateSubtract_inputType(subtract, diagnostics, context);
		return result;
	}

	/**
	 * Validates the inputType constraint of '<em>Subtract</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateSubtract_inputType(Subtract subtract,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (subtract_inputTypeInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.SUBTRACT);

			EAnnotation ocl = MultisetsPackage.Literals.SUBTRACT
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputType");

			try {
				subtract_inputTypeInvOCL = helper.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(subtract_inputTypeInvOCL);

		if (!query.check(subtract)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "inputType",
										getObjectLabel(subtract, context) }),
						new Object[] { subtract }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateScalarProduct(ScalarProduct scalarProduct,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(scalarProduct,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(scalarProduct,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(scalarProduct,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(scalarProduct, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(scalarProduct, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(scalarProduct, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(scalarProduct, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= termsValidator.validateOperator_sameOperatorNTermSort(
					scalarProduct, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateScalarProduct_inputOutputTypes(scalarProduct,
					diagnostics, context);
		return result;
	}

	/**
	 * Validates the inputOutputTypes constraint of '<em>Scalar Product</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateScalarProduct_inputOutputTypes(
			ScalarProduct scalarProduct, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (scalarProduct_inputOutputTypesInvOCL == null) {
			OCL.Helper helper = OCL_ENV.createOCLHelper();
			helper.setContext(MultisetsPackage.Literals.SCALAR_PRODUCT);

			EAnnotation ocl = MultisetsPackage.Literals.SCALAR_PRODUCT
					.getEAnnotation(OCL_ANNOTATION_SOURCE);
			String expr = ocl.getDetails().get("inputOutputTypes");

			try {
				scalarProduct_inputOutputTypesInvOCL = helper
						.createInvariant(expr);
			} catch (ParserException e) {
				throw new UnsupportedOperationException(e.getLocalizedMessage());
			}
		}

		Query<EClassifier, ?, ?> query = OCL_ENV
				.createQuery(scalarProduct_inputOutputTypesInvOCL);

		if (!query.check(scalarProduct)) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
								.getString("_UI_GenericConstraint_diagnostic",
										new Object[] {
												"inputOutputTypes",
												getObjectLabel(scalarProduct,
														context) }),
						new Object[] { scalarProduct }));
			}
			return false;
		}
		return true;
	}

} // MultisetsValidator
