/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture 
 *    Guillaume Giffo (UPMC) - Code generation refactoring, High-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pnmlcoremodel;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EObject;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Any Object</b></em>'.
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.AnyObject#getContainerToolInfo <em>Container Tool Info</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage#getAnyObject()
 * @model abstract="true"
 * @generated
 */
public interface AnyObject extends EObject {
    /**
     * Returns the value of the '<em><b>Container Tool Info</b></em>'
     * container reference. It is bidirectional and its opposite is '{@link fr.lip6.move.pnml.pnmlcoremodel.ToolInfo#getToolInfoModel <em>Tool Info Model</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Container Tool Info</em>' container
     * reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Container Tool Info</em>' container
     *         reference.
     * @see fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage#getAnyObject_ContainerToolInfo()
     * @see fr.lip6.move.pnml.pnmlcoremodel.ToolInfo#getToolInfoModel
     * @model opposite="toolInfoModel" transient="false" changeable="false"
     * @generated
     */
    ToolInfo getContainerToolInfo();

    // public abstract void idRefHang(java.util.ArrayList<Object> oList);
    public abstract String toPNML();

    public abstract void fromPNML(OMElement locRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException;

    public abstract boolean validateOCL(DiagnosticChain diagnostics);
} // AnyObject
