/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture 
 *    Guillaume Giffo (UPMC) - Code generation refactoring, High-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pnmlcoremodel;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Dimension</b></em>'.
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.Dimension#getContainerDNodeGraphics <em>Container DNode Graphics</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage#getDimension()
 * @model annotation="http://www.pnml.org/models/ToPNML tag='dimension'
 *        kind='son'"
 * @generated
 */
public interface Dimension extends Coordinate {
    /**
     * Returns the value of the '<em><b>Container DNode Graphics</b></em>'
     * container reference. It is bidirectional and its opposite is '{@link fr.lip6.move.pnml.pnmlcoremodel.NodeGraphics#getDimension <em>Dimension</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Container DNode Graphics</em>' container
     * reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Container DNode Graphics</em>'
     *         container reference.
     * @see #setContainerDNodeGraphics(NodeGraphics)
     * @see fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage#getDimension_ContainerDNodeGraphics()
     * @see fr.lip6.move.pnml.pnmlcoremodel.NodeGraphics#getDimension
     * @model opposite="dimension" transient="false" ordered="false"
     * @generated
     */
    NodeGraphics getContainerDNodeGraphics();

    /**
     * Sets the value of the '{@link fr.lip6.move.pnml.pnmlcoremodel.Dimension#getContainerDNodeGraphics <em>Container DNode Graphics</em>}'
     * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Container DNode Graphics</em>'
     *            container reference.
     * @see #getContainerDNodeGraphics()
     * @generated
     */
    void setContainerDNodeGraphics(NodeGraphics value);

    /**
     * Return the string containing the pnml output
     */
    public String toPNML();

    /**
     * set values to conform PNML document
     */
    public void fromPNML(OMElement subRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException;

    public boolean validateOCL(DiagnosticChain diagnostics);
} // Dimension
