/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture 
 *    Guillaume Giffo (UPMC) - Code generation refactoring, High-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pnmlcoremodel.impl;

import java.util.Iterator;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.pnmlcoremodel.AnnotationGraphics;
import fr.lip6.move.pnml.pnmlcoremodel.Name;
import fr.lip6.move.pnml.pnmlcoremodel.PetriNet;
import fr.lip6.move.pnml.pnmlcoremodel.PnObject;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelFactory;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage;
import fr.lip6.move.pnml.pnmlcoremodel.ToolInfo;
import fr.lip6.move.pnml.pnmlcoremodel.util.PnmlcoremodelValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Name</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.NameImpl#getText <em>Text</em>}</li>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.NameImpl#getContainerNamePetriNet <em>Container Name Petri Net</em>}</li>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.NameImpl#getContainerNamePnObject <em>Container Name Pn Object</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class NameImpl extends AnnotationImpl implements Name {
    /**
     * The default value of the '{@link #getText() <em>Text</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getText()
     * @generated
     * @ordered
     */
    protected static final String TEXT_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getText() <em>Text</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getText()
     * @generated
     * @ordered
     */
    protected String text = TEXT_EDEFAULT;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected NameImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return PnmlcoremodelPackage.Literals.NAME;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String getText() {
        return text;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setText(String newText) {
        String oldText = text;
        text = newText;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PnmlcoremodelPackage.NAME__TEXT, oldText, text));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public PetriNet getContainerNamePetriNet() {
        if (eContainerFeatureID != PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET)
            return null;
        return (PetriNet) eContainer();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetContainerNamePetriNet(
            PetriNet newContainerNamePetriNet, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject) newContainerNamePetriNet,
                PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainerNamePetriNet(PetriNet newContainerNamePetriNet) {
        if (newContainerNamePetriNet != eInternalContainer()
                || (eContainerFeatureID != PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET && newContainerNamePetriNet != null)) {
            if (EcoreUtil.isAncestor(this, newContainerNamePetriNet))
                throw new IllegalArgumentException(
                        "Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainerNamePetriNet != null)
                msgs = ((InternalEObject) newContainerNamePetriNet)
                        .eInverseAdd(this,
                                PnmlcoremodelPackage.PETRI_NET__NAME,
                                PetriNet.class, msgs);
            msgs = basicSetContainerNamePetriNet(newContainerNamePetriNet, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET,
                    newContainerNamePetriNet, newContainerNamePetriNet));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public PnObject getContainerNamePnObject() {
        if (eContainerFeatureID != PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT)
            return null;
        return (PnObject) eContainer();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetContainerNamePnObject(
            PnObject newContainerNamePnObject, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject) newContainerNamePnObject,
                PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainerNamePnObject(PnObject newContainerNamePnObject) {
        if (newContainerNamePnObject != eInternalContainer()
                || (eContainerFeatureID != PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT && newContainerNamePnObject != null)) {
            if (EcoreUtil.isAncestor(this, newContainerNamePnObject))
                throw new IllegalArgumentException(
                        "Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainerNamePnObject != null)
                msgs = ((InternalEObject) newContainerNamePnObject)
                        .eInverseAdd(this,
                                PnmlcoremodelPackage.PN_OBJECT__NAME,
                                PnObject.class, msgs);
            msgs = basicSetContainerNamePnObject(newContainerNamePnObject, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT,
                    newContainerNamePnObject, newContainerNamePnObject));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET:
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            return basicSetContainerNamePetriNet((PetriNet) otherEnd, msgs);
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT:
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            return basicSetContainerNamePnObject((PnObject) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET:
            return basicSetContainerNamePetriNet(null, msgs);
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT:
            return basicSetContainerNamePnObject(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(
            NotificationChain msgs) {
        switch (eContainerFeatureID) {
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET:
            return eInternalContainer().eInverseRemove(this,
                    PnmlcoremodelPackage.PETRI_NET__NAME, PetriNet.class, msgs);
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT:
            return eInternalContainer().eInverseRemove(this,
                    PnmlcoremodelPackage.PN_OBJECT__NAME, PnObject.class, msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case PnmlcoremodelPackage.NAME__TEXT:
            return getText();
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET:
            return getContainerNamePetriNet();
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT:
            return getContainerNamePnObject();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case PnmlcoremodelPackage.NAME__TEXT:
            setText((String) newValue);
            return;
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET:
            setContainerNamePetriNet((PetriNet) newValue);
            return;
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT:
            setContainerNamePnObject((PnObject) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.NAME__TEXT:
            setText(TEXT_EDEFAULT);
            return;
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET:
            setContainerNamePetriNet((PetriNet) null);
            return;
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT:
            setContainerNamePnObject((PnObject) null);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.NAME__TEXT:
            return TEXT_EDEFAULT == null ? text != null : !TEXT_EDEFAULT
                    .equals(text);
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PETRI_NET:
            return getContainerNamePetriNet() != null;
        case PnmlcoremodelPackage.NAME__CONTAINER_NAME_PN_OBJECT:
            return getContainerNamePnObject() != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (text: ");
        result.append(text);
        result.append(')');
        return result.toString();
    }

    /**
     * Return the string containing the pnml output
     */
    public String toPNML() {
        // id 0
        // idref 0
        // attributes 0
        // sons 3

        Boolean prettyPrintStatus = ModelRepository.getInstance()
                .isPrettyPrintActive();
        String retline = "";
        String headline = "";
        PrettyPrintData prpd = null;
        if (prettyPrintStatus) {
            retline = "\n";
            prpd = ModelRepository.getInstance().getPrettyPrintData();
            headline = prpd.getCurrentLineHeader();
        }

        StringBuffer sb = new StringBuffer();
        sb.append(headline);
        sb.append("<name");
        if (prettyPrintStatus) {
            headline = prpd.increaseLineHeaderLevel();
        }
        // begin attributes, id and id ref processing

        boolean haveSons = false;
        sb.append(">");
        sb.append(retline);

        // sons, follow processing

        if (getToolspecifics() != null) {

            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();

                sb.append(item.toPNML());

                haveSons = true;
            }

        }

        if (getAnnotationgraphics() != null) {

            String top = getAnnotationgraphics().toPNML();
            if (!top.equals("")) {

                sb.append(top);

                haveSons = true;
            }

        }

        if (getText() != null) {

            sb.append(headline);
            sb.append("<");
            sb.append("text");
            sb.append(">");
            sb.append(getText().toString());
            sb.append("</");
            sb.append("text");
            sb.append(">");
            sb.append(retline);

            haveSons = true;

        }

        /** * */

        if (prettyPrintStatus) {
            headline = prpd.decreaseLineHeaderLevel();
        }

        if (haveSons) {
            sb.append(headline);
            sb.append("</name>");
            sb.append(retline);
        } else {
            sb.delete(sb.lastIndexOf(">"), sb.length());
            sb.append("/>");
        }

        return sb.toString();
    }

    @SuppressWarnings("unchecked")
    public void fromPNML(OMElement locRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException {
        // 0
        // 0
        // 0
        // 3
        @SuppressWarnings("unused")
        PnmlcoremodelFactory fact = new PnmlcoremodelFactoryImpl();

        // processing id

        // processing idref

        // processing attributes

        // processing sons

        for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
            @SuppressWarnings("unused")
            OMElement type = (OMElement) iterator.next();

            if (type.getLocalName().equals("toolspecific")) {
                ToolInfo item;
                item = new PnmlcoremodelFactoryImpl().createToolInfo();
                item.fromPNML(type, idr);

                item.setContainerLabel(this);

                continue;
            }// end if

            if (type.getLocalName().equals("graphics")) {
                AnnotationGraphics item;
                item = new PnmlcoremodelFactoryImpl()
                        .createAnnotationGraphics();
                item.fromPNML(type, idr);

                item.setContainerAnnotation(this);

                continue;
            }// end if

            if (type.getLocalName().equals("text")) {
                this.setText(new java.lang.String(type.getText()));
            }

        }

    }

    /**
     * -
     */
    public boolean validateOCL(DiagnosticChain diagnostics) {

        PnmlcoremodelValidator val = new PnmlcoremodelValidator();
        boolean retour = true;

        if (getToolspecifics() != null) {
            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();
                retour &= item.validateOCL(diagnostics);
            }
        }

        if (getAnnotationgraphics() != null) {
            retour &= getAnnotationgraphics().validateOCL(diagnostics);
        }

        retour &= val.validate(this, diagnostics, null);
        return retour;

    }
} // NameImpl
