/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture 
 *    Guillaume Giffo (UPMC) - Code generation refactoring, High-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pnmlcoremodel.impl;

import javax.xml.namespace.QName;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.pnmlcoremodel.AnnotationGraphics;
import fr.lip6.move.pnml.pnmlcoremodel.Offset;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelFactory;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage;
import fr.lip6.move.pnml.pnmlcoremodel.util.PnmlcoremodelValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Offset</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.OffsetImpl#getContainerAnnotationGraphics <em>Container Annotation Graphics</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class OffsetImpl extends CoordinateImpl implements Offset {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected OffsetImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return PnmlcoremodelPackage.Literals.OFFSET;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public AnnotationGraphics getContainerAnnotationGraphics() {
        if (eContainerFeatureID != PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS)
            return null;
        return (AnnotationGraphics) eContainer();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetContainerAnnotationGraphics(
            AnnotationGraphics newContainerAnnotationGraphics,
            NotificationChain msgs) {
        msgs = eBasicSetContainer(
                (InternalEObject) newContainerAnnotationGraphics,
                PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS,
                msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainerAnnotationGraphics(
            AnnotationGraphics newContainerAnnotationGraphics) {
        if (newContainerAnnotationGraphics != eInternalContainer()
                || (eContainerFeatureID != PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS && newContainerAnnotationGraphics != null)) {
            if (EcoreUtil.isAncestor(this, newContainerAnnotationGraphics))
                throw new IllegalArgumentException(
                        "Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainerAnnotationGraphics != null)
                msgs = ((InternalEObject) newContainerAnnotationGraphics)
                        .eInverseAdd(
                                this,
                                PnmlcoremodelPackage.ANNOTATION_GRAPHICS__OFFSET,
                                AnnotationGraphics.class, msgs);
            msgs = basicSetContainerAnnotationGraphics(
                    newContainerAnnotationGraphics, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS,
                    newContainerAnnotationGraphics,
                    newContainerAnnotationGraphics));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS:
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            return basicSetContainerAnnotationGraphics(
                    (AnnotationGraphics) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS:
            return basicSetContainerAnnotationGraphics(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(
            NotificationChain msgs) {
        switch (eContainerFeatureID) {
        case PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS:
            return eInternalContainer().eInverseRemove(this,
                    PnmlcoremodelPackage.ANNOTATION_GRAPHICS__OFFSET,
                    AnnotationGraphics.class, msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS:
            return getContainerAnnotationGraphics();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS:
            setContainerAnnotationGraphics((AnnotationGraphics) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS:
            setContainerAnnotationGraphics((AnnotationGraphics) null);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.OFFSET__CONTAINER_ANNOTATION_GRAPHICS:
            return getContainerAnnotationGraphics() != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * Return the string containing the pnml output
     */
    public String toPNML() {
        // id 0
        // idref 0
        // attributes 2
        // sons 0

        Boolean prettyPrintStatus = ModelRepository.getInstance()
                .isPrettyPrintActive();
        String retline = "";
        String headline = "";
        PrettyPrintData prpd = null;
        if (prettyPrintStatus) {
            retline = "\n";
            prpd = ModelRepository.getInstance().getPrettyPrintData();
            headline = prpd.getCurrentLineHeader();
        }

        StringBuffer sb = new StringBuffer();
        sb.append(headline);
        sb.append("<offset");
        if (prettyPrintStatus) {
            headline = prpd.increaseLineHeaderLevel();
        }
        // begin attributes, id and id ref processing

        if (getX() != null) {
            sb.append(" x");
            sb.append("=\"");
            sb.append(getX());
            sb.append("\"");
        }

        if (getY() != null) {
            sb.append(" y");
            sb.append("=\"");
            sb.append(getY());
            sb.append("\"");
        }

        sb.append("/>");
        sb.append(retline);

        // sons, follow processing

        /** * */

        if (prettyPrintStatus) {
            headline = prpd.decreaseLineHeaderLevel();
        }

        return sb.toString();
    }

    @SuppressWarnings("unchecked")
    public void fromPNML(OMElement locRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException {
        // 0
        // 0
        // 2
        // 0
        @SuppressWarnings("unused")
        PnmlcoremodelFactory fact = new PnmlcoremodelFactoryImpl();

        // processing id

        // processing idref

        // processing attributes

        if (locRoot.getAttributeValue(new QName("x")) != null) {
            try {
                this
                        .setX(new Integer(locRoot.getAttributeValue(new QName(
                                "x"))));
            } catch (Exception e) {
                throw new fr.lip6.move.pnml.framework.utils.exception.InnerBuildException(
                        e);
            }
        }

        if (locRoot.getAttributeValue(new QName("y")) != null) {
            try {
                this
                        .setY(new Integer(locRoot.getAttributeValue(new QName(
                                "y"))));
            } catch (Exception e) {
                throw new fr.lip6.move.pnml.framework.utils.exception.InnerBuildException(
                        e);
            }
        }

        // processing sons

    }

    /**
     * -
     */
    public boolean validateOCL(DiagnosticChain diagnostics) {

        PnmlcoremodelValidator val = new PnmlcoremodelValidator();
        boolean retour = true;

        retour &= val.validate(this, diagnostics, null);
        return retour;

    }
} // OffsetImpl
