/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture 
 *    Guillaume Giffo (UPMC) - Code generation refactoring, High-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pnmlcoremodel.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import javax.xml.namespace.QName;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.pnmlcoremodel.Arc;
import fr.lip6.move.pnml.pnmlcoremodel.Name;
import fr.lip6.move.pnml.pnmlcoremodel.NodeGraphics;
import fr.lip6.move.pnml.pnmlcoremodel.Page;
import fr.lip6.move.pnml.pnmlcoremodel.PetriNet;
import fr.lip6.move.pnml.pnmlcoremodel.Place;
import fr.lip6.move.pnml.pnmlcoremodel.PnObject;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelFactory;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage;
import fr.lip6.move.pnml.pnmlcoremodel.RefPlace;
import fr.lip6.move.pnml.pnmlcoremodel.RefTransition;
import fr.lip6.move.pnml.pnmlcoremodel.ToolInfo;
import fr.lip6.move.pnml.pnmlcoremodel.Transition;
import fr.lip6.move.pnml.pnmlcoremodel.util.PnmlcoremodelValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Page</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.PageImpl#getObjects <em>Objects</em>}</li>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.PageImpl#getContainerPetriNet <em>Container Petri Net</em>}</li>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.PageImpl#getNodegraphics <em>Nodegraphics</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class PageImpl extends PnObjectImpl implements Page {
    /**
     * The cached value of the '{@link #getObjects() <em>Objects</em>}'
     * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getObjects()
     * @generated
     * @ordered
     */
    protected EList<PnObject> objects;

    /**
     * The cached value of the '{@link #getNodegraphics() <em>Nodegraphics</em>}'
     * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getNodegraphics()
     * @generated
     * @ordered
     */
    protected NodeGraphics nodegraphics;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected PageImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return PnmlcoremodelPackage.Literals.PAGE;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public List<PnObject> getObjects() {
        if (objects == null) {
            objects = new EObjectContainmentWithInverseEList<PnObject>(
                    PnObject.class, this, PnmlcoremodelPackage.PAGE__OBJECTS,
                    PnmlcoremodelPackage.PN_OBJECT__CONTAINER_PAGE);
        }
        return objects;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public PetriNet getContainerPetriNet() {
        if (eContainerFeatureID != PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET)
            return null;
        return (PetriNet) eContainer();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetContainerPetriNet(
            PetriNet newContainerPetriNet, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject) newContainerPetriNet,
                PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainerPetriNet(PetriNet newContainerPetriNet) {
        if (newContainerPetriNet != eInternalContainer()
                || (eContainerFeatureID != PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET && newContainerPetriNet != null)) {
            if (EcoreUtil.isAncestor(this, newContainerPetriNet))
                throw new IllegalArgumentException(
                        "Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainerPetriNet != null)
                msgs = ((InternalEObject) newContainerPetriNet).eInverseAdd(
                        this, PnmlcoremodelPackage.PETRI_NET__PAGES,
                        PetriNet.class, msgs);
            msgs = basicSetContainerPetriNet(newContainerPetriNet, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET,
                    newContainerPetriNet, newContainerPetriNet));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NodeGraphics getNodegraphics() {
        return nodegraphics;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetNodegraphics(NodeGraphics newNodegraphics,
            NotificationChain msgs) {
        NodeGraphics oldNodegraphics = nodegraphics;
        nodegraphics = newNodegraphics;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this,
                    Notification.SET, PnmlcoremodelPackage.PAGE__NODEGRAPHICS,
                    oldNodegraphics, newNodegraphics);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setNodegraphics(NodeGraphics newNodegraphics) {
        if (newNodegraphics != nodegraphics) {
            NotificationChain msgs = null;
            if (nodegraphics != null)
                msgs = ((InternalEObject) nodegraphics).eInverseRemove(this,
                        PnmlcoremodelPackage.NODE_GRAPHICS__CONTAINER_PAGE,
                        NodeGraphics.class, msgs);
            if (newNodegraphics != null)
                msgs = ((InternalEObject) newNodegraphics).eInverseAdd(this,
                        PnmlcoremodelPackage.NODE_GRAPHICS__CONTAINER_PAGE,
                        NodeGraphics.class, msgs);
            msgs = basicSetNodegraphics(newNodegraphics, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PnmlcoremodelPackage.PAGE__NODEGRAPHICS, newNodegraphics,
                    newNodegraphics));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.PAGE__OBJECTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getObjects())
                    .basicAdd(otherEnd, msgs);
        case PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET:
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            return basicSetContainerPetriNet((PetriNet) otherEnd, msgs);
        case PnmlcoremodelPackage.PAGE__NODEGRAPHICS:
            if (nodegraphics != null)
                msgs = ((InternalEObject) nodegraphics).eInverseRemove(this,
                        EOPPOSITE_FEATURE_BASE
                                - PnmlcoremodelPackage.PAGE__NODEGRAPHICS,
                        null, msgs);
            return basicSetNodegraphics((NodeGraphics) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.PAGE__OBJECTS:
            return ((InternalEList<?>) getObjects())
                    .basicRemove(otherEnd, msgs);
        case PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET:
            return basicSetContainerPetriNet(null, msgs);
        case PnmlcoremodelPackage.PAGE__NODEGRAPHICS:
            return basicSetNodegraphics(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(
            NotificationChain msgs) {
        switch (eContainerFeatureID) {
        case PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET:
            return eInternalContainer()
                    .eInverseRemove(this,
                            PnmlcoremodelPackage.PETRI_NET__PAGES,
                            PetriNet.class, msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case PnmlcoremodelPackage.PAGE__OBJECTS:
            return getObjects();
        case PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET:
            return getContainerPetriNet();
        case PnmlcoremodelPackage.PAGE__NODEGRAPHICS:
            return getNodegraphics();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case PnmlcoremodelPackage.PAGE__OBJECTS:
            getObjects().clear();
            getObjects().addAll((Collection<? extends PnObject>) newValue);
            return;
        case PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET:
            setContainerPetriNet((PetriNet) newValue);
            return;
        case PnmlcoremodelPackage.PAGE__NODEGRAPHICS:
            setNodegraphics((NodeGraphics) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.PAGE__OBJECTS:
            getObjects().clear();
            return;
        case PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET:
            setContainerPetriNet((PetriNet) null);
            return;
        case PnmlcoremodelPackage.PAGE__NODEGRAPHICS:
            setNodegraphics((NodeGraphics) null);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.PAGE__OBJECTS:
            return objects != null && !objects.isEmpty();
        case PnmlcoremodelPackage.PAGE__CONTAINER_PETRI_NET:
            return getContainerPetriNet() != null;
        case PnmlcoremodelPackage.PAGE__NODEGRAPHICS:
            return nodegraphics != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * Return the string containing the pnml output
     */
    public String toPNML() {
        // id 1
        // idref 0
        // attributes 0
        // sons 4

        Boolean prettyPrintStatus = ModelRepository.getInstance()
                .isPrettyPrintActive();
        String retline = "";
        String headline = "";
        PrettyPrintData prpd = null;
        if (prettyPrintStatus) {
            retline = "\n";
            prpd = ModelRepository.getInstance().getPrettyPrintData();
            headline = prpd.getCurrentLineHeader();
        }

        StringBuffer sb = new StringBuffer();
        sb.append(headline);
        sb.append("<page");
        if (prettyPrintStatus) {
            headline = prpd.increaseLineHeaderLevel();
        }
        // begin attributes, id and id ref processing

        if (getId() != null) {
            sb.append(" id");
            sb.append("=\"");
            sb.append(getId());
            sb.append("\"");
        }

        boolean haveSons = false;
        sb.append(">");
        sb.append(retline);

        // sons, follow processing

        if (getName() != null) {

            String top = getName().toPNML();
            if (!top.equals("")) {

                sb.append(top);

                haveSons = true;
            }

        }

        if (getToolspecifics() != null) {

            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();

                sb.append(item.toPNML());

                haveSons = true;
            }

        }

        if (getObjects() != null) {

            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.PnObject> items = getObjects();
            for (Iterator<PnObject> iterator = items.iterator(); iterator
                    .hasNext();) {
                PnObject item = (PnObject) iterator.next();

                sb.append(item.toPNML());

                haveSons = true;
            }

        }

        if (getNodegraphics() != null) {

            String top = getNodegraphics().toPNML();
            if (!top.equals("")) {

                sb.append(top);

                haveSons = true;
            }

        }

        /** * */

        if (prettyPrintStatus) {
            headline = prpd.decreaseLineHeaderLevel();
        }

        if (haveSons) {
            sb.append(headline);
            sb.append("</page>");
            sb.append(retline);
        } else {
            sb.delete(sb.lastIndexOf(">"), sb.length());
            sb.append("/>");
        }

        return sb.toString();
    }

    @SuppressWarnings("unchecked")
    public void fromPNML(OMElement locRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException {
        // 1
        // 0
        // 0
        // 4
        @SuppressWarnings("unused")
        PnmlcoremodelFactory fact = new PnmlcoremodelFactoryImpl();

        // processing id

        if (locRoot.getAttributeValue(new QName("id")) != null) {
            this.setId(new java.lang.String(locRoot
                    .getAttributeValue(new QName("id"))));
            ModelRepository.getInstance().getCurrentIdRepository().checkId(
                    new java.lang.String(locRoot.getAttributeValue(new QName(
                            "id"))).toString(), (Object) this);
        }

        // processing idref

        // processing attributes

        // processing sons

        for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
            @SuppressWarnings("unused")
            OMElement type = (OMElement) iterator.next();

            if (type.getLocalName().equals("name")) {
                Name item;
                item = new PnmlcoremodelFactoryImpl().createName();
                item.fromPNML(type, idr);

                item.setContainerNamePnObject(this);

                continue;
            }// end if

            if (type.getLocalName().equals("toolspecific")) {
                ToolInfo item;
                item = new PnmlcoremodelFactoryImpl().createToolInfo();
                item.fromPNML(type, idr);

                item.setContainerPnObject(this);

                continue;
            }// end if

            if (type.getLocalName().equals("page")) {
                Page item;
                item = new PnmlcoremodelFactoryImpl().createPage();
                item.fromPNML(type, idr);

                item.setContainerPage(this);

                continue;
            }// end if

            if (type.getLocalName().equals("arc")) {
                Arc item;
                item = new PnmlcoremodelFactoryImpl().createArc();
                item.fromPNML(type, idr);

                item.setContainerPage(this);

                continue;
            }// end if

            if (type.getLocalName().equals("place")) {
                Place item;
                item = new PnmlcoremodelFactoryImpl().createPlace();
                item.fromPNML(type, idr);

                item.setContainerPage(this);

                continue;
            }// end if

            if (type.getLocalName().equals("referenceTransition")) {
                RefTransition item;
                item = new PnmlcoremodelFactoryImpl().createRefTransition();
                item.fromPNML(type, idr);

                item.setContainerPage(this);

                continue;
            }// end if

            if (type.getLocalName().equals("transition")) {
                Transition item;
                item = new PnmlcoremodelFactoryImpl().createTransition();
                item.fromPNML(type, idr);

                item.setContainerPage(this);

                continue;
            }// end if

            if (type.getLocalName().equals("referencePlace")) {
                RefPlace item;
                item = new PnmlcoremodelFactoryImpl().createRefPlace();
                item.fromPNML(type, idr);

                item.setContainerPage(this);

                continue;
            }// end if

            if (type.getLocalName().equals("graphics")) {
                NodeGraphics item;
                item = new PnmlcoremodelFactoryImpl().createNodeGraphics();
                item.fromPNML(type, idr);

                item.setContainerPage(this);

                continue;
            }// end if

        }

    }

    /**
     * -
     */
    public boolean validateOCL(DiagnosticChain diagnostics) {

        PnmlcoremodelValidator val = new PnmlcoremodelValidator();
        boolean retour = true;

        if (getName() != null) {
            retour &= getName().validateOCL(diagnostics);
        }

        if (getToolspecifics() != null) {
            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();
                retour &= item.validateOCL(diagnostics);
            }
        }

        if (getObjects() != null) {
            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.PnObject> items = getObjects();
            for (Iterator<PnObject> iterator = items.iterator(); iterator
                    .hasNext();) {
                PnObject item = (PnObject) iterator.next();
                retour &= item.validateOCL(diagnostics);
            }
        }

        if (getNodegraphics() != null) {
            retour &= getNodegraphics().validateOCL(diagnostics);
        }

        retour &= val.validate(this, diagnostics, null);
        return retour;

    }
} // PageImpl
