/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture 
 *    Guillaume Giffo (UPMC) - Code generation refactoring, High-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pnmlcoremodel.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.pnmlcoremodel.PetriNet;
import fr.lip6.move.pnml.pnmlcoremodel.PetriNetDoc;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelFactory;
import fr.lip6.move.pnml.pnmlcoremodel.PnmlcoremodelPackage;
import fr.lip6.move.pnml.pnmlcoremodel.util.PnmlcoremodelValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Petri Net Doc</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.PetriNetDocImpl#getNets <em>Nets</em>}</li>
 * <li>{@link fr.lip6.move.pnml.pnmlcoremodel.impl.PetriNetDocImpl#getXmlns <em>Xmlns</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class PetriNetDocImpl extends EObjectImpl implements PetriNetDoc {
    /**
     * The cached value of the '{@link #getNets() <em>Nets</em>}' containment
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getNets()
     * @generated
     * @ordered
     */
    protected EList<PetriNet> nets;

    /**
     * The default value of the '{@link #getXmlns() <em>Xmlns</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getXmlns()
     * @generated
     * @ordered
     */
    protected static final String XMLNS_EDEFAULT = "http://www.pnml.org/version-2009/grammar/pnml";

    /**
     * The cached value of the '{@link #getXmlns() <em>Xmlns</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getXmlns()
     * @generated
     * @ordered
     */
    protected String xmlns = XMLNS_EDEFAULT;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected PetriNetDocImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return PnmlcoremodelPackage.Literals.PETRI_NET_DOC;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public List<PetriNet> getNets() {
        if (nets == null) {
            nets = new EObjectContainmentWithInverseEList<PetriNet>(
                    PetriNet.class, this,
                    PnmlcoremodelPackage.PETRI_NET_DOC__NETS,
                    PnmlcoremodelPackage.PETRI_NET__CONTAINER_PETRI_NET_DOC);
        }
        return nets;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String getXmlns() {
        return xmlns;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.PETRI_NET_DOC__NETS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getNets())
                    .basicAdd(otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PnmlcoremodelPackage.PETRI_NET_DOC__NETS:
            return ((InternalEList<?>) getNets()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case PnmlcoremodelPackage.PETRI_NET_DOC__NETS:
            return getNets();
        case PnmlcoremodelPackage.PETRI_NET_DOC__XMLNS:
            return getXmlns();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case PnmlcoremodelPackage.PETRI_NET_DOC__NETS:
            getNets().clear();
            getNets().addAll((Collection<? extends PetriNet>) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.PETRI_NET_DOC__NETS:
            getNets().clear();
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case PnmlcoremodelPackage.PETRI_NET_DOC__NETS:
            return nets != null && !nets.isEmpty();
        case PnmlcoremodelPackage.PETRI_NET_DOC__XMLNS:
            return XMLNS_EDEFAULT == null ? xmlns != null : !XMLNS_EDEFAULT
                    .equals(xmlns);
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (xmlns: ");
        result.append(xmlns);
        result.append(')');
        return result.toString();
    }

    /**
     * Return the string containing the pnml output
     */
    public String toPNML() {
        // id 0
        // idref 0
        // attributes 1
        // sons 1

        Boolean prettyPrintStatus = ModelRepository.getInstance()
                .isPrettyPrintActive();
        String retline = "";
        String headline = "";
        PrettyPrintData prpd = null;
        if (prettyPrintStatus) {
            retline = "\n";
            prpd = ModelRepository.getInstance().getPrettyPrintData();
            headline = prpd.getCurrentLineHeader();
        }

        StringBuffer sb = new StringBuffer();
        sb.append(headline);
        sb.append("<pnml");
        if (prettyPrintStatus) {
            headline = prpd.increaseLineHeaderLevel();
        }
        // begin attributes, id and id ref processing

        if (getXmlns() != null) {
            sb.append(" xmlns");
            sb.append("=\"");
            sb.append(getXmlns());
            sb.append("\"");
        }

        boolean haveSons = false;
        sb.append(">");
        sb.append(retline);

        // sons, follow processing

        if (getNets() != null) {

            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.PetriNet> items = getNets();
            for (Iterator<PetriNet> iterator = items.iterator(); iterator
                    .hasNext();) {
                PetriNet item = (PetriNet) iterator.next();

                sb.append(item.toPNML());

                haveSons = true;
            }

        }

        /** * */

        if (prettyPrintStatus) {
            headline = prpd.decreaseLineHeaderLevel();
        }

        if (haveSons) {
            sb.append(headline);
            sb.append("</pnml>");
            sb.append(retline);
        } else {
            sb.delete(sb.lastIndexOf(">"), sb.length());
            sb.append("/>");
        }

        return sb.toString();
    }

    @SuppressWarnings("unchecked")
    public void fromPNML(OMElement locRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException {
        // 0
        // 0
        // 1
        // 1
        @SuppressWarnings("unused")
        PnmlcoremodelFactory fact = new PnmlcoremodelFactoryImpl();

        // processing id

        // processing idref

        // processing attributes

        // processing sons

        for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
            @SuppressWarnings("unused")
            OMElement type = (OMElement) iterator.next();

            if (type.getLocalName().equals("net")) {
                PetriNet item;
                item = new PnmlcoremodelFactoryImpl().createPetriNet();
                item.fromPNML(type, idr);

                item.setContainerPetriNetDoc(this);

                continue;
            }// end if

        }

    }

    /**
     * -
     */
    public boolean validateOCL(DiagnosticChain diagnostics) {

        PnmlcoremodelValidator val = new PnmlcoremodelValidator();
        boolean retour = true;

        if (getNets() != null) {
            java.util.List<fr.lip6.move.pnml.pnmlcoremodel.PetriNet> items = getNets();
            for (Iterator<PetriNet> iterator = items.iterator(); iterator
                    .hasNext();) {
                PetriNet item = (PetriNet) iterator.next();
                retour &= item.validateOCL(diagnostics);
            }
        }

        retour &= val.validate(this, diagnostics, null);
        return retour;

    }
} // PetriNetDocImpl
