/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pthlpng.hlcorestructure;

import java.util.List;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Arc Graphics</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.ArcGraphics#getPositions
 * <em>Positions</em>}</li>
 * <li>{@link fr.lip6.move.pnml.pthlpng.hlcorestructure.ArcGraphics#getLine <em>
 * Line</em>}</li>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.ArcGraphics#getContainerArc
 * <em>Container Arc</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage#getArcGraphics()
 * @model 
 *        annotation="http://www.pnml.org/models/ToPNML tag='graphics' kind='son'"
 * @generated
 */
public interface ArcGraphics extends Graphics {
	/**
	 * Returns the value of the '<em><b>Positions</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Position}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Position#getContainerArcGraphics
	 * <em>Container Arc Graphics</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Positions</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Positions</em>' containment reference list.
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage#getArcGraphics_Positions()
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.Position#getContainerArcGraphics
	 * @model opposite="containerArcGraphics" containment="true"
	 *        annotation="http://www.pnml.org/models/ToPNML kind='follow'"
	 * @generated
	 */
	List<Position> getPositions();

	/**
	 * Returns the value of the '<em><b>Line</b></em>' containment reference. It
	 * is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Line#getContainerArcGraphics
	 * <em>Container Arc Graphics</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Line</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Line</em>' containment reference.
	 * @see #setLine(Line)
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage#getArcGraphics_Line()
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.Line#getContainerArcGraphics
	 * @model opposite="containerArcGraphics" containment="true" ordered="false"
	 *        annotation="http://www.pnml.org/models/ToPNML kind='follow'"
	 * @generated
	 */
	Line getLine();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.ArcGraphics#getLine
	 * <em>Line</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Line</em>' containment reference.
	 * @see #getLine()
	 * @generated
	 */
	void setLine(Line value);

	/**
	 * Returns the value of the '<em><b>Container Arc</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Arc#getArcgraphics
	 * <em>Arcgraphics</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Container Arc</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Container Arc</em>' container reference.
	 * @see #setContainerArc(Arc)
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage#getArcGraphics_ContainerArc()
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.Arc#getArcgraphics
	 * @model opposite="arcgraphics" transient="false"
	 * @generated
	 */
	Arc getContainerArc();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.ArcGraphics#getContainerArc
	 * <em>Container Arc</em>}' container reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Container Arc</em>' container
	 *            reference.
	 * @see #getContainerArc()
	 * @generated
	 */
	void setContainerArc(Arc value);

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML();

	/**
	 * set values to conform PNML document
	 */
	public void fromPNML(OMElement subRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	// public void idRefHang(java.util.ArrayList<Object> oList);

	public boolean validateOCL(DiagnosticChain diagnostics);
} // ArcGraphics
