/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pthlpng.hlcorestructure;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Place</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Place#getType <em>Type
 * </em>}</li>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Place#getHlinitialMarking
 * <em>Hlinitial Marking</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage#getPlace()
 * @model annotation="http://www.pnml.org/models/ToPNML tag='place' kind='son'"
 * @generated
 */
public interface Place extends PlaceNode {
	/**
	 * Returns the value of the '<em><b>Type</b></em>' containment reference. It
	 * is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Type#getContainerPlace
	 * <em>Container Place</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Type</em>' containment reference.
	 * @see #setType(Type)
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage#getPlace_Type()
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.Type#getContainerPlace
	 * @model opposite="containerPlace" containment="true"
	 *        annotation="http://www.pnml.org/models/ToPNML kind='follow'"
	 * @generated
	 */
	Type getType();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Place#getType
	 * <em>Type</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Type</em>' containment reference.
	 * @see #getType()
	 * @generated
	 */
	void setType(Type value);

	/**
	 * Returns the value of the '<em><b>Hlinitial Marking</b></em>' containment
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.HLMarking#getContainerPlace
	 * <em>Container Place</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Hlinitial Marking</em>' containment reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Hlinitial Marking</em>' containment
	 *         reference.
	 * @see #setHlinitialMarking(HLMarking)
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage#getPlace_HlinitialMarking()
	 * @see fr.lip6.move.pnml.pthlpng.hlcorestructure.HLMarking#getContainerPlace
	 * @model opposite="containerPlace" containment="true"
	 *        annotation="http://www.pnml.org/models/ToPNML kind='follow'"
	 * @generated
	 */
	HLMarking getHlinitialMarking();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.Place#getHlinitialMarking
	 * <em>Hlinitial Marking</em>}' containment reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Hlinitial Marking</em>' containment
	 *            reference.
	 * @see #getHlinitialMarking()
	 * @generated
	 */
	void setHlinitialMarking(HLMarking value);

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML();

	/**
	 * set values to conform PNML document
	 */
	public void fromPNML(OMElement subRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	// public void idRefHang(java.util.ArrayList<Object> oList);

	public boolean validateOCL(DiagnosticChain diagnostics);
} // Place
