/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id ggiffo, Mon Sep 08 14:31:27 CEST 2008$
 */
package fr.lip6.move.pnml.pthlpng.hlcorestructure.hlapi;

import fr.lip6.move.pnml.pthlpng.hlcorestructure.LineStyle;

public enum LineStyleHLAPI {
	SOLID("SOLID"), DASH("DASH"), DOT("DOT");

	private final LineStyle item;

	private LineStyleHLAPI(String name) {
		this.item = LineStyle.get(name);
	}

	/**
	 * Return one HLAPI enum (used for tests).
	 * 
	 * @return one of the enum, null if the int is "out of bounds"
	 */
	public static LineStyleHLAPI get(int num) {

		if (num == 0) {
			return SOLID;
		}

		if (num == 1) {
			return DASH;
		}

		if (num == 2) {
			return DOT;
		}

		return null;
	}

	public LineStyle getContainedItem() {
		return item;
	}

}