/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pthlpng.hlcorestructure.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.lip6.move.pnml.pthlpng.hlcorestructure.Annotation;
import fr.lip6.move.pnml.pthlpng.hlcorestructure.AnnotationGraphics;
import fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Annotation</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.hlcorestructure.impl.AnnotationImpl#getAnnotationgraphics
 * <em>Annotationgraphics</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class AnnotationImpl extends LabelImpl implements Annotation {
	/**
	 * The cached value of the '{@link #getAnnotationgraphics()
	 * <em>Annotationgraphics</em>}' containment reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getAnnotationgraphics()
	 * @generated
	 * @ordered
	 */
	protected AnnotationGraphics annotationgraphics;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AnnotationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return HlcorestructurePackage.Literals.ANNOTATION;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AnnotationGraphics getAnnotationgraphics() {
		return annotationgraphics;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetAnnotationgraphics(
			AnnotationGraphics newAnnotationgraphics, NotificationChain msgs) {
		AnnotationGraphics oldAnnotationgraphics = annotationgraphics;
		annotationgraphics = newAnnotationgraphics;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS,
					oldAnnotationgraphics, newAnnotationgraphics);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAnnotationgraphics(AnnotationGraphics newAnnotationgraphics) {
		if (newAnnotationgraphics != annotationgraphics) {
			NotificationChain msgs = null;
			if (annotationgraphics != null)
				msgs = ((InternalEObject) annotationgraphics)
						.eInverseRemove(
								this,
								HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION,
								AnnotationGraphics.class, msgs);
			if (newAnnotationgraphics != null)
				msgs = ((InternalEObject) newAnnotationgraphics)
						.eInverseAdd(
								this,
								HlcorestructurePackage.ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION,
								AnnotationGraphics.class, msgs);
			msgs = basicSetAnnotationgraphics(newAnnotationgraphics, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS,
					newAnnotationgraphics, newAnnotationgraphics));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS:
			if (annotationgraphics != null)
				msgs = ((InternalEObject) annotationgraphics)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS,
								null, msgs);
			return basicSetAnnotationgraphics((AnnotationGraphics) otherEnd,
					msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS:
			return basicSetAnnotationgraphics(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS:
			return getAnnotationgraphics();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS:
			setAnnotationgraphics((AnnotationGraphics) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS:
			setAnnotationgraphics((AnnotationGraphics) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case HlcorestructurePackage.ANNOTATION__ANNOTATIONGRAPHICS:
			return annotationgraphics != null;
		}
		return super.eIsSet(featureID);
	}

	public abstract boolean validateOCL(DiagnosticChain diagnostics);
} // AnnotationImpl
