/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pthlpng.partitions;

import java.util.List;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.pthlpng.terms.Sort;
import fr.lip6.move.pnml.pthlpng.terms.SortDecl;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Partition</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.pthlpng.partitions.Partition#getDef <em>Def
 * </em>}</li>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.partitions.Partition#getPartitionelements
 * <em>Partitionelements</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.pthlpng.partitions.PartitionsPackage#getPartition()
 * @model 
 *        annotation="http://www.pnml.org/models/ToPNML tag='partition' kind='son'"
 * @generated
 */
public interface Partition extends SortDecl {
	/**
	 * Returns the value of the '<em><b>Def</b></em>' containment reference. It
	 * is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.pthlpng.terms.Sort#getContainerPartition
	 * <em>Container Partition</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Def</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Def</em>' containment reference.
	 * @see #setDef(Sort)
	 * @see fr.lip6.move.pnml.pthlpng.partitions.PartitionsPackage#getPartition_Def()
	 * @see fr.lip6.move.pnml.pthlpng.terms.Sort#getContainerPartition
	 * @model opposite="containerPartition" containment="true" required="true"
	 *        ordered="false"
	 *        annotation="http://www.pnml.org/models/ToPNML kind='follow'"
	 * @generated
	 */
	Sort getDef();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.pthlpng.partitions.Partition#getDef
	 * <em>Def</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Def</em>' containment reference.
	 * @see #getDef()
	 * @generated
	 */
	void setDef(Sort value);

	/**
	 * Returns the value of the '<em><b>Partitionelements</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link fr.lip6.move.pnml.pthlpng.partitions.PartitionElement}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.pthlpng.partitions.PartitionElement#getRefpartition
	 * <em>Refpartition</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Partitionelements</em>' containment reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Partitionelements</em>' containment
	 *         reference list.
	 * @see fr.lip6.move.pnml.pthlpng.partitions.PartitionsPackage#getPartition_Partitionelements()
	 * @see fr.lip6.move.pnml.pthlpng.partitions.PartitionElement#getRefpartition
	 * @model opposite="refpartition" containment="true" required="true"
	 *        annotation="http://www.pnml.org/models/ToPNML kind='follow'"
	 * @generated
	 */
	List<PartitionElement> getPartitionelements();

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML();

	/**
	 * set values to conform PNML document
	 */
	public void fromPNML(OMElement subRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	// public void idRefHang(java.util.ArrayList<Object> oList);

	public boolean validateOCL(DiagnosticChain diagnostics);
} // Partition
