/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pthlpng.partitions;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Partition Element Of</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.partitions.PartitionElementOf#getRefpartition
 * <em>Refpartition</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.pthlpng.partitions.PartitionsPackage#getPartitionElementOf()
 * @model annotation=
 *        "http://www.pnml.org/models/OCL inputOutputTypes='self.input->size() = 1'"
 *        annotation=
 *        "http://www.eclipse.org/emf/2002/Ecore constraints='inputOutputTypes'"
 *        annotation=
 *        "http://www.pnml.org/models/ToPNML tag='partitionelementof' kind='son'"
 * @generated
 */
public interface PartitionElementOf extends PartitionOperator {
	/**
	 * Returns the value of the '<em><b>Refpartition</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Refpartition</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Refpartition</em>' reference.
	 * @see #setRefpartition(Partition)
	 * @see fr.lip6.move.pnml.pthlpng.partitions.PartitionsPackage#getPartitionElementOf_Refpartition()
	 * @model required="true" annotation=
	 *        "http://www.pnml.org/models/ToPNML tag='refpartition' kind='idref'"
	 * @generated
	 */
	Partition getRefpartition();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.pthlpng.partitions.PartitionElementOf#getRefpartition
	 * <em>Refpartition</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Refpartition</em>' reference.
	 * @see #getRefpartition()
	 * @generated
	 */
	void setRefpartition(Partition value);

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML();

	/**
	 * set values to conform PNML document
	 */
	public void fromPNML(OMElement subRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	// public void idRefHang(java.util.ArrayList<Object> oList);

	public boolean validateOCL(DiagnosticChain diagnostics);
} // PartitionElementOf
