/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.pthlpng.terms.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.pthlpng.hlcorestructure.Declaration;
import fr.lip6.move.pnml.pthlpng.hlcorestructure.HlcorestructurePackage;
import fr.lip6.move.pnml.pthlpng.partitions.Partition;
import fr.lip6.move.pnml.pthlpng.partitions.PartitionElement;
import fr.lip6.move.pnml.pthlpng.partitions.impl.PartitionsFactoryImpl;
import fr.lip6.move.pnml.pthlpng.terms.Declarations;
import fr.lip6.move.pnml.pthlpng.terms.NamedOperator;
import fr.lip6.move.pnml.pthlpng.terms.NamedSort;
import fr.lip6.move.pnml.pthlpng.terms.TermsDeclaration;
import fr.lip6.move.pnml.pthlpng.terms.TermsFactory;
import fr.lip6.move.pnml.pthlpng.terms.TermsPackage;
import fr.lip6.move.pnml.pthlpng.terms.VariableDecl;
import fr.lip6.move.pnml.pthlpng.terms.util.TermsValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Declarations</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.terms.impl.DeclarationsImpl#getDeclaration
 * <em>Declaration</em>}</li>
 * <li>
 * {@link fr.lip6.move.pnml.pthlpng.terms.impl.DeclarationsImpl#getContainerDeclaration
 * <em>Container Declaration</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class DeclarationsImpl extends EObjectImpl implements Declarations {
	/**
	 * The cached value of the '{@link #getDeclaration() <em>Declaration</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDeclaration()
	 * @generated
	 * @ordered
	 */
	protected EList<TermsDeclaration> declaration;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected DeclarationsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TermsPackage.Literals.DECLARATIONS;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public List<TermsDeclaration> getDeclaration() {
		if (declaration == null) {
			declaration = new EObjectContainmentWithInverseEList<TermsDeclaration>(
					TermsDeclaration.class, this,
					TermsPackage.DECLARATIONS__DECLARATION,
					TermsPackage.TERMS_DECLARATION__CONTAINER_DECLARATIONS);
		}
		return declaration;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Declaration getContainerDeclaration() {
		if (eContainerFeatureID != TermsPackage.DECLARATIONS__CONTAINER_DECLARATION)
			return null;
		return (Declaration) eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetContainerDeclaration(
			Declaration newContainerDeclaration, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newContainerDeclaration,
				TermsPackage.DECLARATIONS__CONTAINER_DECLARATION, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setContainerDeclaration(Declaration newContainerDeclaration) {
		if (newContainerDeclaration != eInternalContainer()
				|| (eContainerFeatureID != TermsPackage.DECLARATIONS__CONTAINER_DECLARATION && newContainerDeclaration != null)) {
			if (EcoreUtil.isAncestor(this, newContainerDeclaration))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContainerDeclaration != null)
				msgs = ((InternalEObject) newContainerDeclaration).eInverseAdd(
						this, HlcorestructurePackage.DECLARATION__STRUCTURE,
						Declaration.class, msgs);
			msgs = basicSetContainerDeclaration(newContainerDeclaration, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					TermsPackage.DECLARATIONS__CONTAINER_DECLARATION,
					newContainerDeclaration, newContainerDeclaration));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case TermsPackage.DECLARATIONS__DECLARATION:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getDeclaration())
					.basicAdd(otherEnd, msgs);
		case TermsPackage.DECLARATIONS__CONTAINER_DECLARATION:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetContainerDeclaration((Declaration) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case TermsPackage.DECLARATIONS__DECLARATION:
			return ((InternalEList<?>) getDeclaration()).basicRemove(otherEnd,
					msgs);
		case TermsPackage.DECLARATIONS__CONTAINER_DECLARATION:
			return basicSetContainerDeclaration(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID) {
		case TermsPackage.DECLARATIONS__CONTAINER_DECLARATION:
			return eInternalContainer().eInverseRemove(this,
					HlcorestructurePackage.DECLARATION__STRUCTURE,
					Declaration.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case TermsPackage.DECLARATIONS__DECLARATION:
			return getDeclaration();
		case TermsPackage.DECLARATIONS__CONTAINER_DECLARATION:
			return getContainerDeclaration();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case TermsPackage.DECLARATIONS__DECLARATION:
			getDeclaration().clear();
			getDeclaration().addAll(
					(Collection<? extends TermsDeclaration>) newValue);
			return;
		case TermsPackage.DECLARATIONS__CONTAINER_DECLARATION:
			setContainerDeclaration((Declaration) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case TermsPackage.DECLARATIONS__DECLARATION:
			getDeclaration().clear();
			return;
		case TermsPackage.DECLARATIONS__CONTAINER_DECLARATION:
			setContainerDeclaration((Declaration) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case TermsPackage.DECLARATIONS__DECLARATION:
			return declaration != null && !declaration.isEmpty();
		case TermsPackage.DECLARATIONS__CONTAINER_DECLARATION:
			return getContainerDeclaration() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML() {
		// id 0
		// idref 0
		// attributes 0
		// sons 1
		// songens 0

		Boolean prettyPrintStatus = ModelRepository.getInstance()
				.isPrettyPrintActive();
		String retline = "";
		String headline = "";
		PrettyPrintData prpd = null;
		if (prettyPrintStatus) {
			retline = "\n";
			prpd = ModelRepository.getInstance().getPrettyPrintData();
			headline = prpd.getCurrentLineHeader();
		}

		StringBuffer sb = new StringBuffer();
		sb.append(headline);
		sb.append("<declarations");
		if (prettyPrintStatus) {
			headline = prpd.increaseLineHeaderLevel();
		}
		// begin attributes, id and id ref processing

		boolean haveSons = false;
		sb.append(">");
		sb.append(retline);

		// sons, follow &songen processing

		if (getDeclaration() != null) {

			java.util.List<fr.lip6.move.pnml.pthlpng.terms.TermsDeclaration> items = getDeclaration();
			for (Iterator<TermsDeclaration> iterator = items.iterator(); iterator
					.hasNext();) {
				TermsDeclaration item = (TermsDeclaration) iterator.next();

				sb.append(item.toPNML());

				haveSons = true;
			}

		}

		/****/

		if (prettyPrintStatus) {
			headline = prpd.decreaseLineHeaderLevel();
		}

		if (haveSons) {
			sb.append(headline);
			sb.append("</declarations>");
			sb.append(retline);
		} else {
			sb.delete(sb.lastIndexOf(">"), sb.length());
			sb.append("/>");
		}

		return sb.toString();
	}

	@SuppressWarnings("unchecked")
	public void fromPNML(OMElement locRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException {
		// 0
		// 0
		// 0
		// 1
		@SuppressWarnings("unused")
		TermsFactory fact = new TermsFactoryImpl();

		// processing id

		// processing idref

		// processing attributes

		// processing sons

		for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
			@SuppressWarnings("unused")
			OMElement type = (OMElement) iterator.next();

			if (type.getLocalName().equals("variabledecl")) {
				VariableDecl item;
				item = new TermsFactoryImpl().createVariableDecl();
				item.fromPNML(type, idr);

				item.setContainerDeclarations(this);

				continue;
			}// end if

			if (type.getLocalName().equals("namedsort")) {
				NamedSort item;
				item = new TermsFactoryImpl().createNamedSort();
				item.fromPNML(type, idr);

				item.setContainerDeclarations(this);

				continue;
			}// end if

			if (type.getLocalName().equals("namedoperator")) {
				NamedOperator item;
				item = new TermsFactoryImpl().createNamedOperator();
				item.fromPNML(type, idr);

				item.setContainerDeclarations(this);

				continue;
			}// end if

			if (type.getLocalName().equals("partition")) {
				Partition item;
				item = new PartitionsFactoryImpl().createPartition();
				item.fromPNML(type, idr);

				item.setContainerDeclarations(this);

				continue;
			}// end if

			if (type.getLocalName().equals("partitionelement")) {
				PartitionElement item;
				item = new PartitionsFactoryImpl().createPartitionElement();
				item.fromPNML(type, idr);

				item.setContainerDeclarations(this);

				continue;
			}// end if

		}

		// processing sonsgen

	}

	/**
	 * -
	 */
	public boolean validateOCL(DiagnosticChain diagnostics) {

		TermsValidator val = new TermsValidator();
		boolean retour = true;

		if (getDeclaration() != null) {
			java.util.List<fr.lip6.move.pnml.pthlpng.terms.TermsDeclaration> items = getDeclaration();
			for (Iterator<TermsDeclaration> iterator = items.iterator(); iterator
					.hasNext();) {
				TermsDeclaration item = (TermsDeclaration) iterator.next();
				retour &= item.validateOCL(diagnostics);
			}
		}

		retour &= val.validate(this, diagnostics, null);
		return retour;

	}
} // DeclarationsImpl
