/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.ptnet;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>CSS2 Font Style</b></em>',
 * and utility methods for working with them. <!-- end-user-doc -->
 * 
 * @see fr.lip6.move.pnml.ptnet.PtnetPackage#getCSS2FontStyle()
 * @model
 * @generated
 */
public enum CSS2FontStyle implements Enumerator {
    /**
     * The '<em><b>NORMAL</b></em>' literal object. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #NORMAL_VALUE
     * @generated
     * @ordered
     */
    NORMAL(0, "NORMAL", "normal"),

    /**
     * The '<em><b>ITALIC</b></em>' literal object. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #ITALIC_VALUE
     * @generated
     * @ordered
     */
    ITALIC(1, "ITALIC", "italic"),

    /**
     * The '<em><b>OBLIQUE</b></em>' literal object. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @see #OBLIQUE_VALUE
     * @generated
     * @ordered
     */
    OBLIQUE(2, "OBLIQUE", "oblique");

    /**
     * The '<em><b>NORMAL</b></em>' literal value. <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>NORMAL</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #NORMAL
     * @model literal="normal"
     * @generated
     * @ordered
     */
    public static final int NORMAL_VALUE = 0;

    /**
     * The '<em><b>ITALIC</b></em>' literal value. <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>ITALIC</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #ITALIC
     * @model literal="italic"
     * @generated
     * @ordered
     */
    public static final int ITALIC_VALUE = 1;

    /**
     * The '<em><b>OBLIQUE</b></em>' literal value. <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>OBLIQUE</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #OBLIQUE
     * @model literal="oblique"
     * @generated
     * @ordered
     */
    public static final int OBLIQUE_VALUE = 2;

    /**
     * An array of all the '<em><b>CSS2 Font Style</b></em>' enumerators.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private static final CSS2FontStyle[] VALUES_ARRAY = new CSS2FontStyle[] {
            NORMAL, ITALIC, OBLIQUE, };

    /**
     * A public read-only list of all the '<em><b>CSS2 Font Style</b></em>'
     * enumerators. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static final List<CSS2FontStyle> VALUES = Collections
            .unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
     * Returns the '<em><b>CSS2 Font Style</b></em>' literal with the
     * specified literal value. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static CSS2FontStyle get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            CSS2FontStyle result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>CSS2 Font Style</b></em>' literal with the
     * specified name. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static CSS2FontStyle getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            CSS2FontStyle result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>CSS2 Font Style</b></em>' literal with the
     * specified integer value. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static CSS2FontStyle get(int value) {
        switch (value) {
        case NORMAL_VALUE:
            return NORMAL;
        case ITALIC_VALUE:
            return ITALIC;
        case OBLIQUE_VALUE:
            return OBLIQUE;
        }
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private final int value;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private final String name;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private final String literal;

    /**
     * Only this class can construct instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private CSS2FontStyle(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public int getValue() {
        return value;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String getLiteral() {
        return literal;
    }

    /**
     * Returns the literal value of the enumerator, which is its string
     * representation. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public String toString() {
        return literal;
    }

} // CSS2FontStyle
