/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.ptnet;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>PT Marking</b></em>'.
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.ptnet.PTMarking#getText <em>Text</em>}</li>
 * <li>{@link fr.lip6.move.pnml.ptnet.PTMarking#getContainerPlace <em>Container Place</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.ptnet.PtnetPackage#getPTMarking()
 * @model annotation="http://www.pnml.org/models/OCL
 *        markingValueRange='self.text >= 0'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore
 *        constraints='markingValueRange'"
 *        annotation="http://www.pnml.org/models/ToPNML tag='initialMarking'
 *        kind='son'"
 * @generated
 */
public interface PTMarking extends Annotation {
    /**
     * Returns the value of the '<em><b>Text</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Text</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Text</em>' attribute.
     * @see #setText(Integer)
     * @see fr.lip6.move.pnml.ptnet.PtnetPackage#getPTMarking_Text()
     * @model dataType="fr.lip6.move.pnml.ptnet.Natural" required="true"
     *        annotation="http://www.pnml.org/models/ToPNML tag='text'
     *        kind='son'"
     * @generated
     */
    Integer getText();

    /**
     * Sets the value of the '{@link fr.lip6.move.pnml.ptnet.PTMarking#getText <em>Text</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Text</em>' attribute.
     * @see #getText()
     * @generated
     */
    void setText(Integer value);

    /**
     * Returns the value of the '<em><b>Container Place</b></em>' container
     * reference. It is bidirectional and its opposite is '{@link fr.lip6.move.pnml.ptnet.Place#getInitialMarking <em>Initial Marking</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Container Place</em>' container reference
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Container Place</em>' container
     *         reference.
     * @see #setContainerPlace(Place)
     * @see fr.lip6.move.pnml.ptnet.PtnetPackage#getPTMarking_ContainerPlace()
     * @see fr.lip6.move.pnml.ptnet.Place#getInitialMarking
     * @model opposite="initialMarking" transient="false"
     * @generated
     */
    Place getContainerPlace();

    /**
     * Sets the value of the '{@link fr.lip6.move.pnml.ptnet.PTMarking#getContainerPlace <em>Container Place</em>}'
     * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Container Place</em>' container
     *            reference.
     * @see #getContainerPlace()
     * @generated
     */
    void setContainerPlace(Place value);

    /**
     * Return the string containing the pnml output
     */
    public String toPNML();

    /**
     * set values to conform PNML document
     */
    public void fromPNML(OMElement subRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException;

    public boolean validateOCL(DiagnosticChain diagnostics);
} // PTMarking
