/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.ptnet;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * 
 * @see fr.lip6.move.pnml.ptnet.PtnetPackage
 * @generated
 */
public interface PtnetFactory extends EFactory {
    /**
     * The singleton instance of the factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    PtnetFactory eINSTANCE = fr.lip6.move.pnml.ptnet.impl.PtnetFactoryImpl
            .init();

    /**
     * Returns a new object of class '<em>PT Marking</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>PT Marking</em>'.
     * @generated
     */
    PTMarking createPTMarking();

    /**
     * Returns a new object of class '<em>PT Arc Annotation</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>PT Arc Annotation</em>'.
     * @generated
     */
    PTArcAnnotation createPTArcAnnotation();

    /**
     * Returns a new object of class '<em>Petri Net Doc</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Petri Net Doc</em>'.
     * @generated
     */
    PetriNetDoc createPetriNetDoc();

    /**
     * Returns a new object of class '<em>Petri Net</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Petri Net</em>'.
     * @generated
     */
    PetriNet createPetriNet();

    /**
     * Returns a new object of class '<em>Page</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Page</em>'.
     * @generated
     */
    Page createPage();

    /**
     * Returns a new object of class '<em>Name</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Name</em>'.
     * @generated
     */
    Name createName();

    /**
     * Returns a new object of class '<em>Tool Info</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Tool Info</em>'.
     * @generated
     */
    ToolInfo createToolInfo();

    /**
     * Returns a new object of class '<em>Node Graphics</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Node Graphics</em>'.
     * @generated
     */
    NodeGraphics createNodeGraphics();

    /**
     * Returns a new object of class '<em>Position</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Position</em>'.
     * @generated
     */
    Position createPosition();

    /**
     * Returns a new object of class '<em>Offset</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Offset</em>'.
     * @generated
     */
    Offset createOffset();

    /**
     * Returns a new object of class '<em>Dimension</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Dimension</em>'.
     * @generated
     */
    Dimension createDimension();

    /**
     * Returns a new object of class '<em>Annotation Graphics</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Annotation Graphics</em>'.
     * @generated
     */
    AnnotationGraphics createAnnotationGraphics();

    /**
     * Returns a new object of class '<em>Fill</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Fill</em>'.
     * @generated
     */
    Fill createFill();

    /**
     * Returns a new object of class '<em>Line</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Line</em>'.
     * @generated
     */
    Line createLine();

    /**
     * Returns a new object of class '<em>Arc Graphics</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Arc Graphics</em>'.
     * @generated
     */
    ArcGraphics createArcGraphics();

    /**
     * Returns a new object of class '<em>Arc</em>'. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Arc</em>'.
     * @generated
     */
    Arc createArc();

    /**
     * Returns a new object of class '<em>Font</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Font</em>'.
     * @generated
     */
    Font createFont();

    /**
     * Returns a new object of class '<em>Place</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Place</em>'.
     * @generated
     */
    Place createPlace();

    /**
     * Returns a new object of class '<em>Ref Transition</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Ref Transition</em>'.
     * @generated
     */
    RefTransition createRefTransition();

    /**
     * Returns a new object of class '<em>Transition</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Transition</em>'.
     * @generated
     */
    Transition createTransition();

    /**
     * Returns a new object of class '<em>Ref Place</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Ref Place</em>'.
     * @generated
     */
    RefPlace createRefPlace();

    /**
     * Returns the package supported by this factory. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the package supported by this factory.
     * @generated
     */
    PtnetPackage getPtnetPackage();

} // PtnetFactory
