/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id ggiffo, Wed Sep 10 13:41:08 CEST 2008$
 */
package fr.lip6.move.pnml.ptnet.hlapi;

import fr.lip6.move.pnml.framework.hlapi.HLAPIClass;
import fr.lip6.move.pnml.ptnet.ToolInfo;

public interface AnyObjectHLAPI extends HLAPIClass {

    // getters giving LLAPI object

    /**
     * 
     */
    public ToolInfo getContainerToolInfo();

    // getters giving HLAPI object

    /**
     * This accessor automaticaly encapsulate an element of the current object.
     * WARNING : this creates a new object in memory.
     */

    public ToolInfoHLAPI getContainerToolInfoHLAPI();

    // setters (including container setter if aviable)

    // setters/remover for lists.

    // equals method
    public boolean equals(Object item);

}