/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.ptnet.impl;

import java.util.Iterator;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.ptnet.AnnotationGraphics;
import fr.lip6.move.pnml.ptnet.Arc;
import fr.lip6.move.pnml.ptnet.PTArcAnnotation;
import fr.lip6.move.pnml.ptnet.PtnetFactory;
import fr.lip6.move.pnml.ptnet.PtnetPackage;
import fr.lip6.move.pnml.ptnet.ToolInfo;
import fr.lip6.move.pnml.ptnet.util.PtnetValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>PT Arc Annotation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.ptnet.impl.PTArcAnnotationImpl#getText <em>Text</em>}</li>
 * <li>{@link fr.lip6.move.pnml.ptnet.impl.PTArcAnnotationImpl#getContainerArc <em>Container Arc</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class PTArcAnnotationImpl extends AnnotationImpl implements
        PTArcAnnotation {
    /**
     * The default value of the '{@link #getText() <em>Text</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getText()
     * @generated
     * @ordered
     */
    protected static final Integer TEXT_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getText() <em>Text</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getText()
     * @generated
     * @ordered
     */
    protected Integer text = TEXT_EDEFAULT;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected PTArcAnnotationImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return PtnetPackage.Literals.PT_ARC_ANNOTATION;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Integer getText() {
        return text;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setText(Integer newText) {
        Integer oldText = text;
        text = newText;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PtnetPackage.PT_ARC_ANNOTATION__TEXT, oldText, text));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Arc getContainerArc() {
        if (eContainerFeatureID != PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC)
            return null;
        return (Arc) eContainer();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetContainerArc(Arc newContainerArc,
            NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject) newContainerArc,
                PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainerArc(Arc newContainerArc) {
        if (newContainerArc != eInternalContainer()
                || (eContainerFeatureID != PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC && newContainerArc != null)) {
            if (EcoreUtil.isAncestor(this, newContainerArc))
                throw new IllegalArgumentException(
                        "Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainerArc != null)
                msgs = ((InternalEObject) newContainerArc).eInverseAdd(this,
                        PtnetPackage.ARC__INSCRIPTION, Arc.class, msgs);
            msgs = basicSetContainerArc(newContainerArc, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC,
                    newContainerArc, newContainerArc));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC:
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            return basicSetContainerArc((Arc) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC:
            return basicSetContainerArc(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(
            NotificationChain msgs) {
        switch (eContainerFeatureID) {
        case PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC:
            return eInternalContainer().eInverseRemove(this,
                    PtnetPackage.ARC__INSCRIPTION, Arc.class, msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case PtnetPackage.PT_ARC_ANNOTATION__TEXT:
            return getText();
        case PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC:
            return getContainerArc();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case PtnetPackage.PT_ARC_ANNOTATION__TEXT:
            setText((Integer) newValue);
            return;
        case PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC:
            setContainerArc((Arc) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case PtnetPackage.PT_ARC_ANNOTATION__TEXT:
            setText(TEXT_EDEFAULT);
            return;
        case PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC:
            setContainerArc((Arc) null);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case PtnetPackage.PT_ARC_ANNOTATION__TEXT:
            return TEXT_EDEFAULT == null ? text != null : !TEXT_EDEFAULT
                    .equals(text);
        case PtnetPackage.PT_ARC_ANNOTATION__CONTAINER_ARC:
            return getContainerArc() != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (text: ");
        result.append(text);
        result.append(')');
        return result.toString();
    }

    /**
     * Return the string containing the pnml output
     */
    public String toPNML() {
        // id 0
        // idref 0
        // attributes 0
        // sons 3

        Boolean prettyPrintStatus = ModelRepository.getInstance()
                .isPrettyPrintActive();
        String retline = "";
        String headline = "";
        PrettyPrintData prpd = null;
        if (prettyPrintStatus) {
            retline = "\n";
            prpd = ModelRepository.getInstance().getPrettyPrintData();
            headline = prpd.getCurrentLineHeader();
        }

        StringBuffer sb = new StringBuffer();
        sb.append(headline);
        sb.append("<inscription");
        if (prettyPrintStatus) {
            headline = prpd.increaseLineHeaderLevel();
        }
        // begin attributes, id and id ref processing

        boolean haveSons = false;
        sb.append(">");
        sb.append(retline);

        // sons, follow processing

        if (getToolspecifics() != null) {

            java.util.List<fr.lip6.move.pnml.ptnet.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();

                sb.append(item.toPNML());

                haveSons = true;
            }

        }

        if (getAnnotationgraphics() != null) {

            String top = getAnnotationgraphics().toPNML();
            if (!top.equals("")) {

                sb.append(top);

                haveSons = true;
            }

        }

        if (getText() != null) {

            sb.append(headline);
            sb.append("<");
            sb.append("text");
            sb.append(">");
            sb.append(getText().toString());
            sb.append("</");
            sb.append("text");
            sb.append(">");
            sb.append(retline);

            haveSons = true;

        }

        /** * */

        if (prettyPrintStatus) {
            headline = prpd.decreaseLineHeaderLevel();
        }

        if (haveSons) {
            sb.append(headline);
            sb.append("</inscription>");
            sb.append(retline);
        } else {
            sb.delete(sb.lastIndexOf(">"), sb.length());
            sb.append("/>");
        }

        return sb.toString();
    }

    @SuppressWarnings("unchecked")
    public void fromPNML(OMElement locRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException {
        // 0
        // 0
        // 0
        // 3
        @SuppressWarnings("unused")
        PtnetFactory fact = new PtnetFactoryImpl();

        // processing id

        // processing idref

        // processing attributes

        // processing sons

        for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
            @SuppressWarnings("unused")
            OMElement type = (OMElement) iterator.next();

            if (type.getLocalName().equals("toolspecific")) {
                ToolInfo item;
                item = new PtnetFactoryImpl().createToolInfo();
                item.fromPNML(type, idr);

                item.setContainerLabel(this);

                continue;
            }// end if

            if (type.getLocalName().equals("graphics")) {
                AnnotationGraphics item;
                item = new PtnetFactoryImpl().createAnnotationGraphics();
                item.fromPNML(type, idr);

                item.setContainerAnnotation(this);

                continue;
            }// end if

            if (type.getLocalName().equals("text")) {
                this.setText(new java.lang.Integer(type.getText()));
            }

        }

    }

    /**
     * -
     */
    public boolean validateOCL(DiagnosticChain diagnostics) {

        PtnetValidator val = new PtnetValidator();
        boolean retour = true;

        if (getToolspecifics() != null) {
            java.util.List<fr.lip6.move.pnml.ptnet.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();
                retour &= item.validateOCL(diagnostics);
            }
        }

        if (getAnnotationgraphics() != null) {
            retour &= getAnnotationgraphics().validateOCL(diagnostics);
        }

        retour &= val.validate(this, diagnostics, null);
        return retour;

    }
} // PTArcAnnotationImpl
