/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.ptnet.impl;

import java.util.Iterator;

import javax.xml.namespace.QName;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.ptnet.Name;
import fr.lip6.move.pnml.ptnet.NodeGraphics;
import fr.lip6.move.pnml.ptnet.PTMarking;
import fr.lip6.move.pnml.ptnet.Place;
import fr.lip6.move.pnml.ptnet.PtnetFactory;
import fr.lip6.move.pnml.ptnet.PtnetPackage;
import fr.lip6.move.pnml.ptnet.ToolInfo;
import fr.lip6.move.pnml.ptnet.util.PtnetValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Place</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.ptnet.impl.PlaceImpl#getInitialMarking <em>Initial Marking</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class PlaceImpl extends PlaceNodeImpl implements Place {
    /**
     * The cached value of the '{@link #getInitialMarking() <em>Initial Marking</em>}'
     * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInitialMarking()
     * @generated
     * @ordered
     */
    protected PTMarking initialMarking;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected PlaceImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return PtnetPackage.Literals.PLACE;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public PTMarking getInitialMarking() {
        return initialMarking;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetInitialMarking(
            PTMarking newInitialMarking, NotificationChain msgs) {
        PTMarking oldInitialMarking = initialMarking;
        initialMarking = newInitialMarking;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this,
                    Notification.SET, PtnetPackage.PLACE__INITIAL_MARKING,
                    oldInitialMarking, newInitialMarking);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setInitialMarking(PTMarking newInitialMarking) {
        if (newInitialMarking != initialMarking) {
            NotificationChain msgs = null;
            if (initialMarking != null)
                msgs = ((InternalEObject) initialMarking).eInverseRemove(this,
                        PtnetPackage.PT_MARKING__CONTAINER_PLACE,
                        PTMarking.class, msgs);
            if (newInitialMarking != null)
                msgs = ((InternalEObject) newInitialMarking).eInverseAdd(this,
                        PtnetPackage.PT_MARKING__CONTAINER_PLACE,
                        PTMarking.class, msgs);
            msgs = basicSetInitialMarking(newInitialMarking, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    PtnetPackage.PLACE__INITIAL_MARKING, newInitialMarking,
                    newInitialMarking));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PtnetPackage.PLACE__INITIAL_MARKING:
            if (initialMarking != null)
                msgs = ((InternalEObject) initialMarking).eInverseRemove(this,
                        EOPPOSITE_FEATURE_BASE
                                - PtnetPackage.PLACE__INITIAL_MARKING, null,
                        msgs);
            return basicSetInitialMarking((PTMarking) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
        switch (featureID) {
        case PtnetPackage.PLACE__INITIAL_MARKING:
            return basicSetInitialMarking(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case PtnetPackage.PLACE__INITIAL_MARKING:
            return getInitialMarking();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case PtnetPackage.PLACE__INITIAL_MARKING:
            setInitialMarking((PTMarking) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case PtnetPackage.PLACE__INITIAL_MARKING:
            setInitialMarking((PTMarking) null);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case PtnetPackage.PLACE__INITIAL_MARKING:
            return initialMarking != null;
        }
        return super.eIsSet(featureID);
    }

    // TODO this element (InArcs) seems not to have any ToPNML associated tag.
    // This is maybe a mistake ?

    // TODO this element (OutArcs) seems not to have any ToPNML associated tag.
    // This is maybe a mistake ?

    // TODO this element (referencingPlaces) seems not to have any ToPNML
    // associated tag.
    // This is maybe a mistake ?

    /**
     * Return the string containing the pnml output
     */
    public String toPNML() {
        // id 1
        // idref 0
        // attributes 0
        // sons 4

        Boolean prettyPrintStatus = ModelRepository.getInstance()
                .isPrettyPrintActive();
        String retline = "";
        String headline = "";
        PrettyPrintData prpd = null;
        if (prettyPrintStatus) {
            retline = "\n";
            prpd = ModelRepository.getInstance().getPrettyPrintData();
            headline = prpd.getCurrentLineHeader();
        }

        StringBuffer sb = new StringBuffer();
        sb.append(headline);
        sb.append("<place");
        if (prettyPrintStatus) {
            headline = prpd.increaseLineHeaderLevel();
        }
        // begin attributes, id and id ref processing

        if (getId() != null) {
            sb.append(" id");
            sb.append("=\"");
            sb.append(getId());
            sb.append("\"");
        }

        boolean haveSons = false;
        sb.append(">");
        sb.append(retline);

        // sons, follow processing

        if (getName() != null) {

            String top = getName().toPNML();
            if (!top.equals("")) {

                sb.append(top);

                haveSons = true;
            }

        }

        if (getToolspecifics() != null) {

            java.util.List<fr.lip6.move.pnml.ptnet.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();

                sb.append(item.toPNML());

                haveSons = true;
            }

        }

        if (getNodegraphics() != null) {

            String top = getNodegraphics().toPNML();
            if (!top.equals("")) {

                sb.append(top);

                haveSons = true;
            }

        }

        if (getInitialMarking() != null) {

            String top = getInitialMarking().toPNML();
            if (!top.equals("")) {

                sb.append(top);

                haveSons = true;
            }

        }

        /** * */

        if (prettyPrintStatus) {
            headline = prpd.decreaseLineHeaderLevel();
        }

        if (haveSons) {
            sb.append(headline);
            sb.append("</place>");
            sb.append(retline);
        } else {
            sb.delete(sb.lastIndexOf(">"), sb.length());
            sb.append("/>");
        }

        return sb.toString();
    }

    @SuppressWarnings("unchecked")
    public void fromPNML(OMElement locRoot, IdRefLinker idr)
            throws InnerBuildException, InvalidIDException,
            VoidRepositoryException {
        // 1
        // 0
        // 0
        // 4
        @SuppressWarnings("unused")
        PtnetFactory fact = new PtnetFactoryImpl();

        // processing id

        if (locRoot.getAttributeValue(new QName("id")) != null) {
            this.setId(new java.lang.String(locRoot
                    .getAttributeValue(new QName("id"))));
            ModelRepository.getInstance().getCurrentIdRepository().checkId(
                    new java.lang.String(locRoot.getAttributeValue(new QName(
                            "id"))).toString(), (Object) this);
        }

        // processing idref

        // processing attributes

        // processing sons

        for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
            @SuppressWarnings("unused")
            OMElement type = (OMElement) iterator.next();

            if (type.getLocalName().equals("name")) {
                Name item;
                item = new PtnetFactoryImpl().createName();
                item.fromPNML(type, idr);

                item.setContainerNamePnObject(this);

                continue;
            }// end if

            if (type.getLocalName().equals("toolspecific")) {
                ToolInfo item;
                item = new PtnetFactoryImpl().createToolInfo();
                item.fromPNML(type, idr);

                item.setContainerPnObject(this);

                continue;
            }// end if

            if (type.getLocalName().equals("graphics")) {
                NodeGraphics item;
                item = new PtnetFactoryImpl().createNodeGraphics();
                item.fromPNML(type, idr);

                item.setContainerNode(this);

                continue;
            }// end if

            if (type.getLocalName().equals("initialMarking")) {
                PTMarking item;
                item = new PtnetFactoryImpl().createPTMarking();
                item.fromPNML(type, idr);

                item.setContainerPlace(this);

                continue;
            }// end if

        }

    }

    /**
     * -
     */
    public boolean validateOCL(DiagnosticChain diagnostics) {

        PtnetValidator val = new PtnetValidator();
        boolean retour = true;

        if (getName() != null) {
            retour &= getName().validateOCL(diagnostics);
        }

        if (getToolspecifics() != null) {
            java.util.List<fr.lip6.move.pnml.ptnet.ToolInfo> items = getToolspecifics();
            for (Iterator<ToolInfo> iterator = items.iterator(); iterator
                    .hasNext();) {
                ToolInfo item = (ToolInfo) iterator.next();
                retour &= item.validateOCL(diagnostics);
            }
        }

        if (getNodegraphics() != null) {
            retour &= getNodegraphics().validateOCL(diagnostics);
        }

        if (getInitialMarking() != null) {
            retour &= getInitialMarking().validateOCL(diagnostics);
        }

        retour &= val.validate(this, diagnostics, null);
        return retour;

    }
} // PlaceImpl
