/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.ptnet.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import fr.lip6.move.pnml.ptnet.Annotation;
import fr.lip6.move.pnml.ptnet.AnnotationGraphics;
import fr.lip6.move.pnml.ptnet.AnyObject;
import fr.lip6.move.pnml.ptnet.Arc;
import fr.lip6.move.pnml.ptnet.ArcGraphics;
import fr.lip6.move.pnml.ptnet.Attribute;
import fr.lip6.move.pnml.ptnet.Coordinate;
import fr.lip6.move.pnml.ptnet.Dimension;
import fr.lip6.move.pnml.ptnet.Fill;
import fr.lip6.move.pnml.ptnet.Font;
import fr.lip6.move.pnml.ptnet.Graphics;
import fr.lip6.move.pnml.ptnet.Label;
import fr.lip6.move.pnml.ptnet.Line;
import fr.lip6.move.pnml.ptnet.Name;
import fr.lip6.move.pnml.ptnet.Node;
import fr.lip6.move.pnml.ptnet.NodeGraphics;
import fr.lip6.move.pnml.ptnet.Offset;
import fr.lip6.move.pnml.ptnet.PTArcAnnotation;
import fr.lip6.move.pnml.ptnet.PTMarking;
import fr.lip6.move.pnml.ptnet.Page;
import fr.lip6.move.pnml.ptnet.PetriNet;
import fr.lip6.move.pnml.ptnet.PetriNetDoc;
import fr.lip6.move.pnml.ptnet.Place;
import fr.lip6.move.pnml.ptnet.PlaceNode;
import fr.lip6.move.pnml.ptnet.PnObject;
import fr.lip6.move.pnml.ptnet.Position;
import fr.lip6.move.pnml.ptnet.PtnetPackage;
import fr.lip6.move.pnml.ptnet.RefPlace;
import fr.lip6.move.pnml.ptnet.RefTransition;
import fr.lip6.move.pnml.ptnet.ToolInfo;
import fr.lip6.move.pnml.ptnet.Transition;
import fr.lip6.move.pnml.ptnet.TransitionNode;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It
 * provides an adapter <code>createXXX</code> method for each class of the
 * model. <!-- end-user-doc -->
 * 
 * @see fr.lip6.move.pnml.ptnet.PtnetPackage
 * @generated
 */
public class PtnetAdapterFactory extends AdapterFactoryImpl {
    /**
     * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected static PtnetPackage modelPackage;

    /**
     * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    public PtnetAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = PtnetPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc --> This implementation returns <code>true</code>
     * if the object is either the model's package or is an instance object of
     * the model. <!-- end-user-doc -->
     * 
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject) object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch the delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected PtnetSwitch<Adapter> modelSwitch = new PtnetSwitch<Adapter>() {
        @Override
        public Adapter casePTMarking(PTMarking object) {
            return createPTMarkingAdapter();
        }

        @Override
        public Adapter casePTArcAnnotation(PTArcAnnotation object) {
            return createPTArcAnnotationAdapter();
        }

        @Override
        public Adapter casePetriNetDoc(PetriNetDoc object) {
            return createPetriNetDocAdapter();
        }

        @Override
        public Adapter casePetriNet(PetriNet object) {
            return createPetriNetAdapter();
        }

        @Override
        public Adapter casePage(Page object) {
            return createPageAdapter();
        }

        @Override
        public Adapter casePnObject(PnObject object) {
            return createPnObjectAdapter();
        }

        @Override
        public Adapter caseName(Name object) {
            return createNameAdapter();
        }

        @Override
        public Adapter caseToolInfo(ToolInfo object) {
            return createToolInfoAdapter();
        }

        @Override
        public Adapter caseLabel(Label object) {
            return createLabelAdapter();
        }

        @Override
        public Adapter caseNodeGraphics(NodeGraphics object) {
            return createNodeGraphicsAdapter();
        }

        @Override
        public Adapter caseGraphics(Graphics object) {
            return createGraphicsAdapter();
        }

        @Override
        public Adapter caseCoordinate(Coordinate object) {
            return createCoordinateAdapter();
        }

        @Override
        public Adapter casePosition(Position object) {
            return createPositionAdapter();
        }

        @Override
        public Adapter caseOffset(Offset object) {
            return createOffsetAdapter();
        }

        @Override
        public Adapter caseDimension(Dimension object) {
            return createDimensionAdapter();
        }

        @Override
        public Adapter caseAnnotationGraphics(AnnotationGraphics object) {
            return createAnnotationGraphicsAdapter();
        }

        @Override
        public Adapter caseFill(Fill object) {
            return createFillAdapter();
        }

        @Override
        public Adapter caseLine(Line object) {
            return createLineAdapter();
        }

        @Override
        public Adapter caseArcGraphics(ArcGraphics object) {
            return createArcGraphicsAdapter();
        }

        @Override
        public Adapter caseArc(Arc object) {
            return createArcAdapter();
        }

        @Override
        public Adapter caseNode(Node object) {
            return createNodeAdapter();
        }

        @Override
        public Adapter caseFont(Font object) {
            return createFontAdapter();
        }

        @Override
        public Adapter casePlaceNode(PlaceNode object) {
            return createPlaceNodeAdapter();
        }

        @Override
        public Adapter caseTransitionNode(TransitionNode object) {
            return createTransitionNodeAdapter();
        }

        @Override
        public Adapter casePlace(Place object) {
            return createPlaceAdapter();
        }

        @Override
        public Adapter caseRefTransition(RefTransition object) {
            return createRefTransitionAdapter();
        }

        @Override
        public Adapter caseTransition(Transition object) {
            return createTransitionAdapter();
        }

        @Override
        public Adapter caseRefPlace(RefPlace object) {
            return createRefPlaceAdapter();
        }

        @Override
        public Adapter caseAttribute(Attribute object) {
            return createAttributeAdapter();
        }

        @Override
        public Adapter caseAnnotation(Annotation object) {
            return createAnnotationAdapter();
        }

        @Override
        public Adapter caseAnyObject(AnyObject object) {
            return createAnyObjectAdapter();
        }

        @Override
        public Adapter defaultCase(EObject object) {
            return createEObjectAdapter();
        }
    };

    /**
     * Creates an adapter for the <code>target</code>. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @param target
     *            the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    @Override
    public Adapter createAdapter(Notifier target) {
        return modelSwitch.doSwitch((EObject) target);
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.PTMarking <em>PT Marking</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.PTMarking
     * @generated
     */
    public Adapter createPTMarkingAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.PTArcAnnotation <em>PT Arc Annotation</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.PTArcAnnotation
     * @generated
     */
    public Adapter createPTArcAnnotationAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.PetriNetDoc <em>Petri Net Doc</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.PetriNetDoc
     * @generated
     */
    public Adapter createPetriNetDocAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.PetriNet <em>Petri Net</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.PetriNet
     * @generated
     */
    public Adapter createPetriNetAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Page <em>Page</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Page
     * @generated
     */
    public Adapter createPageAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.PnObject <em>Pn Object</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.PnObject
     * @generated
     */
    public Adapter createPnObjectAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Name <em>Name</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Name
     * @generated
     */
    public Adapter createNameAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.ToolInfo <em>Tool Info</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.ToolInfo
     * @generated
     */
    public Adapter createToolInfoAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Label <em>Label</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Label
     * @generated
     */
    public Adapter createLabelAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.NodeGraphics <em>Node Graphics</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.NodeGraphics
     * @generated
     */
    public Adapter createNodeGraphicsAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Graphics <em>Graphics</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Graphics
     * @generated
     */
    public Adapter createGraphicsAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Coordinate <em>Coordinate</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Coordinate
     * @generated
     */
    public Adapter createCoordinateAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Position <em>Position</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Position
     * @generated
     */
    public Adapter createPositionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Offset <em>Offset</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Offset
     * @generated
     */
    public Adapter createOffsetAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Dimension <em>Dimension</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Dimension
     * @generated
     */
    public Adapter createDimensionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.AnnotationGraphics <em>Annotation Graphics</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.AnnotationGraphics
     * @generated
     */
    public Adapter createAnnotationGraphicsAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Fill <em>Fill</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Fill
     * @generated
     */
    public Adapter createFillAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Line <em>Line</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Line
     * @generated
     */
    public Adapter createLineAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.ArcGraphics <em>Arc Graphics</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.ArcGraphics
     * @generated
     */
    public Adapter createArcGraphicsAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Arc <em>Arc</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Arc
     * @generated
     */
    public Adapter createArcAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Node <em>Node</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Node
     * @generated
     */
    public Adapter createNodeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Font <em>Font</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Font
     * @generated
     */
    public Adapter createFontAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.PlaceNode <em>Place Node</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.PlaceNode
     * @generated
     */
    public Adapter createPlaceNodeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.TransitionNode <em>Transition Node</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.TransitionNode
     * @generated
     */
    public Adapter createTransitionNodeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Place <em>Place</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Place
     * @generated
     */
    public Adapter createPlaceAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.RefTransition <em>Ref Transition</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.RefTransition
     * @generated
     */
    public Adapter createRefTransitionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Transition <em>Transition</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Transition
     * @generated
     */
    public Adapter createTransitionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.RefPlace <em>Ref Place</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.RefPlace
     * @generated
     */
    public Adapter createRefPlaceAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Attribute <em>Attribute</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Attribute
     * @generated
     */
    public Adapter createAttributeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.Annotation <em>Annotation</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.Annotation
     * @generated
     */
    public Adapter createAnnotationAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link fr.lip6.move.pnml.ptnet.AnyObject <em>Any Object</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see fr.lip6.move.pnml.ptnet.AnyObject
     * @generated
     */
    public Adapter createAnyObjectAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for the default case. <!-- begin-user-doc --> This
     * default implementation returns null. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter() {
        return null;
    }

} // PtnetAdapterFactory
