/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.symmetricnet.booleans;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.symmetricnet.terms.Operator;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Equality</b></em>'. <!-- end-user-doc -->
 * 
 * 
 * @see fr.lip6.move.pnml.symmetricnet.booleans.BooleansPackage#getEquality()
 * @model annotation="http://www.pnml.org/models/OCL
 *        inputOutputTypes='self.input.size() >= 2 and self.input->forAll{c, d |
 *        c.oclIsTypeOf(d) or d.oclIsTypeOf(c)} and
 *        self.output.oclIsKindOf(Bool)'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore
 *        constraints='inputOutputTypes'"
 *        annotation="http://www.pnml.org/models/ToPNML tag='equality'
 *        kind='son'"
 * @generated
 */
public interface Equality extends Operator {

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML();

	/**
	 * set values to conform PNML document
	 */
	public void fromPNML(OMElement subRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	public boolean validateOCL(DiagnosticChain diagnostics);
} // Equality
