/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.symmetricnet.hlcorestructure;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Annotation</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.Annotation#getAnnotationgraphics
 * <em>Annotationgraphics</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.symmetricnet.hlcorestructure.HlcorestructurePackage#getAnnotation()
 * @model abstract="true"
 * @generated
 */
public interface Annotation extends Label {
	/**
	 * Returns the value of the '<em><b>Annotationgraphics</b></em>' containment
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.AnnotationGraphics#getContainerAnnotation
	 * <em>Container Annotation</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Annotationgraphics</em>' containment reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Annotationgraphics</em>' containment
	 *         reference.
	 * @see #setAnnotationgraphics(AnnotationGraphics)
	 * @see fr.lip6.move.pnml.symmetricnet.hlcorestructure.HlcorestructurePackage#getAnnotation_Annotationgraphics()
	 * @see fr.lip6.move.pnml.symmetricnet.hlcorestructure.AnnotationGraphics#getContainerAnnotation
	 * @model opposite="containerAnnotation" containment="true" ordered="false"
	 *        annotation="http://www.pnml.org/models/ToPNML kind='follow'"
	 * @generated
	 */
	AnnotationGraphics getAnnotationgraphics();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.Annotation#getAnnotationgraphics
	 * <em>Annotationgraphics</em>}' containment reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Annotationgraphics</em>' containment
	 *            reference.
	 * @see #getAnnotationgraphics()
	 * @generated
	 */
	void setAnnotationgraphics(AnnotationGraphics value);

	// public abstract void idRefHang(java.util.ArrayList<Object> oList);
	public abstract String toPNML();

	public abstract void fromPNML(OMElement locRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	public abstract boolean validateOCL(DiagnosticChain diagnostics);
} // Annotation
