/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.symmetricnet.hlcorestructure.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.ModelRepository;
import fr.lip6.move.pnml.framework.utils.PrettyPrintData;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;
import fr.lip6.move.pnml.symmetricnet.hlcorestructure.Arc;
import fr.lip6.move.pnml.symmetricnet.hlcorestructure.ArcGraphics;
import fr.lip6.move.pnml.symmetricnet.hlcorestructure.HlcorestructureFactory;
import fr.lip6.move.pnml.symmetricnet.hlcorestructure.HlcorestructurePackage;
import fr.lip6.move.pnml.symmetricnet.hlcorestructure.Line;
import fr.lip6.move.pnml.symmetricnet.hlcorestructure.Position;
import fr.lip6.move.pnml.symmetricnet.hlcorestructure.util.HlcorestructureValidator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Arc Graphics</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.impl.ArcGraphicsImpl#getPositions
 * <em>Positions</em>}</li>
 * <li>
 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.impl.ArcGraphicsImpl#getLine
 * <em>Line</em>}</li>
 * <li>
 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.impl.ArcGraphicsImpl#getContainerArc
 * <em>Container Arc</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ArcGraphicsImpl extends GraphicsImpl implements ArcGraphics {
	/**
	 * The cached value of the '{@link #getPositions() <em>Positions</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getPositions()
	 * @generated
	 * @ordered
	 */
	protected EList<Position> positions;

	/**
	 * The cached value of the '{@link #getLine() <em>Line</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getLine()
	 * @generated
	 * @ordered
	 */
	protected Line line;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ArcGraphicsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return HlcorestructurePackage.Literals.ARC_GRAPHICS;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public List<Position> getPositions() {
		if (positions == null) {
			positions = new EObjectContainmentWithInverseEList<Position>(
					Position.class, this,
					HlcorestructurePackage.ARC_GRAPHICS__POSITIONS,
					HlcorestructurePackage.POSITION__CONTAINER_ARC_GRAPHICS);
		}
		return positions;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Line getLine() {
		return line;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetLine(Line newLine, NotificationChain msgs) {
		Line oldLine = line;
		line = newLine;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					HlcorestructurePackage.ARC_GRAPHICS__LINE, oldLine, newLine);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setLine(Line newLine) {
		if (newLine != line) {
			NotificationChain msgs = null;
			if (line != null)
				msgs = ((InternalEObject) line).eInverseRemove(this,
						HlcorestructurePackage.LINE__CONTAINER_ARC_GRAPHICS,
						Line.class, msgs);
			if (newLine != null)
				msgs = ((InternalEObject) newLine).eInverseAdd(this,
						HlcorestructurePackage.LINE__CONTAINER_ARC_GRAPHICS,
						Line.class, msgs);
			msgs = basicSetLine(newLine, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					HlcorestructurePackage.ARC_GRAPHICS__LINE, newLine, newLine));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Arc getContainerArc() {
		if (eContainerFeatureID != HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC)
			return null;
		return (Arc) eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetContainerArc(Arc newContainerArc,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newContainerArc,
				HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setContainerArc(Arc newContainerArc) {
		if (newContainerArc != eInternalContainer()
				|| (eContainerFeatureID != HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC && newContainerArc != null)) {
			if (EcoreUtil.isAncestor(this, newContainerArc))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContainerArc != null)
				msgs = ((InternalEObject) newContainerArc).eInverseAdd(this,
						HlcorestructurePackage.ARC__ARCGRAPHICS, Arc.class,
						msgs);
			msgs = basicSetContainerArc(newContainerArc, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC,
					newContainerArc, newContainerArc));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case HlcorestructurePackage.ARC_GRAPHICS__POSITIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getPositions())
					.basicAdd(otherEnd, msgs);
		case HlcorestructurePackage.ARC_GRAPHICS__LINE:
			if (line != null)
				msgs = ((InternalEObject) line).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE
								- HlcorestructurePackage.ARC_GRAPHICS__LINE,
						null, msgs);
			return basicSetLine((Line) otherEnd, msgs);
		case HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetContainerArc((Arc) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case HlcorestructurePackage.ARC_GRAPHICS__POSITIONS:
			return ((InternalEList<?>) getPositions()).basicRemove(otherEnd,
					msgs);
		case HlcorestructurePackage.ARC_GRAPHICS__LINE:
			return basicSetLine(null, msgs);
		case HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC:
			return basicSetContainerArc(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID) {
		case HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC:
			return eInternalContainer().eInverseRemove(this,
					HlcorestructurePackage.ARC__ARCGRAPHICS, Arc.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case HlcorestructurePackage.ARC_GRAPHICS__POSITIONS:
			return getPositions();
		case HlcorestructurePackage.ARC_GRAPHICS__LINE:
			return getLine();
		case HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC:
			return getContainerArc();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case HlcorestructurePackage.ARC_GRAPHICS__POSITIONS:
			getPositions().clear();
			getPositions().addAll((Collection<? extends Position>) newValue);
			return;
		case HlcorestructurePackage.ARC_GRAPHICS__LINE:
			setLine((Line) newValue);
			return;
		case HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC:
			setContainerArc((Arc) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case HlcorestructurePackage.ARC_GRAPHICS__POSITIONS:
			getPositions().clear();
			return;
		case HlcorestructurePackage.ARC_GRAPHICS__LINE:
			setLine((Line) null);
			return;
		case HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC:
			setContainerArc((Arc) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case HlcorestructurePackage.ARC_GRAPHICS__POSITIONS:
			return positions != null && !positions.isEmpty();
		case HlcorestructurePackage.ARC_GRAPHICS__LINE:
			return line != null;
		case HlcorestructurePackage.ARC_GRAPHICS__CONTAINER_ARC:
			return getContainerArc() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML() {
		// id 0
		// idref 0
		// attributes 0
		// sons 2

		Boolean prettyPrintStatus = ModelRepository.getInstance()
				.isPrettyPrintActive();
		String retline = "";
		String headline = "";
		PrettyPrintData prpd = null;
		if (prettyPrintStatus) {
			retline = "\n";
			prpd = ModelRepository.getInstance().getPrettyPrintData();
			headline = prpd.getCurrentLineHeader();
		}

		StringBuffer sb = new StringBuffer();
		sb.append(headline);
		sb.append("<graphics");
		if (prettyPrintStatus) {
			headline = prpd.increaseLineHeaderLevel();
		}
		// begin attributes, id and id ref processing

		boolean haveSons = false;
		sb.append(">");
		sb.append(retline);

		// sons, follow processing

		if (getPositions() != null) {

			java.util.List<fr.lip6.move.pnml.symmetricnet.hlcorestructure.Position> items = getPositions();
			for (Iterator<Position> iterator = items.iterator(); iterator
					.hasNext();) {
				Position item = (Position) iterator.next();

				sb.append(item.toPNML());

				haveSons = true;
			}

		}

		if (getLine() != null) {

			String top = getLine().toPNML();
			if (!top.equals("")) {

				sb.append(top);

				haveSons = true;
			}

		}

		/** * */

		if (prettyPrintStatus) {
			headline = prpd.decreaseLineHeaderLevel();
		}

		if (haveSons) {
			sb.append(headline);
			sb.append("</graphics>");
			sb.append(retline);
		} else {
			sb.delete(sb.lastIndexOf(">"), sb.length());
			sb.append("/>");
		}

		return sb.toString();
	}

	@SuppressWarnings("unchecked")
	public void fromPNML(OMElement locRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException {
		// 0
		// 0
		// 0
		// 2
		@SuppressWarnings("unused")
		HlcorestructureFactory fact = new HlcorestructureFactoryImpl();

		// processing id

		// processing idref

		// processing attributes

		// processing sons

		for (Iterator iterator = locRoot.getChildElements(); iterator.hasNext();) {
			@SuppressWarnings("unused")
			OMElement type = (OMElement) iterator.next();

			if (type.getLocalName().equals("position")) {
				Position item;
				item = new HlcorestructureFactoryImpl().createPosition();
				item.fromPNML(type, idr);

				item.setContainerArcGraphics(this);

				continue;
			}// end if

			if (type.getLocalName().equals("line")) {
				Line item;
				item = new HlcorestructureFactoryImpl().createLine();
				item.fromPNML(type, idr);

				item.setContainerArcGraphics(this);

				continue;
			}// end if

		}

	}

	/**
	 * -
	 */
	public boolean validateOCL(DiagnosticChain diagnostics) {

		HlcorestructureValidator val = new HlcorestructureValidator();
		boolean retour = true;

		if (getPositions() != null) {
			java.util.List<fr.lip6.move.pnml.symmetricnet.hlcorestructure.Position> items = getPositions();
			for (Iterator<Position> iterator = items.iterator(); iterator
					.hasNext();) {
				Position item = (Position) iterator.next();
				retour &= item.validateOCL(diagnostics);
			}
		}

		if (getLine() != null) {
			retour &= getLine().validateOCL(diagnostics);
		}

		retour &= val.validate(this, diagnostics, null);
		return retour;

	}
} // ArcGraphicsImpl
