/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.symmetricnet.terms;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Named Sort</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.lip6.move.pnml.symmetricnet.terms.NamedSort#getSortdef <em>
 * Sortdef</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.symmetricnet.terms.TermsPackage#getNamedSort()
 * @model annotation="http://www.pnml.org/models/OCL
 *        refSortNotMultiset='not(self.sortdef.oclIsTypeOf(MultisetSort))'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore
 *        constraints='refSortNotMultiset'"
 *        annotation="http://www.pnml.org/models/ToPNML tag='namedsort'
 *        kind='son'"
 * @generated
 */
public interface NamedSort extends SortDecl {
	/**
	 * Returns the value of the '<em><b>Sortdef</b></em>' containment reference.
	 * It is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.symmetricnet.terms.Sort#getContainerNamedSort
	 * <em>Container Named Sort</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sortdef</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Sortdef</em>' containment reference.
	 * @see #setSortdef(Sort)
	 * @see fr.lip6.move.pnml.symmetricnet.terms.TermsPackage#getNamedSort_Sortdef()
	 * @see fr.lip6.move.pnml.symmetricnet.terms.Sort#getContainerNamedSort
	 * @model opposite="containerNamedSort" containment="true" required="true"
	 *        ordered="false" annotation="http://www.pnml.org/models/ToPNML
	 *        kind='follow'"
	 * @generated
	 */
	Sort getSortdef();

	/**
	 * Sets the value of the '
	 * {@link fr.lip6.move.pnml.symmetricnet.terms.NamedSort#getSortdef
	 * <em>Sortdef</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Sortdef</em>' containment reference.
	 * @see #getSortdef()
	 * @generated
	 */
	void setSortdef(Sort value);

	/**
	 * Return the string containing the pnml output
	 */
	public String toPNML();

	/**
	 * set values to conform PNML document
	 */
	public void fromPNML(OMElement subRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	public boolean validateOCL(DiagnosticChain diagnostics);
} // NamedSort
